{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 32000,0,0}

Program Asq;

USES Dos;

TYPE
  String255 = String[ 255 ];

CONST
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  ProgramName = 'ASQ';
  Version = '3.4';
  Revision = '1996.02.18';
  InSet : String255 = '';
  InExtSet : String255 = '';
  Prompt : String255 = '';
  DoEat : Boolean = False;
  DoUC : Boolean = True;
  Silent : Boolean = False;
  Terse : Boolean = False;
  Found : Boolean = False;
  PrevMsg : String255 = '';
  MsgSeq : Byte = 0;
  Extended : Boolean = False;
  SetPos : Byte = 0;
  Done : Boolean = False;
  PromptDone : Boolean = False;
  AnyKey : Boolean = False;
  TimeOut : Integer = -1;
  NoKey = #255;
  DfltChar : Char = NoKey;
  TimeOutCnt : Integer = 0;

VAR
  ExitSave : Pointer;
  ComLine : String255;
  Loop : Integer;
  Ch : Char;
  ExtChar : Array[ 1..255 ] of Boolean;
  TimeOutStr : String[20];
  PrevSeconds : Integer;
  Result : Integer;

{-------------------------------------------------------------------------}

Procedure Stop( Msg : String255 );
  Begin
    Writeln( Msg );
    Halt( 255 );
  End;

{-------------------------------------------------------------------------}

Procedure Dly( Dur : Integer );
  Var
    Regs : Registers;
    StartSec100, EndSec100, CurrSec100 : LongInt;
  Begin
    Regs.AH := $2C;  MSDos( Regs );  { get time }
    StartSec100 :=
      Regs.CH * 360000 + Regs.CL * 6000 + Regs.DH * 100 + Regs.DL;
    Dur := Dur div 10;
    EndSec100 := StartSec100 + Dur;
    Repeat
      Regs.AH := $2C;  MSDos( Regs );  { get time }
      CurrSec100 :=
        Regs.CH * 360000 + Regs.CL * 6000 + Regs.DH * 100 + Regs.DL;
    Until ( CurrSec100 >= EndSec100 ) or ( CurrSec100 < StartSec100 );
  End;

{-------------------------------------------------------------------------}

Function Seconds : Integer;
  Var
    Regs : Registers;
    StartSec100, EndSec100, CurrSec100 : LongInt;
  Begin
    Regs.AH := $2C;  MSDos( Regs );  { get time }
    Seconds := Regs.DH;
  End;

{-------------------------------------------------------------------------}

{$F+}
Procedure TidyExit;
  Var
    ErrNum : Integer;
    ErrAddr : Pointer;
  Begin
    ExitProc := ExitSave;
    ErrNum := ExitCode;
    ErrAddr := ErrorAddr;
    If ErrNum = 255 Then
      Begin
        Writeln( '***  USER BREAK  ***' );
        Halt( 255 );
      End
    Else
      Halt( ErrNum );
  End;
{$F-}
   
{-------------------------------------------------------------------------}

Function KeyPressed : Boolean;
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := $01;  Intr( $16, Regs );
    KeyPressed := Regs.Flags and FZero = $00;
  End;

{----------------------------------------------------------------------}

FUNCTION GetKey:Char;
  VAR  Regs:Registers;
  BEGIN
    Extended := False;
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := $00;
    Intr( $16, Regs );
    If Regs.AL = 0 Then
      Begin
        Regs.AL := Regs.AH;
        Extended := True;
      End;
    GetKey := Chr( Regs.AL );
  END;

{-------------------------------------------------------------------------}

Procedure WritePrompt( Msg : String255 );
  Var
    MtchMsg, BkStr : String255;
    CntPos, TmPos, UCLp, SpclPos, DifPos : Byte;
    Regs : Registers;
  Begin
    MtchMsg := Msg;
    BkStr := '';
    For UCLp := 1 to Length( MtchMsg ) do
      MtchMsg[ UCLp ] := UpCase( MtchMsg[ UCLp ] );
    SpclPos := Pos( '$...', Msg );
    If SpclPos = 0 Then
      SpclPos := Pos( '$>>>', Msg );
    If SpclPos = 0 Then
      SpclPos := Pos( '$---', Msg );
    If SpclPos = 0 Then
      SpclPos := Pos( '$===', Msg );
    If SpclPos > 0 Then
      Begin
        Delete( Msg, SpclPos, 1 );
        Msg[ SpclPos + MsgSeq ] := ' ';
        Inc( MsgSeq );
        If MsgSeq > 2 Then MsgSeq := 0;
      End;
    TmPos := Pos( '$TIME', MtchMsg );
    If TmPos > 0 Then
      Begin
        Regs.AH := $2C;  MSDos( Regs );
        Msg[ TmPos ] := Chr( Regs.CH div 10 + 48 );
        Msg[ TmPos + 1 ] := Chr( Regs.CH mod 10 + 48 );
        Msg[ TmPos + 2 ] := ':';
        Msg[ TmPos + 3 ] := Chr( Regs.CL div 10 + 48 );
        Msg[ TmPos + 4 ] := Chr( Regs.CL mod 10 + 48 );
      End;
    CntPos := Pos( '$CNT', MtchMsg );
    If CntPos > 0 Then
      Begin
        Msg[ CntPos ] := ' ';
        Msg[ CntPos + 1 ] := Chr( TimeOutCnt div 100 + 48 );
        If Msg[ CntPos + 1 ] = '0' Then Msg[ CntPos + 1 ] := ' ';
        Msg[ CntPos + 2 ] := Chr( ( TimeOutCnt div 10 ) mod 10 + 48 );
        If Msg[ CntPos + 2 ] = '0' Then Msg[ CntPos + 2 ] := ' ';
        Msg[ CntPos + 3 ] := Chr( TimeOutCnt mod 10 + 48 );
      End;
    If ( SpclPos = 0 ) and ( TmPos = 0 ) and ( CntPos = 0 ) Then
      Begin
        PromptDone := True;
        If DfltChar <> NoKey Then
          Msg := Msg + DfltChar + ^H;
        Write( Msg );
      End
    Else
      Begin
        If Msg <> PrevMsg Then
          Begin
            If PrevMsg = '' Then
              DifPos := 1
            Else
              Begin
                DifPos := 255;
                If SpclPos > 0 Then DifPos := SpclPos;
                If ( TmPos > 0 ) and ( TmPos < DifPos ) Then
                  DifPos := TmPos;
                If ( CntPos > 0 ) and ( CntPos < DifPos ) Then
                  DifPos := CntPos;
                While DifPos + Length( BkStr ) <= Length( PrevMsg ) do
                  BkStr := BkStr + ^H;
                If DfltChar <> NoKey Then
                  Delete( BkStr, Length( BkStr ), 1 );
              End;
            If DfltChar <> NoKey Then
              Msg := Msg + DfltChar;
            PrevMsg := Msg;
            Write( BkStr + Copy( Msg, DifPos, 255 ) );
            If DfltChar <> NoKey Then Write( ^H );
            If SpclPos > 0 Then Dly( 285 );
          End;
      End;
  End;

{-------------------------------------------------------------------------}

Procedure ConvertExtKeys( Var InK : String255 );
  Var
    OutK : String255;
    Code, Lp : Integer;
    ExtFlag : Boolean;
    KeyNumStr : String[3];
  Begin
    FillChar( ExtChar, SizeOf( ExtChar ), False );
    OutK := '';
    While InK <> '' do
      Begin
        If Copy( InK, 1, 1 ) = '/' Then
          Begin
            Delete( InK, 1, 1 );
            If Copy( InK, 1, 1 ) <> '/' Then
              DfltChar := InK[ 1 ]
          End;
        If Copy( InK, 1, 1 ) <> '\' Then
          Begin
            OutK := OutK + Copy( InK, 1, 1 );
            Delete( InK, 1, 1 );
          End
        Else
          Begin
            Delete( InK, 1, 1 );
            If Copy( InK, 1, 1 ) = '\' Then
              Begin  { literal }
                OutK := OutK + Copy( InK, 1, 1 );
                Delete( InK, 1, 1 );
              End
            Else
              Begin
                If Copy( InK, 1, 1 ) = '-' Then
                  Begin  { literal }
                    ExtFlag := True;
                    Delete( InK, 1, 1 );
                  End
                Else
                  ExtFlag := False;
                KeyNumStr := Copy( InK, 1, 3 );
                Delete( InK, 1, 3 );
                Result := 0;
                If Length( KeyNumStr ) <> 3 Then Result := 1;
                If Result = 0 Then
                  For Lp := 1 to 3 do
                    If not ( KeyNumStr[ Lp ] in [ '0'..'9' ] ) Then
                      Result := 1;
                If Result = 0 Then
                  Val( KeyNumStr, Code, Result );
                If ( Result <> 0 ) or ( Code < 0 ) or ( Code > 255 ) Then
                  Stop( 'Bad key code value: "' + KeyNumStr + '".' );
                If Code = 0 Then
                  AnyKey := True
                Else
                  OutK := OutK + Chr( Code );
                ExtChar[ Length( OutK ) ] := ExtFlag;
              End;
          End;
      End;
    InK := OutK;
  End;

{*************************************************************************}

BEGIN

  If ( ParamCount = 0 ) or
     ( ( ParamCount = 1 ) and ( ParamStr(1) = '?' ) )
    THEN BEGIN
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( ProgramName + ' ver ' + Version + ' rev ' + Revision +
                            ' - ' + CpyRt + '.' );
      Writeln( 'Keypress accept and validate, for simple menus.' );
      Writeln( '  Present a prompt then wait for valid keypress.' );
      Writeln( 'ASQ [options] "prompt"[,] [charset]' );
      Writeln( '  Return errorlevel corresponding to position' );
      Writeln( '  in charset of pressed key.  Return 255 for errors.' );
      Writeln( 'Options:' );
      Writeln( '  /E   Eat pending keys at startup.' );
      Writeln( '  /C   Make selection case sensitive.' );
      Writeln( '  /S   Suppress invalid key sound.' );
      Writeln( '  /T   Do not echo user keypress or carriage return.' );
      Writeln( '  /n   Timeout seconds, returns 0.' );
      Writeln( 'Prompt:' );
      Writeln( '  $TIME $CNT  Show HH:MM or countdown within prompt.' );
      Writeln( '  $... $--- $>>> $===  Show animated portion in prompt.' );
      Writeln( 'Charset:' );
      Writeln( '  Omit charset to simply accept any keypress.' );
      Writeln( '  Printable characters are interpreted literally.' );
      Writeln( '  \nnn   Accept key (Ctrl/misc) returning scan code nnn.' );
      Writeln( '  \-nnn  Accept Alt or Func keys as above.' );
      Writeln( '         Must be three digit decimal.  \\ is literal \.' );
      Writeln( '  \000   Accept any other key, returns max pos +1.' );
      Writeln( '  /c     Indicates default selection.  // is literal /.' );
      Halt;
    END;

{ Get full, unadulterated command line. }
  Move( Mem[ PrefixSeg : $80 ], ComLine, SizeOf( ComLine ) );
  Delete( ComLine, 1, 1 );  { space after program name }
{ Parse out the prompt. }
  Prompt := '';
{ Remove leading spaces. }
  While ( ComLine <> '' ) and ( Copy( ComLine, 1, 1 ) = ' ' ) do
    Delete( ComLine, 1, 1 );
{ Parse out options. }
  Repeat
    Found := False;
    If ( Length( ComLine ) >= 2 ) and
       ( ( Copy( ComLine, 1, 2 ) = '/E' ) or
         ( Copy( ComLine, 1, 2 ) = '/e' ) ) Then
      Begin
        Delete( ComLine, 1, 2 );
        DoEat := True;
        Found := True;
      End;
    If ( not Found ) and
       ( Length( ComLine ) >= 2 ) and
       ( ( Copy( ComLine, 1, 2 ) = '/C' ) or
         ( Copy( ComLine, 1, 2 ) = '/c' ) ) Then
      Begin
        Delete( ComLine, 1, 2 );
        DoUC := False;
        Found := True;
      End;
    If ( not Found ) and
       ( Length( ComLine ) >= 2 ) and
       ( ( Copy( ComLine, 1, 2 ) = '/S' ) or
         ( Copy( ComLine, 1, 2 ) = '/s' ) ) Then
      Begin
        Delete( ComLine, 1, 2 );
        Silent := True;
        Found := True;
      End;
    If ( not Found ) and
       ( Length( ComLine ) >= 2 ) and
       ( ( Copy( ComLine, 1, 2 ) = '/T' ) or
         ( Copy( ComLine, 1, 2 ) = '/t' ) ) Then
      Begin
        Delete( ComLine, 1, 2 );
        Terse := True;
        Found := True;
      End;
    If ( not Found ) and
       ( Length( ComLine ) >= 2 ) and
       ( ComLine[ 1 ] = '/' ) and
       ( ComLine[ 2 ] in [ '0'..'9' ] ) Then
      Begin
        Delete( ComLine, 1, 1 );
        TimeOutStr := '';
        While ( ComLine <> '' ) and
              ( ComLine[ 1 ] in [ '0'..'9' ] ) do
          Begin
            TimeOutStr := TimeOutStr + Copy( ComLine, 1, 1 );
            Delete( ComLine, 1, 1 );
          End;
        If TimeOutStr <> '' Then
          Begin
            Val( TimeOutStr, TimeOut, Result );
            If ( Result <> 0 ) or
               ( TimeOut < 1 ) or ( TimeOut > 32767 ) Then
              Stop( 'Bad timeout value: "' + TimeOutStr + '".' );
            Found := True;
          End;
      End;
    If Found Then
      Begin
        While ( ComLine <> '' ) and ( Copy( ComLine, 1, 1 ) = ' ' ) do
          Delete( ComLine, 1, 1 );
      End;
  Until not Found;
  { Check for missing prompt. }
  If ComLine = '' THEN Stop( 'Insufficient parameters.' );
  { Check for quote mark, remove it if found. }
  If Copy( ComLine, 1, 1 ) <> '"' Then Stop( 'Missing open quote.' );
  Delete( ComLine, 1, 1 );
  { Assemble the prompt. }
  While ( ComLine <> '' ) and
        ( Copy( ComLine, 1, 1 ) <> '"' ) do
    Begin
      Prompt := Prompt + Copy( ComLine, 1, 1 );
      Delete( ComLine, 1, 1 );
    End;
  { Check for quote mark, remove it if found. }
  If Copy( ComLine, 1, 1 ) <> '"' Then Stop( 'Missing close quote.' );
  Delete( ComLine, 1, 1 );
  { strip comma for ASK compatibility }
  If Copy( ComLine, 1, 1 ) = ',' Then Delete( ComLine, 1, 1 );
  { Strip leading and trailing spaces. }
  While ( ComLine <> '' ) and
        ( Copy( ComLine, Length( ComLine ), 1 ) = ' ' ) do
    Delete( ComLine, Length( ComLine ), 1 );
  While ( ComLine <> '' ) and
        ( Copy( ComLine, 1, 1 ) = ' ' ) do
    Delete( ComLine, 1, 1 );
  InSet := ComLine;
  If DoUC Then
    For Loop := 1 to Length( InSet ) do
      InSet[ Loop ] := UpCase( InSet[ Loop ] );
  ConvertExtKeys( InSet );

  ExitSave := ExitProc;  ExitProc := @TidyExit;

  If DoEat Then
    While KeyPressed do Ch := GetKey;
  TimeOutCnt := TimeOut;
  Repeat
    PrevSeconds := Seconds;
    Repeat
      If ( Prompt <> '' ) and ( not PromptDone ) Then
        WritePrompt( Prompt );
      If TimeOutCnt > 0 Then
        If PrevSeconds <> Seconds Then
          Begin
            PrevSeconds := Seconds;
            Dec( TimeOutCnt );
            If TimeOutCnt = 0 Then
              Begin
                If not Terse Then Writeln;
                Halt( 0 );
              End;
          End;
    Until KeyPressed;
    Ch := GetKey;
    If ( Ch = #13 ) and ( DfltChar <> NoKey ) Then
      Ch := DfltChar;
    If InSet = '' Then
      Done := True
    Else
      Begin
        If DoUC Then Ch := UpCase( Ch );
        SetPos := Pos( Ch, InSet );
        If SetPos > 0 Then
          Done := Extended = ExtChar[ SetPos ];
        If ( SetPos = 0 ) and AnyKey Then
          Begin
            Done := True;
            SetPos := Length( InSet ) + 1;
          End;
        If ( not Done ) and ( not Silent ) Then Write( ^G );
      End;
  Until Done;
  If not Terse Then Writeln( Ch );
  ExitProc := ExitSave;
  Halt( SetPos );

End.


