{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 32000,0,0}

Program ComUtl;

Uses Dos;

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  MaxComPort = 4;
  BaudLSBOfs    = 0;
  BaudMSBOfs    = 1;
  IntrEnableOfs = 1;
  LineCtrlOfs   = 3;
  ModemCtrlOfs  = 4;
  LineStatOfs   = 5;
  ModemStatOfs  = 6;
  NetSaveFileSpec = '\COMUTL.$$$';
  MaxProbablePorts = 18;
  PortAdrAry   : Array[ 1..MaxProbablePorts ] of Word =
    ( $1A0, $1A8, $1E0, $1E8, $1F0, $1F8,
      $2A0, $2A8, $2E0, $2E8, $2F0, $2F8,
      $3A0, $3A8, $3E0, $3E8, $3F0, $3F8 );

Type
  SmallString = String[ 80 ];
  AddrArray = Array [ 1..MaxComPort ] of Word;

Var
  PAddrArr : Array [ 1..4 ] of Word absolute $40:0;
  Param : SmallString;
  ParamLoop, UCLoop, PNum, PAddr, ShowLoop : Word;
  ComPortTable : AddrArray Absolute $40:0;  { equipment table }
  TempPortTable : AddrArray;
  Result : Integer;
  Ch : Char;

Function TestPort( PortAddr: Integer ) : Boolean;
  Var
    SavBMsb, SavBLsb : Word;
  Begin
    { allow access to baud rate generator (DLAB high) }
    Port[ PortAddr + LineCtrlOfs ] :=
      Port[ PortAddr + LineCtrlOfs ] or $80;
    { set high and low divisors }
    SavBMsb := Port[ PortAddr + BaudMSBOfs ];
    SavBLsb := Port[ PortAddr + BaudLSBOfs ];
    Port[ PortAddr + BaudMSBOfs ] := 8;
    Port[ PortAddr + BaudLSBOfs ] := $7D;
    If ( Port[ PortAddr + BaudMSBOfs ] = 8 ) and
       ( Port[ PortAddr + BaudLSBOfs ] = $7D ) Then
      Begin
        TestPort := True;
        Port[ PortAddr + BaudMSBOfs ] := SavBMsb;
        Port[ PortAddr + BaudLSBOfs ] := SavBLsb;
      End
    Else
      TestPort := False;
    Port[ PortAddr + LineCtrlOfs ] :=
      Port[ PortAddr + LineCtrlOfs ] and $7F;
  End;

{----------------------------------------------------------------------}

Function WordHex( W : Word ) : SmallString;
  Const
    Xlat : Array [ 0..15 ] of Char = '0123456789ABCDEF';
  Begin
    WordHex :=
        Xlat [ ( W shr 12 ) and 15 ] +
        Xlat [ ( W shr 8 ) and 15 ] +
        Xlat [ ( W shr 4 ) and 15 ] +
        Xlat [ W and 15 ]
  End;

{----------------------------------------------------------------------}

Function HexWord( H : SmallString ) : Word;
  Const
    Xlat = '0123456789ABCDEF';
  Begin
    HexWord :=
        ( Pos( H[ 1 ], XLat ) - 1 ) * $0100 +
        ( Pos( H[ 2 ], XLat ) - 1 ) * $0010 +
        ( Pos( H[ 3 ], XLat ) - 1 ) * $0001;
  End;

{----------------------------------------------------------------------}

Function I_S( Num : Word ) : SmallString;
  Var
    NumStr : SmallString;
  Begin
    Str( Num, NumStr );
    I_S := NumStr;
  End;

{-------------------------------------------------------------------------}
{ Returns serial port status info as a string where capital letters       }
{ indicate logical one state.  String is 'drooldopfbtt' representing      }
{ Modem status:                                                           }
{   [C]lear to send, [D]ata set ready, [R]ing indicator,                  }
{   [R]eceive line signal detect.                                         }
{ Modem control:                                                          }
{   [D]ata terminal ready, [R]equest to send, [O]ut 1, [O]ut 2, [L]oop.   }
{ Line status:                                                            }
{   [D]ata ready, [O]verrun error, [P]arity error, [F]raming error,       }
{   [B]reak error, [T]x hold empty, [T]x shift empty.                     }
{-------------------------------------------------------------------------}

Function PortStat( PortNum : Byte ) : SmallString;
  Var
    ModmStat, ModmCtrl, LineStat : Byte;
    O : SmallString;
  Begin
    ModmStat := Port[ PAddr + ModemStatOfs ];
    ModmCtrl := Port[ PAddr + ModemCtrlOfs ];
    LineStat := Port[ PAddr + LineStatOfs ];
    O := 'cdrr drool dopfbtt';
    If ModmStat and $10 <> 0 Then O[ 1 ] := UpCase( O[ 1 ] );
    If ModmStat and $20 <> 0 Then O[ 2 ] := UpCase( O[ 2 ] );
    If ModmStat and $40 <> 0 Then O[ 3 ] := UpCase( O[ 3 ] );
    If ModmStat and $80 <> 0 Then O[ 4 ] := UpCase( O[ 4 ] );
    If ModmCtrl and $01 <> 0 Then O[ 6 ] := UpCase( O[ 6 ] );
    If ModmCtrl and $02 <> 0 Then O[ 7 ] := UpCase( O[ 7 ] );
    If ModmCtrl and $04 <> 0 Then O[ 8 ] := UpCase( O[ 8 ] );
    If ModmCtrl and $08 <> 0 Then O[ 9 ] := UpCase( O[ 9 ] );
    If ModmCtrl and $10 <> 0 Then O[ 10 ] := UpCase( O[ 10 ] );
    If LineStat and $01 <> 0 Then O[ 12 ] := UpCase( O[ 12 ] );
    If LineStat and $02 <> 0 Then O[ 13 ] := UpCase( O[ 13 ] );
    If LineStat and $04 <> 0 Then O[ 14 ] := UpCase( O[ 14 ] );
    If LineStat and $08 <> 0 Then O[ 15 ] := UpCase( O[ 15 ] );
    If LineStat and $10 <> 0 Then O[ 16 ] := UpCase( O[ 16 ] );
    If LineStat and $20 <> 0 Then O[ 17 ] := UpCase( O[ 17 ] );
    If LineStat and $40 <> 0 Then O[ 18 ] := UpCase( O[ 18 ] );
    PortStat := O;
  End;


{----------------------------------------------------------------------}

Function PortSettings( PNum : Integer;
                       Verbose : Boolean ) : SmallString;
  Var
    PAddr, X, N : Word;
    O, W : SmallString;
  Const
    Xlat : Array [ 0..15 ] of Char = '0123456789ABCDEF';
  Begin
    PortSettings := '';  O := '';
    If ( PNum < 1 ) or ( PNum > 4 ) Then
      Begin
        If Verbose Then
          PortSettings := 'Invalid port number ' + I_S( PNum )
        Else
          PortSettings := 'BadPort';
        Exit;
      End;
    PAddr := PAddrArr[ PNum ];
    If PAddr > 0 Then
      Begin  { port exists }
        If Verbose Then
          O := 'Com' + I_S( PNum ) +
               ': Adr=' + Copy( WordHex( PAddr ), 2, 3 )
        Else
          O := 'Com' + I_S( PNum ) +
               ': ' + Copy( WordHex( PAddr ), 2, 3 ) + 'h  ';
        Port[ PAddr + LineCtrlOfs ] :=
          Port[ PAddr + LineCtrlOfs ] or $80;
        X := Port[ PAddr + BaudMSBOfs ];
        If ( X <= $0003 ) and ( X >= $0000 ) Then
          X := ( X shl 8 ) + Port[ PAddr ]
        Else
          X := $00;
        Port[ PAddr + LineCtrlOfs ] :=
          Port[ PAddr + LineCtrlOfs ] and $7F;
        Case X of
          $0001 : W := '115200';
          $0003 : W := '38400';
          $0006 : W := '19200';
          $000C : W := '9600';
          $0018 : W := '4800';
          $0030 : W := '2400';
          $0060 : W := '1200';
          $00C0 : W := '600';
          $0180 : W := '300';
          $0300 : W := '150';
          Else W := 'Bad';
        End;
        If Verbose Then W := ' bd=' + W;
        O := O + W;
        X := Port[ PAddr + LineCtrlOfs ] and $0038;
        Case X OF
          $18 : W := 'E';
          $08 : W := 'O';
          $28 : W := 'S';
          $00 : W := 'N';
          Else W := 'Bad';
        End;
        If Verbose Then W := ' par=' + W;
        O := O + W;
        X := Port[ PAddr + LineCtrlOfs ] and $0003;
        Case X of
          0 : W := '5';
          1 : W := '6';
          2 : W := '7';
          3 : W := '8';
          Else W := 'Bad';
        End;
        If Verbose Then W := ' DB=' + W;
        O := O + W;
        X := Port[ PAddr + LineCtrlOfs ] and $0004;
        If X = 0 Then
          W := '1'
        Else
          W := '2';
        If Verbose Then W := ' SB=' + W;
        O := O + W;
        X := Port[ PAddr + BaudMSBOfs ];
        If Verbose Then
          O := O + ' IGn=' + Copy( WordHex( X ), 3, 2 )
        Else
          O := O + ' IG' + Copy( WordHex( X ), 3, 2 );
        If Odd( PNum ) Then N := 4 Else N := 3;
        If ( Odd( PNum ) and ( Port[ $21 ] and $10 = $00 ) ) or
           ( Odd( PNum ) and ( Port[ $21 ] and $08 = $00 ) ) Then
          W := 'on'
        Else
          W := 'off';
        If Verbose Then
          O := O + ' IEn' + I_S( N ) + '=' + W
        Else
          If W = 'on' Then O := O + ' IE';
      End  { port exists }
    Else
      O := O + 'Com' + I_S( PNum ) + ': is not installed.';
    PortSettings := O;
  End;

{----------------------------------------------------------------------}

Procedure Stop( Msg : SmallString );
  Begin
    Writeln( Msg, ' in parameter: "', Param, '"' );
    Halt( 1 );
  End;

{----------------------------------------------------------------------}

Procedure ParseParam( Var PortNum, Addr : Word );
  Var
    PortCh : Char;
    AddrStr : SmallString;
  Begin
    If Length( Param ) <> 8 Then Stop( 'Incomplete statement' );
    If Copy( Param, 1, 3 ) <> 'COM' Then Stop( 'Bad format' );
    PortCh := Param[ 4 ];
    If not ( PortCh in [ '1'..'4' ] ) Then Stop( 'Bad port number' );
    PortNum := Ord( PortCh ) - 48;
    If Param[ 5 ] <> '=' Then Stop( 'Missing "="' );
    AddrStr := Copy( Param, 6, 3 );
    For UCLoop := 1 to 3 do
      Begin
        AddrStr[ UCLoop ] := UpCase( AddrStr[ UCLoop ] );
        If not ( AddrStr[ UCLoop ] in [ '0'..'9', 'A'..'F' ] ) Then
          Stop( 'Bad address character' );
      End;
    Addr := HexWord( AddrStr );
  End;

{-------------------------------------------------------------------------}

Function KeyPressed : Boolean;
  Var
    Regs : Registers;
  Begin
    Regs.AH := $0B;  MSDos( Regs );
    KeyPressed := Regs.AL = $FF;
  End;

{----------------------------------------------------------------------}

Function GetKey : Char;
  Var
    Regs : Registers;
  Begin
    Regs.AH := $08;  { ConInputNoEcho }
    MsDos( Regs );
    GetKey := UpCase( Chr( Regs.AL ) );
  End;

{-------------------------------------------------------------------------}

Procedure NetSave;
  Type
    ComCfgRec =
      Record
        BaudMSB, BaudLSB : Byte;
        LineCtrl, ModemCtrl, IrqEnable, IrqType : Byte;
        Vec : Pointer;
      End;
  Var
    PortLoop, Result : Integer;
    ComCfgFile : File of ComCfgRec;
    ComCfgSave : Array[ 1..MaxComPort ] of ComCfgRec; { prev port vec }
  Label
    ErrOut;
  Procedure ComRestoreCfg( PortNum : Integer );
    Var
      Junk : Byte;
    Begin
      Port[ ComPortTable[ PortNum ] + IntrEnableOfs ] := $00;  { intr off }
      Case PortNum of
        1, 3 : Port[ $21 ] := Port[ $21 ] or $10;  { disable IRQ4 }
        2, 4 : Port[ $21 ] := Port[ $21 ] or $08;  { disable IRQ3 }
       End;
      Port[ ComPortTable[ PortNum ] + ModemCtrlOfs ] :=
        ComCfgSave[ PortNum ].ModemCtrl;
      Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] :=
        ComCfgSave[ PortNum ].LineCtrl;
      Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] :=
        Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] or $80;
      Port[ ComPortTable[ PortNum ] + BaudMSBOfs ] :=
        ComCfgSave[ PortNum ].BaudMSB;
      Port[ ComPortTable[ PortNum ] + BaudLSBOfs ] :=
        ComCfgSave[ PortNum ].BaudLSB;
      Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] :=
        Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] and $7F;
      Junk := Port[ ComPortTable[ PortNum ] ]; { clear receiver }
      Junk := Port[ ComPortTable[ PortNum ] ];
      Junk := Port[ ComPortTable[ PortNum ] + LineStatOfs ];
      Junk := Port[ ComPortTable[ PortNum ] + ModemStatOfs ];
      Case PortNum of
        1, 3 : SetIntVec( $0C, ComCfgSave[ PortNum ].Vec );
        2, 4 : SetIntVec( $0B, ComCfgSave[ PortNum ].Vec );
       End;
      Port[ ComPortTable[ PortNum ] + IntrEnableOfs ] :=
        ComCfgSave[ PortNum ].IrqType;
      Case PortNum of
        1, 3 : Port[ $21 ] := Port[ $21 ] and $EF or  { set IRQ4 enable }
                 ComCfgSave[ PortNum ].IrqEnable;
        2, 4 : Port[ $21 ] := Port[ $21 ] and $F7 or  { set IRQ3 enable }
                 ComCfgSave[ PortNum ].IrqEnable;
       End;
    End;
  Procedure ComSaveCfg( PortNum : Integer );
    Begin
      Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] :=
        Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] or $80;
      ComCfgSave[ PortNum ].BaudMSB :=
        Port[ ComPortTable[ PortNum ] + BaudMSBOfs ];
      ComCfgSave[ PortNum ].BaudLSB :=
        Port[ ComPortTable[ PortNum ] + BaudLSBOfs ];
      Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] :=
        Port[ ComPortTable[ PortNum ] + LineCtrlOfs ] and $7F;
      ComCfgSave[ PortNum ].LineCtrl :=
        Port[ ComPortTable[ PortNum ] + LineCtrlOfs ];
      ComCfgSave[ PortNum ].ModemCtrl :=
        Port[ ComPortTable[ PortNum ] + ModemCtrlOfs ];
      ComCfgSave[ PortNum ].IrqType :=
        Port[ ComPortTable[ PortNum ] + IntrEnableOfs ];
      Case PortNum of
        1, 3 : ComCfgSave[ PortNum ].IrqEnable :=
                 Port[ $21 ] and $10; { get IRQ4 enable }
        2, 4 : ComCfgSave[ PortNum ].IrqEnable :=
                 Port[ $21 ] and $08; { get IRQ3 enable }
       End;
      Case PortNum of
        1 : GetIntVec( $0C, ComCfgSave[ PortNum ].Vec );
        2 : GetIntVec( $0B, ComCfgSave[ PortNum ].Vec );
       End;
    End;
  Begin
    Assign( ComCfgFile, NetSaveFileSpec );
    If ( ParamStr( 1 ) = '/R' ) or ( ParamStr( 1 ) = '/r' ) Then
      Begin  { read }
        Reset( ComCfgFile );  Result := IOResult;
        If Result <> 0 Then Goto ErrOut;
        For PortLoop := 1 to MaxComPort do
          Begin
            Read( ComCfgFile, ComCfgSave[ PortLoop ] );
            Result := IOResult;
            If Result <> 0 Then Goto ErrOut;
          End;
        For PortLoop := 1 to MaxComPort do
          ComRestoreCfg( PortLoop );
        Close( ComCfgFile );  Result := IOResult;
        If Result <> 0 Then Goto ErrOut;
        If ParamCount = 0 Then
          Begin
            Erase( ComCfgFile );  Result := IOResult;
            If Result <> 0 Then Goto ErrOut;
          End;
      End  { read }
    Else
      Begin  { write }
        Rewrite( ComCfgFile );  Result := IOResult;
        If Result <> 0 Then Goto ErrOut;
        For PortLoop := 1 to MaxComPort do
          ComSaveCfg( PortLoop );
        For PortLoop := 1 to MaxComPort do
          Begin
            Write( ComCfgFile, ComCfgSave[ PortLoop ] );
            Result := IOResult;
            If Result <> 0 Then Goto ErrOut;
          End;
        Close( ComCfgFile );  Result := IOResult;
        If Result <> 0 Then Goto ErrOut;
      End;  { write }
    Exit;
  ErrOut:
    Writeln( 'Cannot access port configuration file.' );
    Close( ComCfgFile );  Result := IOResult;
    Erase( ComCfgFile );  Result := IOResult;
  End;

{-------------------------------------------------------------------------}

Begin

  If ( ParamCount > 0 ) and ( ParamStr( 1 ) = '?' ) Then
    Begin
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( 'COMUTL ver 3.1 rev 91/06/29 - ', CpyRt, '.' );
      Writeln( 'Several advanced serial port utility functions.' );
      Writeln( '  Port info show, find, add, diagnose, save, recall.' );
      Writeln( 'COMUTL' );
      Writeln( '  Display port addresses and settings.' );
      Writeln( 'COMUTL /F' );
      Writeln( '  Find ports by checking for baud register ports.' );
      Writeln( 'COMUTL COMx=nnn ...' );
      Writeln( '  Change or add up to four ports in equipment table.' );
      Writeln( '  x = port number  nnn = three digit hex address' );
      Writeln( 'COMUTL n /C' );
      Writeln( '  Return errorlevel if port n does not exist.' );
      Writeln( 'COMUTL n' );
      Writeln( '  Show continuous status of port n (capital=on):' );
      Writeln( '    cdrr - Modem status: Cts Dsr Ri Rcv_detect' );
      Writeln( '    drool - Modem control: Dtr Rts Out1 Out2 Loop' );
      Writeln( '    dopfbtt - Line status: Dta_rdy Ovrrun_err Prty_err' );
      Writeln( '               Frmng_err Brk_err Txhld_empty Txshft_empty.' );
      Writeln( '    IGn=UART intr generate, IE=CPU intr enable.' );
      Writeln( '  Status show may interfere with resident com software.' );
      Writeln( 'COMUTL /W {or} /R' );
      Writeln( '  Save or recall full port setup including interrupts.' );
      Writeln( '  For recovery from applications which disrupt the setup.' );
      Writeln( '  Configuration is stored in \COMUTL.$$$ file.' );
      Halt( 1 );
    End;

  If ( ParamCount > 0) and
     ( ( ParamStr( 1 ) = '/F' ) or ( ParamStr( 1 ) = '/f' ) ) Then
    Begin
      For PNum := 1 to MaxProbablePorts do
        If TestPort( PortAdrAry[ PNum ] ) Then
          Writeln( 'Port address $',
                   Copy( WordHex( PortAdrAry[ PNum ] ), 2, 3 ),
                         ' may be a valid port.' );
      Exit;
    End;

  If ( ParamCount > 0) and
     ( ( ParamStr( 1 ) = '/R' ) or ( ParamStr( 1 ) = '/r' ) or
       ( ParamStr( 1 ) = '/W' ) or ( ParamStr( 1 ) = '/w' ) ) Then
    Begin
      NetSave;
      Exit;
    End;

  If ( Copy( ParamStr( 1 ), 1, 1 ) = '1' ) or
     ( Copy( ParamStr( 1 ), 1, 1 ) = '2' ) or
     ( Copy( ParamStr( 1 ), 1, 1 ) = '3' ) or
     ( Copy( ParamStr( 1 ), 1, 1 ) = '4' ) Then
    Begin
      Val( Copy( ParamStr( 1 ), 1, 1 ), PNum, ShowLoop );
      If ( ParamCount > 1 ) and
         ( ( ParamStr( 2 ) = '/C' ) or ( ParamStr( 2 ) = '/c' ) ) Then
        Begin
          If PAddrArr[ PNum ] = 0 Then
            Begin
              Writeln( 'Com', PNum, ' does not exist.' );
              Halt( 1 );
            End
          Else
            Begin
              Writeln( 'Com', PNum, ' exists.' );
              Halt;
            End;
        End;
      Repeat
        Write( #13, PortSettings( PNum, False ), '  ',
                    PortStat( PNum ), '   ' );
      Until KeyPressed;
      While KeyPressed do Ch := GetKey;
      Writeln;
      Exit;
    End;

  If ParamCount > 0 Then
    Begin
      TempPortTable := ComPortTable;
      For ParamLoop := 1 to ParamCount do
        Begin
          Param := ParamStr( ParamLoop );
          For UCLoop := 1 to Length( Param ) do
            Param[ UCLoop ] := UpCase( Param[ UCLoop ] );
          PNum := 0;  PAddr := 0;
          ParseParam( PNum, PAddr );
          TempPortTable[ PNum ] := PAddr;
          If Not TestPort(PAddr) Then
            Writeln( 'Address installed but no port detected at ',
                     Copy( WordHex( PAddr ), 2, 3 ) );
        End;
      If ParamCount > 0 Then ComPortTable := TempPortTable;
    End;

  For ShowLoop := 1 to MaxComPort do
    Begin
      Write( 'Com', ShowLoop, '=',
             Copy( WordHex( ComPortTable[ ShowLoop ] ), 2, 3 ) );
      If ShowLoop < MaxComPort Then Write( '  ' );
    End;
  Writeln;
  For ShowLoop := 1 to MaxComPort do
    If ComPortTable[ ShowLoop ] <> 0 Then
      Writeln( PortSettings( ShowLoop, True ) );

End.


