{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 16384,0,16384}

Program Daniel;

Uses Dos, Crt;

Type
  String60 = String[60];

VAR
  Con : Text;
  Ch : Char;
  S  : Integer;
  Lock : String[20];
  Key : String[20];
  SaveMode : Byte;
  CurrColor : Byte;

CONST
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  Row : Byte = 1;
  Col : Byte = 1;
  SBase    = 100;
  SFactor  = 20;
  DefaultLock = 'DANIEL';

Function KeyPressed : Boolean;
  Var
    Regs : Registers;
  Begin
    Regs.AH := $0B;  MSDos( Regs );
    KeyPressed := Regs.AL = $FF;
  End;

Function GetKey : Char;
  Var
    Regs : Registers;
  Begin
    Regs.AH := $08;  { ConInputNoEcho }
    MsDos( Regs );
    GetKey := UpCase( Chr( Regs.AL ) );
  End;

Procedure GotoXY( X, Y : Word );
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := $02;  Regs.DH := Y - 1;  Regs.DL := X - 1;
    Intr( $10, Regs );
    Row := Y;  Col := X;
  End;

Procedure SetVMode( M : Byte );
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := $00;  Regs.AL := M;
    Intr( $10, Regs );
  End;

Function GetVMode : Byte;
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := 15;
    Intr( $10, Regs );
    GetVMode := Regs.AL;
  End;

Procedure GraphBackground( C : Word );
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := 11;  Regs.BH := 0;  Regs.BL := C;
    Intr( $10, Regs );
  End;

Procedure GraphPalette( C : Word );
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := 11;  Regs.BH := 1;  Regs.BL := C;
    Intr( $10, Regs );
  End;

Procedure TextColor( C : Word );
  Begin
    CurrColor := C;
  End;

Procedure DosWrite( Msg : String60 );
  Var
    Regs : Registers;
    Loop : Byte;
  Begin
    For Loop := 1 to Length( Msg ) do
      Begin
        FillChar( Regs, SizeOf( Regs ), 0 );
        Regs.AH := $09;
        Regs.AL := Ord( Msg[ Loop ] );
        Regs.CX := $0001;
        Regs.BL := CurrColor;
        Intr( $10, Regs );
        Inc( Col );  GotoXY( Col, Row );
      End;
  End;

Procedure DosWriteln( Msg : String60 );
  Begin
    Msg := Msg + #13 + #10;
    DosWrite( Msg );
  End;

Function UnLocked : Boolean;
  BEGIN
    If Ch in [ 'A'..'Z' ] then
      BEGIN
        Key := Key + Ch;
        Delete( Key, 1, 1 );
      END;
    UnLocked := Lock = Key;
  END;  { UnLocking function }


Procedure Whoop( T : Integer; Up : Boolean);
  VAR  Loop : Integer;
  BEGIN
    Case Up of
      True  : For Loop := T downto T div 2 do Sound( Loop);
      False : For Loop := T div 2 to T do Sound( Loop);
    End;
  END;


Procedure Boop( T : Integer);
  BEGIN Sound( T); Delay( 200); END;


Procedure Chirp( T : Integer);
  BEGIN
    Sound( T);  Delay( 14);
    Sound( T div 2);  Delay( 14);
    Sound( T);  Delay( 14);
  END;


Procedure Razz( T : Integer);
  VAR  Loop : Byte;
  BEGIN
    For Loop := 1 to 10 do
    BEGIN
      Sound( T);  Delay( 8);
      Sound( T div 2);  Delay( 8);
    END;
  END;


Procedure Arpeggio( T : Integer);
  BEGIN
    Sound( T);  Delay( 20);
    Sound( T * 5 div 4 );  Delay( 20);
    Sound( T * 4 div 3 );  Delay( 20);
    Sound( T * 3 div 2 );  Delay( 20);
  END;


Procedure Tone( T : Integer);
  BEGIN
    If ( T < 100) or ( T > 18000) then Exit;
    Case Random( 6) of
      0 : Whoop( T, True);
      1 : Whoop( T, False);
      2 : Boop( T);
      3 : Razz( T);
      4 : Arpeggio( T);
      5 : Chirp( T);
    End;  { case }
    NoSound;
  END;


Procedure Dazzle;
  VAR FC : Byte;
  BEGIN
    While not KeyPressed do
    BEGIN   { show LOCK word until keypressed }
      FC := Random( 4 );
      GotoXY( 1 + Random( 40 - Length( Key)), 1 + Random( 24) );
      TextColor( FC );  DosWrite( Lock );
    END;
  END;  { dazzle procedure }


Procedure PrepareLock;
  VAR  Loop, Len : Integer;  St : String[39];
  BEGIN
    Key := '';
    If ParamCount < 1 then Lock := DefaultLock
      else Lock := ParamStr( 1 );
    For Loop := 1 to Length( Lock ) do
      BEGIN
        Lock[ Loop ] := UpCase( Lock[ Loop ] );
        Key := Key + ' ';
      END;
    St := 'Type  "' + Lock + '"  to quit.';
    Len := 31 - Length( St );
    For Loop := 1 to Len do
      If Odd( Loop ) then St := St + ' ' else St := ' ' + St;
    St := ' >>>' + St + '<<<';
    TextColor( 3 );  GotoXY( 1, 25 );  DosWrite( St );
  END;


BEGIN

  If ( ParamCount > 0 ) and ( ParamStr( 1 ) = '?' ) Then
    Begin
      Assign( Con, '' );  ReWrite( Con );
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( Con, 'DANIEL ver 3.1 rev 91/06/29 - ' + CpyRt + '.' );
      Writeln( Con, 'Interactive sounds and lights for toddlers.' );
      Writeln( Con, '  Display a child''s name writing randomly' );
      Writeln( Con, '    all over the screen, and respond with varying' );
      Writeln( Con, '    noises and colors to keypresses.' );
      Writeln( Con, 'DANIEL [name]' );
      Writeln( Con, '  Name   Display a name other than "DANIEL" default.' );
      Writeln( Con, 'CGA compatible graphics is required.' );
      Close( Con );  Halt( 1 );
    End;

  SaveMode := GetVMode;
  If SaveMode = $07 Then
    Begin
      Assign( Con, '' );  ReWrite( Con );
      DosWriteln( 'CGA graphics capability required.' );
      Close( Con );
      Halt( 1 );
    End;

  SetVMode( $04 );  { 320x200x4 }

  PrepareLock;

  Repeat
    Dazzle;
    Ch := ReadKey;  Ch := UpCase( Ch );  S := Ord( Ch);
    GraphBackground( S mod 16 );
    GraphPalette( S mod 4 );
    S := SBase + S * SFactor;
    Tone( S );
  Until UnLocked;

  SetVMode( SaveMode );

END.






