{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 1024,0,0}

Uses Dos;

Const
  NewVec : Byte = $80;
  OldVec = $16;  { bios kbd }
  LogSpec : String[ 30 ] = 'C:\DO.DAT';
  HotKey : Word = $8100;
  HotKeyChar : Char = '0';
  AltKeys : String[72] =
   'A'#30'B'#48'C'#46'D'#32'E'#18'F'#33'G'#34'H'#35'I'#23'J'#36 +
   'K'#37'L'#38'M'#50'N'#49'O'#24'P'#25'Q'#16'R'#19'S'#31'T'#20 +
   'U'#22'V'#47'W'#17'X'#45'Y'#21'Z'#44'1'#120'2'#121'3'#122 +
   '4'#123'5'#124'6'#125'7'#126'8'#127'9'#128'0'#129;
  Msg_Error : String[ 8 ] = 'Error 00';
  Msg_InUse : String[ 30 ] =
    'Already loaded.  Use Alt-*.'#13#10'$';
  Msg_Help : String[ 197 ] =
    'DO ver 3.1 rev 91/06/29 - (C) Andrew Bedno - Chicago.'#13#10 +
    'Resident pop-up time logger.'#13#10 +
    'DO [c [fn]]'#13#10 +
    '  c    Specify Alt-hot key 0..9, A..Z (default 0).'#13#10 +
    '  fn   Specify log file (default C:\DO.DAT).'#13#10'$';

Var
  Regs : Registers;
  OutLn : Array [ 1..21 ] of Byte;
  PrevSize, CurrPos : LongInt;
  Result : Integer;
  Stage : Char;
  LastKey, Loop, CrsrX : Byte;
  LogHandle, VAddr : Word;
  Msg_Loaded : String[ 50 ];

Procedure TsrEntry( Flags, CS, IP,
                    AX, BX, CX, DX, SI, DI, DS, ES, BP : Word );
  Interrupt;
  Var
    SaveLn : Array [ 1..160 ] of Byte;
  Begin
    If ( AX = $FFFF ) and
       ( CX = Ord( 'D' ) ) and ( DX = Ord( 'O' ) ) Then
      Begin
        DX := $ABCD;  { residency check }
        SI := Ord( HotKeyChar );
      End
    Else
      Begin
        { get a keypress }
        Regs.AX := AX;  Regs.BX := BX;  Regs.CX := CX;  Regs.DX := DX;
        Regs.BP := BP;  Regs.SI := SI;  Regs.DI := DI;
        Regs.DS := DS;  Regs.ES := ES;  Regs.Flags := Flags;
        Intr( NewVec, Regs );
        If ( AX and $FF00 = 0 ) and ( Regs.AX = HotKey ) Then
          Begin  { hot key }
            If Mem[ $40 : $49 ] = $07 Then  { get video mode }
              VAddr := $B000       { mono }
            Else
              If Mem[ $40 : $49 ] < 4 Then
                VAddr := $B800     { color }
              Else
                VAddr := 0;        { graphics }
            Repeat  { hotkey restart }
              { save current top line }
              Move( Mem[ VAddr : $0000 ], SaveLn, 160 );
              { indicate end of name by #0 at length + 1 }
              LogSpec[ Length( LogSpec ) + 1 ] := #0;
              { open file }
              Regs.AH := $3D;  { open }
              Regs.DS := Seg( LogSpec[ 1 ] );  { file name }
              Regs.DX := Ofs( LogSpec[ 1 ] );
              Regs.AL := 2;  { read/write mode }
              Stage := 'A';
              Intr( $21, Regs );
              Result := 0;
              If Regs.Flags and $0001 <> 0 Then
                Result := Regs.AX
              Else
                LogHandle := Regs.AX;
              { create if necessary }
              If Result <> 0 Then
                Begin
                  Regs.AH := $3C;  { create }
                  Regs.DS := Seg( LogSpec[ 1 ] );  { file name }
                  Regs.DX := Ofs( LogSpec[ 1 ] );
                  Regs.CX := 0;  { attributes }
                  Stage := 'B';
                  Intr( $21, Regs );
                  Result := 0;
                  If Regs.Flags and $0001 <> 0 Then
                    Result := Regs.AX
                  Else
                    LogHandle := Regs.AX;
                End;
              OutLn[ 1 ] := 0;
              LastKey := 0;
              While ( ( ( OutLn[ 1 ] <> 13 ) and ( OutLn[ 1 ] <> 27 ) ) or
                      ( LastKey = 10 ) ) and
                    ( Result = 0 ) do
                Begin  { while not <escape> or <enter> or error }
                  If VAddr > 0 Then
                    Begin  { text mode }
                      { clear top line }
                      For CrsrX := 0 to 79 do
                        Begin
                          Mem[ VAddr : CrsrX shl 1 ] := 250;      { dot }
                          Mem[ VAddr : CrsrX shl 1 + 1 ] := $70;  { b/w }
                        End;
                      CrsrX := 0;  { reset cursor position }
                    End;  { text mode }
                  { seek to end for appending }
                  Regs.AH := $42;  { long seek }
                  Regs.CX := 0;  { distance MSB }
                  Regs.DX := 0;  { distance LSB }
                  Regs.AL := 2;  { mode: seek to end }
                  Regs.BX := LogHandle;  { handle # }
                  Stage := 'C';
                  Intr( $21, Regs );
                  If Regs.Flags and $0001 <> 0 Then
                    Result := Regs.AX
                  Else
                    Begin
                    { keep previous end of file for undo }
                      PrevSize := Regs.DX;
                      PrevSize := PrevSize shl 16 or Regs.AX;
                      CurrPos := PrevSize;
                    End;
                  { get date and write it as YYMMDD }
                  Regs.AH := $2A;  Intr( $21, Regs );
                  OutLn[ 1 ] := 32;                          { space }
                  OutLn[ 2 ] := Regs.CX mod 100 div 10 + 48; { Yh }
                  OutLn[ 3 ] := Regs.CX mod 10 + 48;         { Yl }
                  OutLn[ 4 ] := 47;                          { slash }
                  OutLn[ 5 ] := Regs.DH div 10 + 48;         { Mh }
                  OutLn[ 6 ] := Regs.DH mod 10 + 48;         { Ml }
                  OutLn[ 7 ] := 47;                          { slash }
                  OutLn[ 8 ] := Regs.DL div 10 + 48;         { Dh }
                  OutLn[ 9 ] := Regs.DL mod 10 + 48;         { Dl }
                  { get time and write it as HHMMSS }
                  Regs.AH := $2C;  Intr( $21, Regs );
                  OutLn[ 10 ] := 32;                          { space }
                  OutLn[ 11 ] := Regs.CH div 10 + 48;         { Hh }
                  OutLn[ 12 ] := Regs.CH mod 10 + 48;         { Hl }
                  OutLn[ 13 ] := 58;                          { colon }
                  OutLn[ 14 ] := Regs.CL div 10 + 48;         { Mh }
                  OutLn[ 15 ] := Regs.CL mod 10 + 48;         { Ml }
                  OutLn[ 16 ] := 58;                          { colon }
                  OutLn[ 17 ] := Regs.DH div 10 + 48;         { Sh }
                  OutLn[ 18 ] := Regs.DH mod 10 + 48;         { Sl }
                  OutLn[ 19 ] := 32;                          { space }
                  OutLn[ 20 ] := 59;                          { ; }
                  OutLn[ 21 ] := 32;                          { space }
                  If Result = 0 Then
                    Begin
                      Regs.AH := $40;  { write }
                      Regs.DS := Seg( OutLn[ 1 ] );  { data }
                      Regs.DX := Ofs( OutLn[ 1 ] );
                      { if restarted write ; for project to continue }
                      If LastKey = 10 Then { alt-enter }
                        Regs.CX := 21  { bytes to write }
                      Else
                        Regs.CX := 19;
                      CurrPos := CurrPos + Regs.CX;
                      Regs.BX := LogHandle;  { handle # }
                      Stage := 'D';
                      Intr( $21, Regs );
                      If Regs.Flags and $0001 <> 0 Then
                        Result := Regs.AX
                    End;
                  If Result = 0 Then
                    Repeat  { until <esc> <enter> <ctrl><enter> or error }
                      If ( VAddr > 0 ) and  { text mode }
                         ( CrsrX < 80 ) Then  { still on screen }
                        Begin  { put solid block cursor }
                          Mem[ VAddr : CrsrX shl 1 ] := 219;
                          Mem[ VAddr : CrsrX shl 1 + 1 ] := $F0;  { blink }
                        End;
                      { get keypress }
                      Regs.AH := 0;  Intr( NewVec, Regs );
                      LastKey := Regs.AH;
                      OutLn[ 1 ] := Regs.AL;
                      If ( VAddr > 0 ) and  { text mode }
                         ( CrsrX < 80 ) Then  { still on screen }
                        Mem[ VAddr : CrsrX shl 1 + 1 ] := $70;  { b/w }
                      If OutLn[ 1 ] = 8 Then  { backspace }
                        Begin
                          If CurrPos > PrevSize + 19 Then
                            Begin
                              If VAddr > 0 Then
                                Begin  { text mode }
                                  If CrsrX < 80 Then  { erase char }
                                    Mem[ VAddr : CrsrX shl 1 ] := 250;
                                  Dec( CrsrX );  { move cursor }
                                End;
                              Dec( CurrPos );
                              { seek back one }
                              Regs.AH := $42;  { long seek }
                              Regs.CX := CurrPos shr 16;     { pos MSB }
                              Regs.DX := CurrPos and $FFFF;  { pos LSB  }
                              Regs.AL := 0;  { mode: seek from start }
                              Regs.BX := LogHandle;  { handle # }
                              Stage := 'E';
                              Intr( $21, Regs );
                              If Regs.Flags and $0001 <> 0 Then
                                Result := Regs.AX;
                              { truncate }
                              If Result = 0 Then
                                Begin
                                  Regs.AH := $40;  { write }
                                  Regs.CX := 0;  { bytes (0=truncate) }
                                  Regs.DS := 0;  { no data }
                                  Regs.DX := 0;
                                  Regs.BX := LogHandle;  { handle # }
                                  Stage := 'F';
                                  Intr( $21, Regs );
                                  If Regs.Flags and $0001 <> 0 Then
                                    Result := Regs.AX
                                End;
                            End;
                        End
                      Else
                        Begin  { any other key }
                          LastKey := OutLn[ 1 ];
                          If LastKey = 10 Then { <ctrl><enter> }
                            OutLn[ 1 ] := 13;  { simulate CR }
                          If ( OutLn[ 1 ] = 13 ) or  { <enter> }
                             ( ( OutLn[ 1 ] >= 32 ) and
                               ( OutLn[ 1 ] <= 127 ) ) Then  { not ext key }
                            Begin
                              OutLn[ 2 ] := 10;
                              Regs.AH := $40;  { write }
                              Regs.DS := Seg( OutLn[ 1 ] );  { data }
                              Regs.DX := Ofs( OutLn[ 1 ] );
                              If OutLn[ 1 ] = 13 Then  { add LF after CR }
                                Regs.CX := 2  { bytes to write }
                              Else
                                Regs.CX := 1;
                              CurrPos := CurrPos + Regs.CX;
                              Regs.BX := LogHandle;  { handle # }
                              Stage := 'G';
                              Intr( $21, Regs );
                              If Regs.Flags and $0001 <> 0 Then
                                Result := Regs.AX;
                              If VAddr > 0 Then
                                Begin  { text mode }
                                  If CrsrX < 80 Then  { put char }
                                    Mem[ VAddr : CrsrX shl 1 ] := OutLn[ 1 ];
                                  Inc( CrsrX );  { move cursor }
                                End;
                            End;
                        End;
                  { until <esc> or <enter> or <ctrl><enter> or error }
                  Until ( OutLn[ 1 ] = 27 ) or ( OutLn[ 1 ] = 13 ) or
                        ( LastKey = 10 ) or ( Result <> 0 );
                End;  { while not <escape> or <enter> or error }
              { undo last entry if escape }
              If ( Result = 0 ) and ( OutLn[ 1 ] = 27 ) Then
                Begin
                  { seek to previous position }
                  Regs.AH := $42;  { long seek }
                  Regs.CX := PrevSize shr 16;     { distance MSB }
                  Regs.DX := PrevSize and $FFFF;  { distance LSB  }
                  Regs.AL := 0;  { mode: seek from start }
                  Regs.BX := LogHandle;  { handle # }
                  Stage := 'H';
                  Intr( $21, Regs );
                  If Regs.Flags and $0001 <> 0 Then
                    Result := Regs.AX;
                  { truncate }
                  If Result = 0 Then
                    Begin
                      Regs.AH := $40;  { write }
                      Regs.CX := 0;  { bytes to write (0=truncate) }
                      Regs.DS := 0;  { no data }
                      Regs.DX := 0;
                      Regs.BX := LogHandle;  { handle # }
                      Stage := 'I';
                      Intr( $21, Regs );
                      If Regs.Flags and $0001 <> 0 Then
                        Result := Regs.AX
                    End;
                End;
              { close file }
              Regs.AH := $3E;  { close }
              Regs.BX := LogHandle;  { handle # }
              If Result = 0 Then Stage := 'J';
              Intr( $21, Regs );
              If ( Regs.Flags and $0001 <> 0 ) and ( Result = 0 ) Then
                Result := Regs.AX;
              If Result <> 0 Then
                Begin
                  { show error code }
                  Msg_Error[ 7 ] := Chr( 48 + Result );
                  Msg_Error[ 8 ] := Stage;
                  If VAddr > 0 Then
                    For CrsrX := 0 to 79 do
                      Begin
                        If CrsrX < 8 Then
                          Mem[ VAddr : CrsrX shl 1 ] :=
                            Ord( Msg_Error[ CrsrX + 1 ] )
                        Else
                          Mem[ VAddr : CrsrX shl 1 ] := 32;
                        Mem[ VAddr : CrsrX shl 1 + 1 ] := $F0;  { blink }
                      End;
                  { get keypress }
                  Regs.AH := 0;  Intr( NewVec, Regs );
                End;
              { restore current top line }
              If VAddr > 0 Then  { text mode }
                Move( SaveLn, Mem[ VAddr : $0000 ], 160 );
            { call displaced keyboard routine }
              Regs.AX := AX;  Regs.BX := BX;  Regs.CX := CX;
              Regs.DX := DX;
              Regs.BP := BP;  Regs.SI := SI;  Regs.DI := DI;
              Regs.DS := DS;  Regs.ES := ES;  Regs.Flags := Flags;
              Intr( NewVec, Regs );
            Until Regs.AX <> HotKey;  { hotkey restart }
          End;  { hot key }
        AX := Regs.AX;  BX := Regs.BX;  CX := Regs.CX;  DX := Regs.DX;
        BP := Regs.BP;  SI := Regs.SI;  DI := Regs.DI;
        DS := Regs.DS;  ES := Regs.ES;  Flags := Regs.Flags;
      End;  { not a residency check }
  End;

{------------------------------------------------------------------------}

Begin

  { check if help requested }
  If Mem[ PrefixSeg : $80 ] > 1 Then
    If Mem[ PrefixSeg : $82 ] = Ord( '?' ) Then
      Begin
        Regs.AH := $09;  { display string }
        Regs.DS := Seg( Msg_Help[ 1 ] );
        Regs.DX := Ofs( Msg_Help[ 1 ] );
        Intr( $21, Regs );  { display message }
        Halt( 1 );
      End
    Else
      Begin
        HotKeyChar := UpCase( Chr( Mem[ PrefixSeg : $82 ] ) );
        If Mem[ PrefixSeg : $80 ] > 3 Then
          Begin
            LogSpec[ 0 ] := Chr( Mem[ PrefixSeg : $80 ] - 3 );
            Move( Mem[ PrefixSeg : $84 ], LogSpec[ 1 ],
                  Ord( LogSpec[ 0 ] ) );
            For Loop := 1 to Length( LogSpec ) do
              LogSpec[ Loop ] := UpCase( LogSpec[ Loop ] );
          End;
        For Loop := 1 to 36 do
          If AltKeys[ Loop * 2 - 1 ] = HotKeyChar Then
            HotKey := Ord( AltKeys[ Loop * 2 ] ) shl 8;
        If HotKey = $8100 Then HotKeyChar := '0';
      End;

  { check if already resident }
  Regs.AX := $FFFF;
  Regs.CX := Ord( 'D' );  Regs.DX := Ord( 'O' );
  Intr( OldVec, Regs );
  If Regs.DX = $ABCD Then
    Begin
      { show already loaded message }
      Regs.AH := $09;  { display string }
      Msg_InUse[ 26 ] := Chr( Regs.SI );
      Regs.DS := Seg( Msg_InUse[ 1 ] );
      Regs.DX := Ofs( Msg_InUse[ 1 ] );
      Intr( $21, Regs );  { display message }
      Halt( 1 );
    End;

  { find a free vector }
  NewVec := $7F;
  Repeat
    Inc( NewVec );
    Regs.AH := $35;  { get vector }
    Regs.AL := NewVec;
    Intr( $21, Regs );
  Until ( ( Regs.ES = 0 ) and ( Regs.BX = 0 ) ) or ( NewVec = $F0 );
  If NewVec = $F0 Then Halt( 1 );

  { get current address of vector to be displaced }
  Regs.AH := $35;  { get vector }
  Regs.AL := OldVec;
  Intr( $21, Regs );

  { copy it to new vector }
  Regs.AH := $25;  { set vector }
  Regs.AL := NewVec;
  Regs.DS := Regs.ES;
  Regs.DX := Regs.BX;
  Intr( $21, Regs );

  { replace original with new address }
  {$F+}
  Regs.DS := Seg( TsrEntry );
  Regs.DX := Ofs( TsrEntry );
  {$F-}
  Regs.AH := $25;  { set vector }
  Regs.AL := OldVec;  { user procedure }
  Intr( $21, Regs );

  { show now loaded message }
  Regs.AH := $09;  { display string }
  Msg_Loaded := 'DO loaded.  Using ' + LogSpec + '.' +
                '  Alt-' + HotKeyChar + ' activates.$';
  Regs.DS := Seg( Msg_Loaded[ 1 ] );
  Regs.DX := Ofs( Msg_Loaded[ 1 ] );
  Intr( $21, Regs );  { display message }

  { exit but keep resident }
  Regs.AH := $31;     { keep }
  Regs.AL := 0;   { exit code }
  { size in pargraphs = ( code + data + stack bytes ) div 16 + 3 extra }
  Regs.DX := 438;
  Intr( $21, Regs );

End.


