{$A+,B-,D+,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 32768,90000,90000}

Uses Dos, Printer;

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  IniName : String[ 80 ] = 'FRACTAL.DAT';
  IniNameSet : Boolean = False;
  Color : Byte = 1;
  NumItsSet : Boolean = False;
  NumIts : LongInt = 0;
  Advice : Boolean = True;  { used to be optional }
  AnyLoaded : Boolean = False;
  Title : Boolean = False;
  UseMenu : Boolean = False;
  DoAll : Boolean = False;
  FractalNumSet : Boolean = False;
  SavePic : Boolean = False;
  FractalNum : LongInt = 0;
  PrevFractalNum : LongInt = 0;
  KeyCheckFreq : Word = 500;
  MaxFractal = 5;
  MaxLines = 12;
  LoCGA = $04;  HiCGA = $06;  Tandy1 = $09;  Tandy2 = $0A;  EGA = $0E;
  VideoMode : Byte = HiCGA;
  None = 0;  HPGL = 1;  HPLJ = 2;
  PrinterNum : Byte = None;
  PrinterOpen : Boolean = False;
  OutFileName : String[ 40 ] = 'PRN';
  DoShow : Boolean = False;
  DoGrid : Boolean = False;
  DoCalc : Boolean = False;
  BadFileNameSet : Set of Char =
      [ #0..#20, #128..#255, '.', '"', '/', '\', '[', ']',
        ':', '|', '<', '>', '+', '=', ';', ',', ' ' ];
  PictureSize : Word = 0;
  OffSides : LongInt = 0;
  TotalIts : LongInt = 0;
  CountPlotsOnly : Boolean = True;
  Loading : Boolean = False;
  AvgX : Real = 0.0;
  AvgY : Real = 0.0;
  MinX : Real = 1E37;
  MinY : Real = 1E37;
  MaxX : Real = -1E37;
  MaxY : Real = -1E37;

Type
  String2 = String[2];
  FractalSetRecord =
    Array [ 1 .. MaxLines ] of Record  A, B, C, D, E, F, P : Real;  End;
  WindowRecord =
    Record  X1, Y1, X2, Y2 : Real;  End;
  FractalDataRecord =
    Record
      Lines : Byte;
      Name : String[ 80 ];
      W : WindowRecord;
      Feature : FractalSetRecord;
    End;

Var
  FractalData : FractalDataRecord;
  ItLoop, LoopIts, Loop, Sweep, Limit : LongInt;
  Result, PrevY, AllLoop : Integer;
  WorldX1, WorldY1, WorldX2, WorldY2, WorldXFactor, WorldYFactor : Real;
  FrcX, FrcY : Real;
  DevXMax, DevYMax : Real;
  MaxColor : Byte;
  PrevMode : Byte;
  ExitSave : Pointer;
  Regs : Registers;
  Ch : Char;
  PrinterXFactor : Real;
  PrinterYFactor : Real;
  PrinterXMax : Real;
  PrinterYMax : Real;
  OutFile : Text;

Const
  PenWidthStr : String[3] = '3';
  PenWidth : Byte = 3;
  ConstantData : Array [ 1 .. MaxFractal ] of FractalDataRecord =
   ( ( Lines: 4;  Name:'COMET';
       W:( X1:0.0; Y1:0.0; X2:18.0; Y2:9.0 );
       Feature:(
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:1.0; F:0.0; P:0.01 ),
        ( A:0.85; B:0.4; C:-0.04; D:0.85; E:0.0; F:1.6; P:0.85 ),
        ( A:0.2; B:-0.26; C:0.23; D:0.22; E:0.0; F:1.6; P:0.07 ),
        ( A:-0.15; B:0.28; C:0.26; D:0.24; E:0.0; F:0.44; P:0.07 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ) ) ),
     ( Lines: 4;  Name:'FERN';
       W:( X1:-5.0; Y1:0.0; X2:4.0; Y2:12.0 );
       Feature:(
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:1.0; F:0.0; P:0.01 ),
        ( A:0.85; B:-0.03; C:0.03; D:0.85; E:0.0; F:1.6; P:0.85 ),
        ( A:0.2; B:-0.26; C:0.23; D:0.22; E:0.0; F:1.6; P:0.07 ),
        ( A:-0.15; B:0.28; C:0.26; D:0.24; E:0.0; F:0.44; P:0.07 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ) ) ),
     ( Lines: 4;  Name:'NEBULA';
       W:( X1:-0.15; Y1:-0.2; X2:0.57; Y2:0.57 );
       Feature:(
        ( A:0.1; B:0.42; C:-0.42; D:0.5; E:0.1; F:0.0; P:0.1  ),
        ( A:0.42; B:-0.42; C:0.42; D:0.42; E:0.1; F:0.2; P:0.42 ),
        ( A:0.42; B:0.42; C:-0.42; D:0.42; E:0.2; F:0.2; P:0.42 ),
        ( A:0.1; B:0.0; C:0.0; D:0.1; E:0.0; F:0.2; P:0.06 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ) ) ),
     ( Lines: 4;  Name:'SNAILS';
       W:( X1:-4.5; Y1:0.0; X2:1.5; Y2:4.0 );
       Feature:(
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:1.0; F:0.0; P:0.01 ),
        ( A:0.74; B:-0.43; C:0.43; D:0.74; E:0.0; F:1.6; P:0.85 ),
        ( A:0.2; B:-0.26; C:0.23; D:0.22; E:0.0; F:1.6; P:0.07 ),
        ( A:-0.15; B:0.28; C:0.26; D:0.24; E:0.0; F:0.44; P:0.07 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ) ) ),
     ( Lines: 4;  Name:'TREE';
       W:( X1:-0.3; Y1:0.0; X2:0.3; Y2:0.5 );
       Feature:(
        ( A:0.0; B:0.0; C:0.0; D:0.5; E:0.0; F:0.0; P:0.05 ),
        ( A:0.42; B:-0.42; C:0.42; D:0.42; E:0.0; F:0.2; P:0.4 ),
        ( A:0.42; B:0.42; C:-0.42; D:0.42; E:0.0; F:0.2; P:0.4 ),
        ( A:0.1; B:0.0; C:0.0; D:0.1; E:0.0; F:0.2; P:0.15 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ),
        ( A:0.0; B:0.0; C:0.0; D:0.0; E:0.0; F:0.0; P:0.0 ) ) ) );

{---------------------------------------------------------------------------}

Function WhereX : Byte;
  Begin
    Regs.AH := 3;         { function }
    Regs.BX := $0000;     { display page }
    Intr( $10, Regs );
    WhereX := Regs.DL + 1;    { returned x position }
  End;

{----------------------------------------------------------------}

Function WhereY : Byte;
  Begin
    Regs.AH := 3;         { function }
    Regs.BX := $0000;     { display page }
    Intr( $10, Regs );
    WhereY := Regs.DH + 1;    { returned x position }
  End;

{----------------------------------------------------------------}

Procedure GotoXY( X, Y : Word );
  Var
    Regs : Registers;
  Begin
    Regs.AH := $02;
    Regs.BH := 0;
    Regs.DL := X - 1;
    Regs.DH := Y - 1;
    Intr( $10, Regs );
  End;

{----------------------------------------------------------------}

Procedure Plot( X, Y, C : Word );
  Begin
    Regs.AH := 12;        { function }
    Regs.AL := C;         { color }
    Regs.CX := X;         { x coordinate }
    Regs.DX := Y;         { y coordinate }
    Intr( $10, Regs );
  End;

{----------------------------------------------------------------}

Function GetDot( X, Y : Word ) : Byte;
  Begin
    Regs.AH := 13;        { function }
    Regs.CX := X;         { x coordinate }
    Regs.DX := Y;         { y coordinate }
    Intr( $10, Regs );
    GetDot := Regs.AL;    { returned color }
  End;

{----------------------------------------------------------------}

Procedure Shade( CIndex, CShade : Byte );
  Begin
    Regs.AH := 16;        { function }
    Regs.AL := 0;
    Regs.BH := CShade;    { color shade }
    Regs.BL := CIndex;    { color number }
    Intr( $10, Regs );
    If CIndex <> 0 Then Exit;
    Regs.AH := 16;        { function }
    Regs.AL := 1;
    Regs.BH := CShade;    { color shade }
    Regs.BL := 0;         { color number }
    Intr( $10, Regs );
  End;

{----------------------------------------------------------------}

Function GetMode : Byte;
  Begin
    Regs.AH := 15;
    Intr( $10, Regs );
    GetMode := Regs.AL;
  End;

{----------------------------------------------------------------}

Procedure SetMode( ModeNum : Byte );
  Begin
    Regs.AH := 0;         { function }
    Regs.AL := ModeNum;   { video mode }
    Intr( $10, Regs );
    { Available modes:
        0=CO40, 1=BW40, 2=CO80, 3=BW80, 4=320x200x4,
        5=320x200x1, 6=640x200x1, 7=mono, D=320x200x16,
        E=640x200x16, F=640x350x4, 10=640x350x10 }
  End;

{----------------------------------------------------------------}

Procedure TextMode;
  Begin
    SetMode( PrevMode );
  End;

{----------------------------------------------------------------}

Function HexByte( B : Byte ) : String2;
  Const
    Hex : String[ 16 ] = '0123456789ABCDEF';
  Begin
    HexByte := Hex[ ( ( B and $F0 ) shr 4 ) + 1 ] +
               Hex[ ( B and $0F ) + 1 ];
  End;

{----------------------------------------------------------------}

Procedure TidyExit;
  Var
    TidyAddrPtr : Pointer;
    TidyAddr : Array [ 1..4 ] of Byte absolute TidyAddrPtr;
    TidyAddrHex : String[ 10 ];
    TidyCode : Integer;
  Begin
    ExitProc := ExitSave;
    TidyCode := ExitCode;
    TidyAddrPtr := ErrorAddr;
    TextMode;  Writeln( '' );
    TidyAddrHex :=
      HexByte( TidyAddr[ 4 ] ) + HexByte( TidyAddr[ 3 ] ) + ':' +
      HexByte( TidyAddr[ 2 ] ) + HexByte( TidyAddr[ 1 ] );
    If TidyCode = 255 Then
      Writeln( 'User break.' )
    Else
      If TidyCode > 0 Then
        Begin
          If TidyCode = 200 Then
            Write( 'Fatal error: division by zero' )
          Else
            If ( TidyCode = 201 ) or ( TidyCode = 205 ) or
               ( TidyCode = 206 ) or ( TidyCode = 207 ) Then
              Write( 'Fatal error: numeric overflow' )
            Else
              Write( 'Fatal error: #', TidyCode );
          Writeln( ' at address ', TidyAddrHex );
        End;
    Writeln;
    Halt( 2 );
  End;

{---------------------------------------------------------------------------}

Procedure ShowDomain;
  Var
    Wid, Hgt : Real;
    OnScn : LongInt;
  Begin
    If ( AnyLoaded ) and
       ( not DoAll ) and ( not DoShow ) and ( not DoCalc ) Then
      Begin
        Writeln( 'DOMAIN OF LAST FRACTAL GENERATED:' );
        Write( '  Fractal # ', PrevFractalNum, ', ' );
        If PrevFractalNum < 0 Then
          Write( ' (disk) ' )
        Else
          Write( ' (built in) ' );
        Writeln( FractalData.Name, ' :' );
        Writeln( '  Window: ',
                 FractalData.W.X1:1:5, ', ', 
                 FractalData.W.Y1:1:5, ' to ',
                 FractalData.W.X2:1:5, ', ',
                 FractalData.W.Y2:1:5 );
        Wid := Abs( FractalData.W.X2 - FractalData.W.X1 );
        Hgt := Abs( FractalData.W.Y2 - FractalData.W.Y1 );
        Writeln( '  Size: ', Wid:1:5, ' by ', Hgt:1:5, '    ',
                 'Grid: ', ( Wid / 10 ):1:5, ' by ', ( Hgt / 10 ):1:5 );
        Writeln( '  Transforms:' );
        For Loop := 1 to FractalData.Lines do
          With FractalData.Feature[ Loop ] do
            Writeln( '  ', A:13:5, B:10:5, C:10:5, D:10:5,
                           E:10:5, F:10:5, P:10:5 );
        If TotalIts < 1 Then
          Writeln( 'Not generated.' )
        Else
          Begin
            Write( '  Iterations: ', TotalIts - 1,
                   '  Off screen: ', OffSides );
            If OffSides < 1 Then
              Write( ' (0%)' )
            Else
              Write( ' (', ( ( OffSides / TotalIts ) * 100 ):1:0, '%)' );
            OnScn := TotalIts - 1 - OffSides;
            Write( '  On screen: ', OnScn );
            If OnScn < 1 Then
              Writeln( ' (0%)' )
            Else
              Writeln( ' (', ( ( OnScn / TotalIts ) * 100 ):1:0, '%)' );
            Writeln( '  Plots ranged:     ',
                     MinX:1:5, ', ', MinY:1:5, ' to ',
                     MaxX:1:5, ', ', MaxY:1:5 );
            Writeln( '  Center of range:  ',
                     ( ( MinX + MaxX ) / 2 ):1:5, ', ',
                     ( ( MinY + MaxY ) / 2 ):1:5 );
            AvgX := AvgX / ItLoop;
            AvgY := AvgY / ItLoop;
            Writeln( '  Average plot:     ', AvgX:1:5, ', ', AvgY:1:5 );
          End;
      End;
  End;

{---------------------------------------------------------------------------}

Procedure Stop( Msg : String );
  Begin
    ExitProc := ExitSave;
    If not Loading Then TextMode;
    If Msg <> '' Then
      Begin
        Writeln;  Writeln( Msg );  Writeln;
        Halt( 1 );
      End
    Else
      Begin
        ShowDomain;
        Halt;
      End;
  End;

{---------------------------------------------------------------------------}

Procedure ChkErr( Msg : String );
  Begin
    Result := IOResult;
    If Result <> 0 Then Stop( Msg );
  End;

{---------------------------------------------------------------------------}

Function KeyPressed : Boolean;
  Begin
    Regs.AH := $0B;
    MSDos( Regs );
    KeyPressed := Regs.AL = $FF;
  End;

{---------------------------------------------------------------------------}
Function GetKey : Char;
  Var
    Regs : Registers;
  Begin
    Regs.AH := $08;  { ConInputNoEcho }
    MsDos( Regs );
    GetKey := UpCase( Chr( Regs.AL ) );
  End;

{---------------------------------------------------------------------------}

Procedure EatKeys;
  Var
    EatCh : Char;
  Begin
    While KeyPressed do EatCh := GetKey;
  End;

{---------------------------------------------------------------------------}

Procedure WaitKey;
  Begin
    EatKeys;
    Ch := GetKey;
    EatKeys;
  End;

{---------------------------------------------------------------------------}

Procedure Dly( Dur : Integer );
  Var
    Regs : Registers;
    StartSec100, EndSec100, CurrSec100 : LongInt;
  Begin
    Regs.AH := $2C;  MSDos( Regs );  { get time }
    StartSec100 :=
      Regs.CH * 360000 + Regs.CL * 6000 + Regs.DH * 100 + Regs.DL;
    Dur := Dur div 10;
    EndSec100 := StartSec100 + Dur;
    Repeat
      Regs.AH := $2C;  MSDos( Regs );  { get time }
      CurrSec100 :=
        Regs.CH * 360000 + Regs.CL * 6000 + Regs.DH * 100 + Regs.DL;
    Until ( CurrSec100 >= EndSec100 ) or ( CurrSec100 < StartSec100 );
  End;

{---------------------------------------------------------------------------}

Procedure Strip( Var InLn : String );
  Begin
    While ( InLn[ 1 ]  = ' ' ) and ( InLn <> '' ) do
      Delete( InLn, 1, 1 );  { strip leading spaces }
    While ( InLn[ Length( InLn ) ] = ' ' ) and ( InLn <> '' ) do
      Delete( InLn, Length( InLn ), 1 );  { strip trailing spaces }
  End;

{---------------------------------------------------------------------------}

Procedure InputErr( Msg : String );
  Begin
    Write( Msg, ^G, #13 );  Dly( 900 );  Write( ' ':70, #13 );
    GotoXY( 1, PrevY );  Write( ' ':70, #13 );  Result := 1;
  End;

{---------------------------------------------------------------------------}

Procedure ReadNumLn( Msg : String;  Var OutNum : LongInt );
  Var
    ReadStr : String[ 20 ];
  Begin
    Repeat
      GotoXY( 1, PrevY );  Write( ' ':70, #13 );
      Write( Msg + ' > ' );
      Readln( ReadStr );  Strip( ReadStr );
      Val( ReadStr, OutNum, Result );
      If Result <> 0 Then InputErr( 'BAD INPUT' );
    Until Result = 0;
  End;

{---------------------------------------------------------------------------}

Procedure SetWorld( InX1, InY1, InX2, InY2 : Real );
  Begin
    WorldX1 := InX1;  WorldY1 := InY1;  WorldX2 := InX2;  WorldY2 := InY2;
    WorldXFactor := DevXMax / ( WorldX2 - WorldX1 );
    WorldYFactor := DevYMax / ( WorldY2 - WorldY1 );
  End;

{---------------------------------------------------------------------------}

Procedure SetPrinterWorld;
  Begin
    If PrinterNum = HPGL Then
      Begin
        PrinterXMax := 10000.0;
        PrinterYMax := 8000.0;
      End;
    If PrinterNum = HPLJ Then
      Begin
        PrinterXMax := 3180.0;
        PrinterYMax := 2250.0;
      End;
    PrinterXFactor := PrinterXMax / ( WorldX2 - WorldX1 );
    PrinterYFactor := PrinterYMax / ( WorldY2 - WorldY1 );
  End;

{---------------------------------------------------------------------------}

Procedure PrinterWrite( Data : String );
  Var
    OutResult : Integer;
  Begin
    If not PrinterOpen Then
      Begin
        Assign( OutFile, OutFileName );
        Append( OutFile );  OutResult := IOResult;
        If OutResult <> 0 Then
          Begin
            ReWrite( OutFile );  OutResult := IOResult;
          End;
        PrinterOpen := OutResult = 0;
        If not PrinterOpen Then
          Stop( 'Cannot access output device.' );
      End;
    Write( OutFile, Data );  OutResult := IOResult;
    If OutResult = 0 Then Exit;
    Stop( 'Output device not ready.' );
  End;

{---------------------------------------------------------------------------}

Procedure PrinterPlot( X, Y : Real );
  Var
    XStr, YStr : String[10];
  Begin
    X := ( X - WorldX1 ) * PrinterXFactor;
    Y := ( Y - WorldY1 ) * PrinterYFactor;
    Str( X:1:0, XStr );  Str( Y:1:0, YStr );
    If PrinterNum = HPLJ Then { x and y reversed for landscape printing }
      PrinterWrite( #27 + '*p' + YStr + 'X' +  { cursor at x }
                    #27 + '*p' + XStr + 'Y' +  { cursor at y }
                    #27 + '*c0P' );            { plot }
    If PrinterNum = HPGL Then
      Begin
        PrinterWrite( 'PU ' + XStr + ',' + YStr + ';' +  { pen up x, y }
                      'PD;' );  { pen down }
      End;
  End;

{---------------------------------------------------------------------------}

Procedure SetDot( X, Y : Real );
  Begin
    If Advice Then
      Begin
        If X < MinX Then MinX := X;  If Y < MinY Then MinY := Y;
        If X > MaxX Then MaxX := X;  If Y > MaxY Then MaxY := Y;
        AvgX := AvgX + X;  AvgY := AvgY + Y;
      End;
    If ( X < WorldX1 ) or ( X > WorldX2 ) or
       ( Y < WorldY1 ) or ( Y > WorldY2 ) Then
      Begin
        Inc( OffSides );
        Exit;
      End;
    If PrinterNum <> None Then PrinterPlot( X, Y );
    X := ( X - WorldX1 ) * WorldXFactor;
    Y := ( DevYMax - 1 ) - ( Y - WorldY1 ) * WorldYFactor;
    If VideoMode <> HiCGA Then
      Begin
        Color := GetDot( Trunc( X ), Trunc( Y ) );
        If Color < MaxColor Then Inc( Color );
      End;
    Plot( Trunc( X ), Trunc( Y ), Color )
  End;

{---------------------------------------------------------------------------}

Procedure Iterate;
  Var
    Delta : Byte;
    R, Prob, NewX, NewY : Real;
  Begin
    With FractalData do
      Begin
        R := Random;  Prob := Feature[ 1 ].P;  Delta := 1;
        While ( R > Prob ) and ( Delta < Lines ) do
          Begin
            Inc( Delta );
            Prob := Prob + Feature[ Delta ].P;
          End;
        With Feature[ Delta ] do
          Begin
            NewX := A * FrcX + B * FrcY + E;
            NewY := C * FrcX + D * FrcY + F;
          End;
        FrcX := NewX;  FrcY := NewY;
        SetDot( FrcX, FrcY );
      End;
  End;

{---------------------------------------------------------------------------}

Procedure SwirlColors;
  Var
    SwirlFactor, ShadeLoop, SwirlLoop : Byte;
  Begin
    ShadeLoop := 0;
    While ( not KeyPressed ) and
          ( VideoMode <> HiCGA ) and ( ShadeLoop <= MaxColor ) do
      Begin
        If VideoMode = EGA Then SwirlFactor := 16;
        If VideoMode = Tandy1 Then SwirlFactor := 1;
        If VideoMode in [ LoCGA, Tandy2 ] Then SwirlFactor := 4;
        For SwirlLoop := 1 to MaxColor do
          Begin
            Shade( SwirlLoop, (SwirlLoop-1) * SwirlFactor + ShadeLoop );
            Dly( 56 );
          End;
        Inc( ShadeLoop );
      End;
  End;

{---------------------------------------------------------------------------}

Procedure SavePicture;
  Var
    PicFile : File;
    NameLoop : Byte;
    FileName : String[ 20 ];
  Begin
    If PictureSize = 0 Then Exit;
    FileName := '';  NameLoop := 0;
    While ( NameLoop < Length( FractalData.Name ) ) and
          ( Length( FileName ) < 8 ) do
      Begin
        Inc( NameLoop );
        If not ( FractalData.Name[ NameLoop ] in BadFileNameSet ) Then
          FileName := FileName + FractalData.Name[ NameLoop ];
      End;
    If FileName = '' Then FileName := 'NONAME';
    FileName := FileName + '.FRC';
    Assign( PicFile, FileName );
    ReWrite( PicFile, PictureSize );
    ChkErr( 'Cannot create picture file.' );
    BlockWrite( PicFile, Mem[ $B800 : $0000 ], 1 );
    ChkErr( 'Trouble writing picture file.' );
    Close( PicFile );  ChkErr( 'Trouble closing picture file.' );
  End;

{---------------------------------------------------------------------------}

Procedure LoadFractal( LoadNum : LongInt );
  Var
    FFile : Text;
    DataSet, Counter, LineCnt : Word;
    JunkResult : Integer;
    InLn : String;
    BlankLine : Boolean;
  Procedure ShowStat;
    Begin
      Inc( LineCnt );
      Write( #13, 'Fractal ', Counter, ', line ', LineCnt );
    End;
  Procedure ReadNum( Var R:Real );
    Var
      InVal : String[20];
    Begin
      Strip( InLn );
      If EOF( FFile ) Then Stop( 'Unexpected end of data file.' );
      If InLn = '' Then Stop( 'Value missing in data file.' );
      InVal := '';
      { grab next number }
      While ( InLn <> '' ) and
            ( InLn[ 1 ] in [ '-', '.', '0'..'9' ] ) do
        Begin
          InVal := InVal + InLn[ 1 ];
          Delete( InLn, 1, 1 );
        End;
      { clear space to next number }
      While ( InLn <> '' ) and
            ( not ( InLn[ 1 ] in [ '-', '.', '0'..'9' ] ) ) do
        Delete( InLn, 1, 1 );
      Val( InVal, R, Result );
      If Result <> 0 Then Stop( 'Trouble reading data file.' );
    End;
  Begin
    Loading := True;
    With FractalData do
      Begin
        Assign( FFile, IniName );
        Reset( FFile );  ChkErr( 'Data file not found: ' + IniName );
        Writeln( 'Scanning data file ' + IniName + ' . . .' );
        LineCnt := 0;  Counter := 0;  ShowStat;  InLn := '';
        Repeat
          Inc( Counter );
          { skip blank lines and comments }
          While ( not EOF( FFile ) ) and
                ( ( InLn = '' ) or ( Copy( InLn, 1, 1 ) = ';' ) ) do
            Begin
              ReadLn( FFile, InLn );  ChkErr( 'Trouble reading name.' );
              Strip( InLn );  ShowStat;
            End;
          { skip over data lines if not target fractal }
          If Counter < LoadNum Then
            While ( not EOF( FFile ) ) and ( InLn <> '' ) do
              Begin  { get name }
                ReadLn( FFile, InLn );  ChkErr( 'Trouble scanning name.' );
                Strip( InLn );  ShowStat;
              End;
        Until EOF( FFile ) or ( Counter >= LoadNum );
        If EOF( FFile ) Then
          If DoAll Then
            Stop( 'Done.' )
          Else
            Stop( 'Cannot find requested fractal.' );
        FillChar( FractalData, SizeOf( FractalData ), 0 );
        Name := InLn;
        { get line to be parsed, skipping comments }
        Repeat
          ReadLn( FFile, InLn );  ChkErr( 'Trouble reading window.' );
          ShowStat;
        Until ( Copy( InLn, 1, 1 ) <> ';' ) or EOF( FFile );
        ReadNum( W.X1 );  ReadNum( W.Y1 );
        ReadNum( W.X2 );  ReadNum( W.Y2 );
        DataSet := 1;
        BlankLine := False;
        While not BlankLine do
          Begin
            { get line to be parsed, skipping comments }
            Repeat
              ReadLn( FFile, InLn );  ChkErr( 'Trouble reading transform.' );
              Strip( InLn );  ShowStat;
            Until ( InLn = '' ) or
                  ( Copy( InLn, 1, 1 ) <> ';' ) or EOF( FFile );
            BlankLine := InLn = '';
            If not BlankLine Then
              Begin
                If DataSet > MaxLines Then
                  Stop( 'Too many transforms in data.' );
                ReadNum( Feature[ DataSet ].A );
                ReadNum( Feature[ DataSet ].B );
                ReadNum( Feature[ DataSet ].C );
                ReadNum( Feature[ DataSet ].D );
                ReadNum( Feature[ DataSet ].E );
                ReadNum( Feature[ DataSet ].F );
                ReadNum( Feature[ DataSet ].P );
                Lines := DataSet;  Inc( DataSet );
              End;
          End;  { data set loop }
        Close( FFile );
        ChkErr( 'Closing data file.' );
      End;  { with }
    AnyLoaded := True;
    Loading := False;
 End;

{---------------------------------------------------------------------------}

Function FileExists( FileName : String ) : Boolean;
  Var
    ChkFile : File;
    ChkResult : Integer;
  Begin
    Assign( ChkFile, FileName );
    Reset( ChkFile );  ChkResult := IOResult;
    FileExists := ChkResult = 0;
    Close( ChkFile );  ChkResult := IOResult;
  End;

{---------------------------------------------------------------------------}

Procedure ReadOptions;
  Var
    ParamLoop, Spare : LongInt;
    PenStr, ItStr, Param : String[ 20 ];
    Result, UCLp : Integer;
    Found : Boolean;
  Begin
    ParamLoop := 1;
    While ParamLoop <= ParamCount do
      Begin  { param loop }
        Found := False;
        Param := ParamStr( ParamLoop );
        For UCLp := 1 to Length( Param ) do
          Param[ UCLp ] := UpCase( Param[ UCLp ] );
        { check for fractal number }
        Val( Param, Spare, Result );
        If Result = 0 Then
          If ( Spare = 0 ) or ( Spare > MaxFractal ) Then
            Stop( 'Invalid fractal number: ' + Param )
          Else
            Begin
              FractalNumSet := True;  FractalNum := Spare;
              Found := True;
            End;
        If ( not Found ) and ( Param = '/A' ) Then
          Begin
            Found := True;  DoAll := True;
          End;
        If ( not Found ) and ( Copy( Param, 1, 2 ) = '/V' ) Then
          Begin
            Found := True;
            If Param = '/VH' Then
              VideoMode := HiCGA
            Else
              If Param = '/VL' Then
                VideoMode := LoCGA
              Else
                If Param = '/VE' Then
                  VideoMode := EGA
                Else
                  If Param = '/VT1' Then
                    VideoMode := Tandy1
                  Else
                    If Param = '/VT2' Then
                      VideoMode := Tandy2
                    Else
                      Stop( 'Unknown video mode: ' + Param );
          End;
        If ( not Found ) and
           ( ( Param = '/HPGL' ) or ( Param = '/HPLJ' ) ) Then
          Begin  { printer select }
            If Param = '/HPGL' Then PrinterNum := HPGL;
            If Param = '/HPLJ' Then PrinterNum := HPLJ;
            If ( ParamLoop < ParamCount ) Then
              If Copy( ParamStr( ParamLoop + 1 ), 1, 1 ) <> '/' Then
                Begin
                  { check for valid pen width setting }
                  PenStr := ParamStr( ParamLoop + 1 );
                  Val( PenStr, Spare, Result );
                  If Result = 0 Then
                    Begin
                      If ( Spare < 1 ) and ( Spare > 48 ) Then
                        Stop( 'Invalid pen width value: ' + PenStr )
                      Else
                        Begin
                          Inc( ParamLoop );  { consume param }
                          Found := True;
                          PenWidthStr := PenStr;  PenWidth := Spare;
                        End;
                    End;
                  { check for output file name }
                  If not Found Then
                    If Copy( ParamStr( ParamLoop + 1 ), 1, 1 ) <> '/' Then
                      Begin
                        OutFileName := ParamStr( ParamLoop + 1 );
                        If Param[ UCLp ] in BadFileNameSet Then
                          Stop( 'Bad output device: ' + Param );
                        For UCLp := 1 to Length( Param ) do
                          If Param[ UCLp ] in BadFileNameSet Then
                            Stop( 'Bad output device: ' + Param );
                        Inc( ParamLoop );  { consume param }
                        Found := True;
                      End;  { out dev }
                End;  { printer options }
          End;  { printer select }
        If ( not Found ) and ( Param = '/N' ) Then
          Begin
            Found := True;  Title := True;
          End;
        If ( not Found ) and ( Param = '/S' ) Then
          Begin
            Found := True;  SavePic := True;
          End;
        If ( not Found ) and ( Param = '/SHOW' ) Then
          Begin
            Found := True;  DoShow := True;
          End;
        If ( not Found ) and ( Param = '/G' ) Then
          Begin
            Found := True;  DoGrid := True;
          End;
        If ( not Found ) and ( Param = '/CALC' ) Then
          Begin
            Found := True;  DoCalc := True;
          End;
        { check for iterations value }
        If ( not Found ) and ( Param[ 1 ] = '/' ) and
           ( Length( Param ) > 1 ) Then
          Begin
            ItStr := Param;
            Delete( ItStr, 1, 1 );
            Val( ItStr, Spare, Result );
            If Result = 0 Then
              If ( Spare <> 0 ) and ( Abs( Spare ) <= 1E8 ) Then
                Begin
                  NumItsSet := True;  Found := True;
                  NumIts := Spare;
                End
              Else
                Stop( 'Invalid iterations: ' + ItStr );
          End;
        { last resort, may be file name }
        If not Found Then
          Begin
            IniName := Param;
            IniNameSet := True;
            Found := True;
          End;
        If not Found Then Stop( 'Invalid parameter: ' + Param );
        Inc( ParamLoop );
      End;  { param loop }
    DevYMax := 200.0;
    Case VideoMode of
      LoCGA:
        Begin
          PictureSize := 16384;
          DevXMax := 320.0;  MaxColor := 3;
        End;
      HiCGA:
        Begin
          PictureSize := 16384;
          DevXMax := 640.0;  MaxColor := 1;
        End;
      EGA:
        Begin
          PictureSize := 0;
          DevXMax := 640.0;  MaxColor := 15;
        End;
      Tandy1:
        Begin
          PictureSize := 0;
          DevXMax := 320.0;  MaxColor := 15;
        End;
      Tandy2:
        Begin
          PictureSize := 0;
          DevXMax := 640.0;  MaxColor := 3;
          Shade( 1, 9 );  Shade( 2, 12 );  Shade( 3, 15 );
        End;
     End;  { case }
  End;

{---------------------------------------------------------------------------}

Procedure Help;
  Begin
    For CpyRtLp := 1 to 26 do
      If CpyRtLp = 1 Then
        CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
      Else
        CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                 Ord( CpyRt[ CpyRtLp - 1 ] ) );
    Writeln( 'FRACTAL ver 3.1 rev 91/07/10 - ', CpyRt, '.' );
    Writeln( 'Fractal image generation and display.' );
    Writeln( '  Algorithm developed by Peter Heimberg.' );
    Writeln( 'FRACTAL [options]   (omit options for menu)' );
    Writeln( '  n    Select a fractal to generate by number.' );
    Writeln( '  fn   Use data file Fn.' );
    Writeln( '  /n   Specify number of iterations to plot.' );
    Writeln( '         Use /-n to count only on screen plots.' );
    Writeln( '  /A   Draw all fractals in data file [starting at n].' );
    Writeln( '  /G   Superimpose 10x10 grid on finished picture.' );
    Writeln( '  /N   Superimpose fractal name on finished picture.' );
    Writeln( '  /S   Save picture to disk (/VH and /VL modes only).' );
    Writeln( '  /VH /VL /VE /VT1 /VT2   Video mode:' );
    Writeln( '     640x200x2 CGA (default), 320x200x4 CGA,' );
    Writeln( '     640x200x16 EGA, 320x200x16 Tandy, 640x200x4 Tandy' );
    Writeln( '  /HPLJ {or} /HPGL [n] [fn]   Print to Laser or Plotter:' );
    Writeln( '     n   Set pen width (default 3)' );
    Writeln( '     fn  Set output destination (default PRN)' );
    Writeln( '  /SHOW [fn] [n] [[/G] [/Vx]]   Show saved pictures:' );
    Writeln( '     fn  Picture name if file size same as screen size,' );
    Writeln( '           else list of picture names (default FRACTAL.SCR)' );
    Writeln( '     n   Pause n/100 seconds between frames (default 0)' );
    Writeln( '  /CALC [fn]   Follow prompts to generate mutation sequence.' );
    Halt( 1 );
  End;

{---------------------------------------------------------------------------}

Procedure DrawGrid;
  Var
    GridXGap, GridYGap, GridXLoop, GridYLoop : Integer;
  Begin
    GridXGap := Round( DevXMax / 10 );
    GridYGap := Round( DevYMax / 10 );
    GridXLoop := 0;
    While GridXLoop <= DevXMax - 1 do
      Begin
        For GridYLoop := 0 to Round( DevYMax ) do
          Plot( GridXLoop, GridYLoop, 1 );
        GridXLoop := GridXLoop + GridXGap;
      End;
    GridYLoop := 0;
    While GridYLoop <= DevYMax - 1 do
      Begin
        For GridXLoop := 0 to Round( DevXMax ) do
          Plot( GridXLoop, GridYLoop, 1 );
        GridYLoop := GridYLoop + GridYGap;
      End;
  End;

Procedure SelectFractal;
  Var
    FFile : Text;
    Row, LastDiskFractal : Integer;
    InName : String[ 20 ];
    JumpEnd, TitlePut : Boolean;
  Begin
    UseMenu := True;  JumpEnd := False;  TextMode;  Row := 2;
    Writeln( 'ENTER A NUMBER TO SELECT A FRACTAL:' );  Writeln;
    Writeln( 'BUILT IN:' );
    For Loop := 1 to MaxFractal do
      Writeln( Loop:6, ' ', ConstantData[ Loop ].Name );
    Assign( FFile, IniName );
    Reset( FFile );  Result := IOResult;
    TitlePut := False;
    LastDiskFractal := 0;  InName := '';
    While ( Result = 0 ) and ( not EOF( FFile ) ) do
      Begin
        While ( ( InName = '' ) or ( Copy( InName, 1, 1 ) = ';' ) ) and
              ( Result = 0 ) and ( not EOF( FFile ) ) do
          Begin  { get name }
            ReadLn( FFile, InName );  Result := IOResult;  Strip( InName );
          End;
        If ( Result = 0 ) and ( not EOF( FFile ) ) Then
          Begin
            Dec( LastDiskFractal );  Inc( Row );
            If Row > 17 Then
              Begin
                If not JumpEnd Then
                  Begin
                    Write( 'PRESS <SPACE> TO CONTINUE, <ENTER> TO JUMP ',
                           'TO END, OR <ESC> TO QUIT . . .' );
                    WaitKey;
                    If Ch = #27 Then Stop( '' );
                    JumpEnd := Ch = #13;
                  End;
                TextMode;  Row := 1;
                Writeln( 'ENTER A NUMBER TO SELECT A FRACTAL:' );  Writeln;
              End;
            If not TitlePut Then
              Writeln( 'IN DISK FILE (' + IniName + '):' );
            TitlePut := True;
            Writeln( LastDiskFractal:6, ' ', InName );
          End;
        While ( InName <> '' ) and ( Result = 0 ) and ( not EOF( FFile ) ) do
          Begin  { read to next name }
            ReadLn( FFile, InName );  Result := IOResult;  Strip( InName );
          End;
      End;
    Close( FFile );  Result := IOResult;
    Writeln;  PrevY := WhereY;
    Repeat
      ReadNumLn( 'Enter fractal number (0=quit)', FractalNum );
      If FractalNum = 0 Then Exit;
      If ( FractalNum > MaxFractal ) or
         ( FractalNum < LastDiskFractal ) Then
        InputErr( 'VALUE OUT OF RANGE' );
    Until Result = 0;
  End;

{---------------------------------------------------------------------------}

Procedure Generate;
  Begin
    FrcX := 0.0;  FrcY := 0.0;
    AvgX := 0.0;  AvgY := 0.0;
    MinX := 1E37;  MinY := 1E37;  MaxX := -1E37;  MaxY := -1E37;
    OffSides := 0;
    SetWorld( FractalData.W.X1, FractalData.W.Y1,
              FractalData.W.X2, FractalData.W.Y2 );
    If PrinterNum <> None Then SetPrinterWorld;
    Randomize;
    SetMode( VideoMode );
    If GetMode <> VideoMode Then
      Stop( 'This computer does not support requested graphics mode.' );
    If Title Then
      Begin  GotoXY( 1, 1 );  Write( FractalData.Name );  End;
    If PrinterNum = HPGL Then   { pen width }
      PrinterWrite( 'SP ' + PenWidthStr + ';' );
    If PrinterNum = HPLJ Then   { initialize, pen width }
      PrinterWrite( #27 + 'E' +      { reset }
                    #27 + '*t300R' + { set 300dpi resolution }
                    #27 + '&l0E' +   { top margin is 0 lines }
                    #27 + '&l66F' +  { page length is 66 lines }
                    #27 + '*c' + PenWidthStr + 'A' +   { pen height }
                    #27 + '*c' + PenWidthStr + 'B' );  { pen width }
    ItLoop := 1;
    While ( ( ( not CountPlotsOnly ) and ( ItLoop <= LoopIts ) ) or
            ( CountPlotsOnly and ( ItLoop <= LoopIts + OffSides ) ) ) and
          ( not KeyPressed ) do
      Begin
        For Sweep := 1 TO Limit do Iterate;
        If ( PrinterNum <> None ) and
           ( not SavePic ) and ( not Title ) Then
          Begin
            GotoXY( 1, 1 );  Write( ItLoop );
          End;
        ItLoop := ItLoop + Limit;
      End;
    TotalIts := ItLoop;
    If Title Then
      Begin
        GotoXY( 1, 1 );  Write( FractalData.Name + '!' );
      End
    Else
      Write( ^G );
    If DoGrid Then DrawGrid;
    If SavePic and ( VideoMode <> EGA ) Then SavePicture;
    If PrinterNum = HPGL Then PrinterWrite( 'PG;' );  { form feed }
    If PrinterNum = HPLJ Then PrinterWrite( #12 );  { form feed }
  End;

{---------------------------------------------------------------------------}

Procedure ShowPics;
  Const
    GoReverse : Boolean = False;  { current direction }
    Time : Byte = 0;
    MaxPics = 1000;
  Type
    FileNameArray = Array [ 1..MaxPics ] of String[ 50 ];
  Var
    Loop, Files, FileLoop, Result : Integer;
    FileName : ^FileNameArray;
    SaveScreen : Array [ 1..16384 ] of Byte;
    Ch : Char;
    Regs : Registers;
  Procedure LoadPic( FileName : String );
    Var
      PicFile : File;
    Begin
      If PictureSize = 0 Then
        Stop( 'Picture load not supported in selected video mode.' );
      Assign( PicFile, FileName );
      Reset( PicFile, PictureSize );
      ChkErr( 'Picture ' + FileName + ' not found.' );
      { buffer picture for smoother draw if any delay specified }
      If Time = 0 Then
        BlockRead( PicFile, Mem[ $B800 : $0000 ], 1 )
      Else
        BlockRead( PicFile, SaveScreen, 1 );
      ChkErr( 'Trouble reading picture: ' + FileName  );
      Close( PicFile );
      ChkErr( 'Trouble closing picture: ' + FileName  );
      If Time <> 0 Then
        Move( SaveScreen, Mem[ $B800 : 0000 ], PictureSize );
      If DoGrid Then DrawGrid;
    End;
  Procedure LoadScript;
    Var
      ScrFile : Text;
      ScrResult : Integer;
      InLn : String;
      Dir : SearchRec;
      Path : String[67];
      Name : string[8];
      Ext : string[4];
    Begin  { load script procedure }
      FillChar( FileName^, SizeOf( FileName^ ), 0 );  Files := 0;
      FSplit( IniName, Path, Name, Ext );
      FindFirst( Path + Name + Ext, AnyFile, Dir );
      If ( DosError = 0 ) and ( Dir.Size = PictureSize ) and
         ( ( Length( IniName ) < 4 ) or
           ( Copy( IniName, Length( IniName ) - 3, 4 ) <> '.SCR' ) ) Then
        Begin  { load without script }
          While DosError = 0 do
            Begin
              If Files > MaxPics Then Stop( 'Too many pictures.' );
              Inc( Files );
              FileName^[ Files ] := Path + Dir.Name;
              FindNext( Dir );
            End;
        End  { load without script }
      Else
        Begin  { load script }
          Assign( ScrFile, IniName );
          Reset( ScrFile );  ScrResult := IOResult;
          If ScrResult = 0 Then
            Begin  { open ok }
              While not EOF( ScrFile ) do
                Begin  { not eof }
                  ReadLn( ScrFile, InLn );
                  ChkErr( 'Trouble reading script.' );
                  Strip( InLn );
                  If ( InLn <> '' ) and ( Copy( InLn, 1, 1 ) <> ';' ) Then
                    Begin  { line ok }
                      Inc( Files );
                      If Files > MaxPics Then Stop( 'Too many pictures.' );
                      FileName^[ Files ] := InLn;
                    End;  { line ok }
                End;  { not eof }
              Close( ScrFile );  ChkErr( 'Trouble closing script.' );
            End;  { open ok }
        End;  { load script }
    End;  { load script procedure }
  Procedure DoShowPics;
    Begin
      FileLoop := 1;
      While ( not KeyPressed ) and
            ( FileLoop >= 1 ) and ( FileLoop <= Files ) do
        Begin
          If FileName^[ FileLoop ] = '*REPEAT' Then
            FileLoop := 1;
          If FileName^[ FileLoop ] = '*REVERSE' Then
            Begin
              GoReverse := True;
              Dec( FileLoop );
            End;
          LoadPic( FileName^[ FileLoop ] );
          Loop := 1;
          While ( Loop > 0 ) and ( Loop <= Time - 1 ) and
                ( not KeyPressed ) do
            Begin
              Inc( Loop );  Dly( 10 );
            End;
          If GoReverse Then
            Dec( FileLoop )
          Else
            Inc( FileLoop );
          If FileLoop = 0 Then
            Begin
              GoReverse := False;  FileLoop := 1;
            End;
          If FileLoop >= Files Then
            Repeat Until KeyPressed;
        End;
    End;
  Begin
    If not IniNameSet Then IniName := 'FRACTAL.SCR';
    If FractalNumSet Then Time := Lo( FractalNum );
    New( FileName );
    LoadScript;
    If Files = 0 Then Stop( 'No pictures available.' );
    SetMode( VideoMode );
    If VideoMode in [ LoCGA, Tandy2 ] Then
      Begin
        Shade( 1, 9 );  Shade( 2, 12 );  Shade( 3, 15 );
      End;
    DoShowPics;
    While KeyPressed do Ch := GetKey;
    TextMode;
  End;

{---------------------------------------------------------------------------}

Procedure FracCalc;
  Var
    A, B, C, D, E, F, P, X1, Y1, X2, Y2, N, L : Real;
    Loop, FileNum, Result, StartNum, EndNum : Integer;
    Data1, Data2 : FractalDataRecord;
    OutFile : Text;
  Const
    OutName = 'FRACTAL.SEQ';
  Function Dif( R1, R2 : Real ) : Real;
    Begin
      Dif := R2 + ( ( R1 - R2 ) / L ) * N;
    End;
  Begin
    Writeln( 'This utility takes the data set for two fractals,' );
    Writeln( 'and gradually mutates the first into the second.' );
    Writeln( 'The mutation is a simple linear progression.' );
    Writeln( 'The output is a sequence of intermediate fractal data sets' );
    Writeln( 'which are appended to the disk file "', OutName , '".' );
    Writeln;
    If FileExists( OutName ) Then
      Write( 'Appending to' )
    Else
      Write( 'Creating' );
    Writeln( ' output file ' + OutName );
    Writeln;
    Assign( OutFile, OutName );
    Append( OutFile );  Result := IOResult;
    If Result <> 0 Then
      Begin
        ReWrite( OutFile );
        ChkErr( 'Cannot create ' + OutName );
      End;
    Repeat
      Write( 'Enter starting fractal number > ' );
      ReadLn( StartNum );
      Result := IOResult;
    Until ( Result = 0 ) and ( StartNum <> 0 );
    Writeln;
    If StartNum > 0 Then
      FractalData := ConstantData[ StartNum ]
    Else
      LoadFractal( Abs( StartNum ) );
    Data1 := FractalData;
    Writeln;
    Repeat
      Writeln;
      Write( 'Enter ending fractal number > ' );
      ReadLn( EndNum );
      Result := IOResult;
    Until ( Result = 0 ) and ( EndNum <> 0 );
    Writeln;
    If StartNum > 0 Then
      FractalData := ConstantData[ EndNum ]
    Else
      LoadFractal( Abs( EndNum ) );
    Data2 := FractalData;
    Writeln;
    Writeln( 'Sequence ', Data1.Name, ' to ', Data2.Name );
    N := 1;  FileNum := 1;
    Repeat
      Writeln;
      Write( 'Enter number of frames > ' );
      ReadLn( L );
    Until ( Result = 0 ) and ( L > 1 );
    Writeln;
    While N <= L do
      Begin
        Write( N:1:0, #13 );
        Writeln( OutFile, Data1.Name, FileNum );
        ChkErr( 'Trouble writing to file: ' + OutName + '.' );
        Writeln( OutFile, Dif( Data2.W.X1, Data1.W.X1 ):10:5,
                 Dif( Data2.W.Y1, Data1.W.Y1 ):10:5,
                 Dif( Data2.W.X2, Data1.W.X2 ):10:5,
                 Dif( Data2.W.Y2, Data1.W.Y2 ):10:5 );
        ChkErr( 'Trouble writing to file: ' + OutName + '.' );
        For Loop := 1 to 4 do
          Begin
            Writeln( OutFile,
                     Dif( Data2.Feature[ Loop ].A,
                          Data1.Feature[ Loop ].A ):10:5,
                     Dif( Data2.Feature[ Loop ].B,
                          Data1.Feature[ Loop ].B ):10:5,
                     Dif( Data2.Feature[ Loop ].C,
                          Data1.Feature[ Loop ].C ):10:5,
                     Dif( Data2.Feature[ Loop ].D,
                          Data1.Feature[ Loop ].D ):10:5,
                     Dif( Data2.Feature[ Loop ].E,
                          Data1.Feature[ Loop ].E ):10:5,
                     Dif( Data2.Feature[ Loop ].F,
                          Data1.Feature[ Loop ].F ):10:5,
                     Dif( Data2.Feature[ Loop ].P,
                          Data1.Feature[ Loop ].P ):10:5 );
            ChkErr( 'Trouble writing to file: ' + OutName + '.' );
          End;
        Writeln( OutFile );
        ChkErr( 'Trouble writing to file: ' + OutName + '.' );
        N := N + 1.0;  Inc( FileNum );
      End;
    Close( OutFile );
    ChkErr( 'Trouble closing file: ' + OutName + '.' );
  End;

{---------------------------------------------------------------------------}

Begin
  If ( ParamCount > 0 ) and ( ParamStr( 1 ) = '?' ) Then Help;
  {$F+}
  ExitSave := ExitProc;
  ExitProc := @TidyExit;
  {$F-}
  PrevMode := GetMode;
  EatKeys;
  ReadOptions;
  If DoShow Then
    Begin
      ShowPics;
      Halt;
    End;
  If DoCalc Then
    Begin
      FracCalc;
      Halt;
    End;
  Repeat
    TextMode;
    If ( not DoAll ) and
       ( ( FractalNum = 0 ) or ( not FractalNumSet ) ) Then
      SelectFractal;
    If ( FractalNum <> 0 ) and ( not DoAll ) Then
      Begin
        If FractalNum > 0 Then
          FractalData := ConstantData[ FractalNum ]
        Else
          LoadFractal( Abs( FractalNum ) );
        PrevFractalNum := FractalNum;
      End;
    If ( FractalNum <> 0 ) and
       ( ( NumIts = 0 ) or ( not NumItsSet ) ) Then
      Repeat
        TextMode;
        Write( 'Fractal # ', FractalNum, ', ' );
        If FractalNum < 0 Then
          Write( ' (disk) ' )
        Else
          Write( ' (built in) ' );
        Writeln( FractalData.Name, ' :' );  Writeln;  PrevY := WhereY;
        ReadNumLn( 'Enter number of iterations (0=quit)', NumIts );
      Until NumIts >= 0;
    If ( not DoAll ) and
       ( ( FractalNum = 0 ) or ( NumIts = 0 ) ) Then Stop( '' );
    CountPlotsOnly := NumIts < 0;
    LoopIts := Abs( NumIts );
    If LoopIts > KeyCheckFreq Then
      Limit := KeyCheckFreq
    Else
      Limit := LoopIts;
    AllLoop := Abs( FractalNum );
    If not DoAll Then
      Begin
        Generate;
        EatKeys;  While not KeyPressed do SwirlColors;
      End
    Else
      While ( AllLoop < 32767 ) and ( not KeyPressed ) do
        Begin
          LoadFractal( AllLoop );
          Generate;  TextMode;  Inc( AllLoop );
        End;
    EatKeys;  TextMode;
  Until not UseMenu;
  Stop( '' );
End.



