{$A+,B-,D-,E-,F-,I+,L-,N-,O-,R-,S-,V-}
{$M 32000,0,0}

Program Gobble;

Uses Crt;

Type
   Screen_Row = String[ 80 ];
   String80 = String[ 80 ];

Const
   CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
   CpyRtLp : Byte = 1;
   Version = '3.1';
   Revision = '91/06/29';
   Random_Factor : Integer = 4;
   Random_Flip : Integer = 2;
   Enemy_Dur : Integer = 13;
   Self_Dur : Integer = 10;
   Lives_Max_Default : Integer = 3;
   Overall_Dur_Default : Integer = 1;
   Silent_Flag_Default : Boolean = False;
   Main_Loop_Delay : Integer = 4;
      { DELAY ADDED ON EACH OVERALL COUNTDOWN, IF OVERALL_DUR > 0 }
   Blink_Adjust : Integer = 0;
      { ADDED TO BLINK_COUNT EACH SELF UPDATE, IF SELF MOVING }
   No_Move_Delay : Integer = 60;
      { DELAY ADDED TO SELF UPDATE IF SELF NOT MOVING }
   Self : Char = ^B;
   Maximum_Enemies = 15;
   Bright : Byte = $0F;
   Dim : Byte = $07;
   Background : Byte = $00;
   Offense_Dur : Integer = 1800;
   Blink_Threshold : Integer = 700;
   Blink_Dur : Integer = 100;
   First_Blink_Dur : Integer = 1000;
   Pellet_Score : Integer = 10;
   Power_Score : Integer = 1000;
   Prize_Score : Integer = 10000;
   Enemy_Score : Integer = 2000;
   First_Level_Default : Byte = 1;
   QuitKeys = [ #27, ^C ];
   HighScoreFileSpec = 'GOBBLE.HIS';

Var
   Con : Text;
   Lives_Max : Integer;
   Overall_Dur : Integer;
   Silent_Flag : Boolean;
   Lives_Max_Param : Integer;
   Overall_Dur_Param : Integer;
   First_Level_Param : Integer;
   First_Level : Integer;
   Number_of_Enemies : Integer;
   Enemy : Array [ 1..Maximum_Enemies ] of Char;
   Enemy_X : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Y : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Origin_X : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Origin_Y : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Delta_X : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Delta_Y : Array [ 1..Maximum_Enemies ] of Integer;
   Enemy_Count : Integer;
   Self_Count : Integer;
   Overall_Count : Integer;
   Blink_Count : Integer;
   Offense_Count : Integer;
   Offense : Boolean;
   Killed : Boolean;
   Game_Stop : Boolean;
   Silent : Boolean;
   Victory : Boolean;
   Handle : Boolean;
   Hit : Integer;
   First_Blink_Count : Integer;
   First_Blink_Color : Byte;
   Enemy_Color : Byte;
   Enemies_Gobbled : Byte;
   Pellet_Sum, Pellet_Total : Integer;
   Score : Real;
   Lives : Integer;
   Lives_St : String[ 80 ];
   High_Score : Real;
   High_Score_Player : String[ 3 ];
   High_St : String[ 12 ];
   Disk_File : Text;
   Board : Array [ 1..24 ] of Screen_Row;
   Board_Name : String[ 80 ];
   Level : Integer;
   My_X, My_Y, Old_X, Old_Y : Integer;
   My_Origin_X, My_Origin_Y : Integer;
   Delta_Y, Delta_X : Integer;
   Steering_X,  Steering_Y : Integer;
   Direction_X,  Direction_Y : Integer;
   Turn : Char;
   No_Z : Integer;
   No_Z_Flip : Integer;
   Loop, Loop1 : Integer;
   X, Y, X2, Y2 : Integer;
   R : Real;
   St : String80;
   Ch : Char;
   Blank_Line : Screen_Row;


Procedure Make_High_St;
  Begin
    Str( High_Score:8:0, St );
    High_Score_Player[ 0 ] := Chr( 3 );  St := St + ' ' + High_Score_Player;
    High_St := St;  High_Score_Player := 'YOU';
  End;


Procedure Strip( Var St:String80 );
  Var St2:String80;  L:Integer;
  Begin
    St2 := '';
    For L := 1 to Length( St ) do
      If St[ L ] <> ' ' Then St2 := St2 + St[ L ];
    St := St2;
  End;


Procedure Load_High_Score;
  Label Err;
  Begin
    X := 0;  R := 0.0;  St := '';
    High_Score := 0.0;  High_Score_Player := '   ';  Make_High_St;
    {$I-} Assign( Disk_File, HighScoreFileSpec ); {$I+}
    If IOResult <> 0 Then Exit;
    {$I-} Reset( Disk_File ); {$I+}
    If IOResult <> 0 Then Exit;
    {$I-} ReadLn( Disk_File, St ); {$I+}
    If IOResult <> 0 Then Goto Err;
    If Length( St ) < 1 Then Exit;
    Strip( St );  Val( St, R, X );
    If X > 0 Then Goto Err;
    {$I-} ReadLn( Disk_File, St ); {$I+}
    If IOResult <> 0 Then Goto Err;
    High_Score_Player := St; High_Score := R;
    Close( Disk_File );  Make_High_St;  Exit;
  Err:
    Close( Disk_File );
  End;


Procedure Save_High_Score;
  Label Err;
  Begin
    {$I-} Assign( Disk_File, HighScoreFileSpec ); {$I+}
    If IOResult <> 0 Then Exit;
    {$I-} ReWrite( Disk_File ); {$I+}
    If IOResult <> 0 Then Exit;
    Str( High_Score:8:0, St );
    {$I-} WriteLn( Disk_File, St ); {$I+}
    If IOResult <> 0 Then Goto Err;
    {$I-} WriteLn( Disk_File, High_Score_Player ); {$I+}
    If IOResult <> 0 Then Goto Err;
    Flush( Disk_File );  Close( Disk_File );  Exit;
  Err:
    Close( Disk_File );
  End;


Procedure ForeColor( C:Byte );
  Begin TextColor( C ); End;


Procedure BackColor( C:Byte );
  Begin TextBackGround( C ); End;


Procedure Reverse_Color;
  Begin  ForeColor( BackGround );  BackColor( Bright );  End;


Procedure Normal_Color;
  Begin  BackColor( BackGround );  ForeColor( Bright );  End;


Procedure Handle_Steering; Forward;


Procedure At( At_X, At_Y:Integer; At_St:Screen_Row );
  Begin
    GotoXY( At_X, At_Y );  Write( At_St );  GotoXY( At_X, At_Y );
    Handle_Steering;
  End;


Procedure Clear_Screen;
  Begin
    ClrScr;
    At( 1, 1, '' );
  End;


Procedure Quit;
  Begin  Clear_Screen;  At( 1, 1, '' );  Halt;  End;


Procedure EatKeys;
  Begin
    If not Keypressed Then Exit;
    While Keypressed do
      Begin  Ch := ReadKey;  If Ch in QuitKeys Then Quit;  End;
  End;


Procedure Abort( Msg:Screen_Row );
  Begin
    Clear_Screen; At( 20, 7, Msg );
    At( 20, 9, 'Press any key to quit.' ); EatKeys; Ch := ReadKey;
    Quit;
  End;


Procedure New_High_Score;  Forward;


Procedure Load_Board;
  Label Top, Next, Err, Done;
  Begin
  Top:
    {$I-} Assign( Disk_File, Board_Name ); {$I+}
    If IOResult <> 0 Then Goto Err;
    {$I-} Reset( Disk_File ); {$I+}
    If IOResult <> 0 Then Goto Err;
    Loop := 1;
  Next:
    St := Blank_Line;
    {$I-} ReadLn( Disk_File, St ); {$I+}
    If IOResult <> 0 Then Goto Err;
    St[ 0 ] := Chr( 79 );
    Board[ Loop ] := St;
    If Loop >= 24 Then Goto Done;
    Inc( Loop );
    Goto Next;
  Done:
    Close( Disk_File );  Exit;
  Err:
    New_High_Score;
    Abort( 'Game board ' + Board_Name + ' not found.' );
  End;


Procedure Initialize;
  Begin
    ForeColor( Bright );  BackColor( Background );
    No_Z_Flip := 1;
    Lives := Lives_Max;  Silent := Silent_Flag;  Handle := False;
    For Loop := 1 to Maximum_Enemies do
      Begin
        Enemy[ Loop ] := ' ';
        Enemy_X[ Loop ] := 0;  Enemy_Y[ Loop ] := 0;
        Enemy_Origin_X[ Loop ] := 0;  Enemy_Origin_Y[ Loop ] := 0;
      End;
    Score := 0.0;  High_Score := 0.0;  Load_High_Score;
    Level := First_Level - 1;
    My_X := 0;  My_Y := 0;  My_Origin_X := 0;  My_Origin_Y := 0;
  End;


Procedure Find_Self;
  Begin
    Loop := 0;
    For Y := 1 to 24 do
      For X := 1 to 79 do
        If Board[ Y ][ X ] = self Then
          Begin
            Loop := 1;
            My_Origin_X := X;  My_Origin_Y := Y + 1;
            Board[ Y ][ X ] := ' ';
          End;
    If Loop = 0 Then Abort( 'Player not found on board.' );
  End;


Procedure Find_Enemies;
  Begin
    Loop := 0;
    For Y := 1 to 24 do For X := 1 to 79 do
      If Board[ Y ][ X ] in [ 'A'..'Z' ] Then
        If Loop < Maximum_Enemies Then
          Begin
            Inc( Loop );
            Enemy_Origin_X[ Loop ] := X;  Enemy_Origin_Y[ Loop ] := Y + 1;
            Enemy[ Loop ] := Board[ Y ][ X ];  Board[ Y ][ X ] := ' ';
          End;
    If Loop = 0 Then Abort( 'No enemies found on board.' );
    Number_Of_Enemies := Loop;
  End;


Procedure Count_Pellets;
  Begin
    Pellet_Total := 0;  Pellet_Sum := 0;
    For Y := 1 to 24 do For X := 1 to 79 do
      If Board[ Y ][ X ] = '.' Then Inc( Pellet_Total );
  End;


Procedure Show_Score;
  Begin  Str( Score:8:0, St );  At( 1, 1, St );  End;


Procedure Top_Line;
  Begin
    At( 1, 1, Blank_Line );
    Lives_St := '';
    For Loop := 1 to 5 do
      If Loop <= Lives Then
        Lives_St := Lives_St + self
      Else
        Lives_St := ' ' + Lives_St;
    St := '';
    St := '         :SCORE        ' + High_St + ' :RECORD        ';
    St := St + Lives_St + ' :LIVES       ' + Chr( 64 + Level ) + ' :LEVEL ';
    At( 1, 1, St );  Show_Score;
  End;


Procedure New_Old;
  Begin  Old_X := My_X;  Old_Y := My_Y;  End;


Procedure New_Life;
  Begin
    Enemy_Count := Enemy_Dur;
    Self_Count := Self_Dur;
    Offense_Count := Offense_Dur;
    Blink_Count := 0;
    Overall_Count := Overall_Dur;
    Offense := False;  Enemy_Color := Bright;
    Killed := False;  Game_Stop := False;  Victory := False;
    Delta_Y := 0;  Delta_X := 0;  Steering_X := 0;  Steering_Y := 0;
    Direction_X := 0;  Direction_Y := 0;  Turn := ' ';
    Enemies_Gobbled := 0;
    My_X := My_Origin_X;  My_Y := My_Origin_Y;  New_Old;
    For Loop := 1 to Number_Of_Enemies do
      Begin
        Enemy_X[ Loop ] := Enemy_Origin_X[ Loop ];
        Enemy_Y[ Loop ] := Enemy_Origin_Y[ Loop ];
        At( Enemy_X[ Loop ], Enemy_Y[ Loop ], Enemy[ Loop ] );
        Enemy_Delta_X[ Loop ] := 0;  Enemy_Delta_Y[ Loop ] := 0;
      End;
    At( My_X, My_Y, self );  Top_Line;
  End;


Procedure Level_Setup;
  Begin
    Clear_Screen;
    Inc( Level );  Board_Name := 'GOBBLE-' + Chr( 64 + Level ) + '.BRD';
    Load_Board;  Count_Pellets;  Find_Self;  Find_Enemies;
    For Loop := 1 to 24 do At( 1, Loop + 1, Board[ Loop ] );  New_Life;
  End;


Function Blocked:Boolean;
  Begin
    If X < 1 Then X := 79;  If X > 79 Then X := 1;
    If Y < 2 Then Y := 25;  If Y > 25 Then Y := 2;
    If Board[ Y - 1 ][ X ] in [ '.', '*', ' ' ] Then
      Blocked := False
    Else
      Blocked := True;
  End;


Procedure Tone( T:Integer );
  Begin  If not Silent Then Sound( T );  End;


Procedure Blank_Sound;  { same duration as pellet_sound }
  Begin  Delay( 40 );  End;


Procedure Pellet_Sound;
  Begin
    Show_Score;
    Tone( 750 ); Delay( 20 ); Tone( 1500 ); Delay( 20 ); NoSound;
  End;


Procedure Power_Sound;
  Begin
    Loop1 := 1200;  Show_Score;
    For Loop := 1 to 6 do
      Begin
        Tone( Loop1 );  Delay( 60 );
        Loop1 := Loop1 * 10 div 8;
      End;
    NoSound;
  End;


Procedure Death_Sound;
  Begin
    Loop1 := 900;
    For Loop := 1 to 4 do
      Begin
        Tone( Loop1 );  Delay( Loop * 60 );
        Loop1 := Loop1 * 8 div 10;
      End;
    NoSound;
  End;


Procedure Kill_Sound;
  Begin
    Show_Score;
    For Loop := 3000 downto 200 do Tone( Loop );
    NoSound;
  End;


Procedure Victory_Sound;
  Begin
    For Loop := 1 to 3 do
      For Loop1 := 400 to 4000 do Tone( Loop1 );
    NoSound;
  End;


Procedure Die;
  Begin
    Reverse_Color;  At( Old_X, Old_Y, self );  Normal_Color;
    Death_Sound;  Game_Stop := True;  Killed := True;  Delay( 2000 );
    For Loop := 1 to Number_Of_Enemies do
      Begin
        Ch := Board[ Enemy_Y[ Loop ] - 1 ][ Enemy_X[ Loop ] ];
        At( Enemy_X[ Loop ], Enemy_Y[ Loop ], Ch );
        Enemy_X[ Loop ] := Enemy_Origin_X[ Loop ];
        Enemy_Y[ Loop ] := Enemy_Origin_Y[ Loop ];
      End;
    At( Old_X, Old_Y, Board[ Old_Y - 1 ][ Old_X ] );  New_Old;
  End;


Procedure Kill;
  Begin
    Enemy_X[ Hit ] := Enemy_Origin_X[ Hit ];
    Enemy_Y[ Hit ] := Enemy_Origin_Y[ Hit ];
    Inc( Enemies_Gobbled );
    If Enemies_Gobbled > 4 Then Enemies_Gobbled := 4;
    Score := Score + Enemy_Score * Enemies_Gobbled + 0.0;
    At( Old_X, Old_Y, Board[ Old_Y - 1 ][ Old_X ] );
    Reverse_Color;  At( My_X, My_Y, Enemy[ Hit ] );  Normal_Color;
    Kill_Sound;  At( My_X, My_Y, self );
  End;


Procedure DoGobble;
  Label Nox, Top, Plt, Pwr, Spc, Live;
  Begin
    If ( My_X <> Old_X ) or ( My_Y <> Old_Y ) Then Goto NoX;
    Delay( No_Move_Delay );
    Exit;
  NoX:
    If Blink_Count > 0 Then Blink_Count := Blink_Count + Blink_Adjust;
    Hit := 0;
    For Loop := 1 to Number_Of_Enemies do
    If ( My_X = Enemy_X[ Loop ] ) and ( My_Y = Enemy_Y[ Loop ] ) Then
      Hit := Loop;
    If Hit = 0 Then Goto Top;
    If Offense Then Goto Live;
    Die;
    Exit;
  Live:
    Kill;  New_Old;  Goto Plt;
  Top:
    If Old_Y <> My_Y Then Blank_Sound;
    At( My_X, My_Y, self );
    At( Old_X, Old_Y, Board[ Old_Y - 1 ][ Old_X ] );  New_Old;
  Plt:
    If Board[ My_Y - 1 ][ My_X ] <> '.' Then Goto Pwr;
    Score := Score + Pellet_Score + 0.0;  Board[ My_Y - 1 ][ My_X ] := ' ';
    Pellet_Sound;  Inc( Pellet_Sum );
    If Pellet_Sum <> Pellet_Total Then Exit;
    Victory_Sound;
    Game_Stop := True;  Victory := True;
    Exit;
  Pwr:
    If Board[ My_Y - 1 ][ My_X ] = '*' Then Goto Spc;
    Blank_Sound;
    Exit;
  Spc:
    Score := Score + Power_Score + 0.0;  Offense_Count := Offense_Dur;
    Board[ My_Y - 1 ][ My_X ] := ' ';  Offense := True;  Power_Sound;
    Enemy_Color := Dim;
  End;


Procedure Update_Self;
  Label Mv;
  Begin
    If ( Steering_X = 0 ) and ( Steering_Y = 0 ) Then Goto Mv;
    X := My_X + Steering_X;  Y := My_Y + Steering_Y;
    If Not Blocked Then
      Begin
        Direction_X := Steering_X;  Direction_Y := Steering_Y;
        Steering_X := 0;  Steering_Y := 0;
      End;
  Mv:
    X := My_X + Direction_X;  Y := My_Y + Direction_Y;
    If Not Blocked Then
      Begin  My_X := X;  My_Y := Y;  End;
    DoGobble;
  End;


Procedure  Handle_Steering;
  Label NPs, Num;
  Begin
    If ( not Keypressed ) or ( not Handle ) Then Exit;
    Turn := ReadKey;  If Turn in QuitKeys Then Quit;
    If Turn <> ' ' Then Goto NPs;
    Handle := False;  Normal_Color;  At( 1, 1, Blank_Line );
    EatKeys;  At( 1, 1, '     PAUSED . . .          PRESS ANY KEY.' );
    Ch := ReadKey;  If Ch in QuitKeys Then Quit;
    Top_Line;  Handle := True;
    Exit;
  NPs:
    If ( Turn = Chr( 0 ) ) and Keypressed Then Turn := ReadKey;
  Num:
    If not ( Turn in [ 'H', 'P', 'K', 'M', '2', '4', '6', '8' ] ) Then exit;
    Steering_X := 0;  Steering_Y := 0;
    Case Turn of
      '8', 'H' : Steering_Y := -1;
      '2', 'P' : Steering_Y := 1;
      '4', 'K' : Steering_X := -1;
      '6', 'M' : Steering_X := 1;
     End;
  End;


Procedure No_Zero( Delta:Integer );
  Begin
    If Delta <> 0 Then
      No_Z := Delta
    Else
      Begin
        No_Z_Flip := 0 - No_Z_Flip;  No_Z := No_Z_Flip;
        If Random( Random_Factor ) = 0 Then
          No_Z := Random( Random_Flip ) * Random_Flip - 1;
      End;
  End;


Procedure Make_Deltas;
  Begin
    Delta_X := 0;  Delta_Y := 0;
    If My_X > X Then Delta_X := 1;  If My_X < X Then Delta_X := -1;
    If My_Y > Y Then Delta_Y := 1;  If My_Y < Y Then Delta_Y := -1;
    If ( Delta_X = 0 ) and ( Delta_Y = 0 ) Then Exit;
    If Offense Then
      Begin
        Delta_X := 0 - Delta_X;
        Delta_Y := 0 - Delta_Y;
      End;
  End;


Procedure Initial_Deltas;
  Begin
    For Loop := 1 to Number_Of_Enemies do
      Begin
        X := Enemy_X[ Loop ];  Y := Enemy_Y[ Loop ];  Make_Deltas;
        If ( Delta_X <> 0 ) and ( Delta_Y <> 0 ) Then Delta_Y := 0;
        Enemy_Delta_X[ Loop ] := Delta_X;  Enemy_Delta_Y[ Loop ] := Delta_Y;
      End;
  End;


Procedure Update_Enemies;
  Label
    Top, DltX, APX, APY, APX2, APY2,
     Blkd, PrpY2, PrpX, PrpX2, Rev, Mv, Live, Next;
  Begin
    Loop := 1;
  Top:
    If Loop > Number_Of_Enemies Then Exit;
    X := Enemy_X[ Loop ];  Y := Enemy_Y[ Loop ];
    Make_Deltas;  If ( Delta_X = 0 ) and ( Delta_Y = 0 ) Then Goto Mv;
    { ** TRY TO TURN IF ONE OF THE DELTAS IS ZERO ** }
    If Delta_Y = 0 Then Goto DltX;
    If Delta_X <> 0 Then Goto APX;
    { TRY Y TURN IF X DELTA IS ZERO }
    Y := Enemy_Y[ Loop ] + Delta_Y;  X := Enemy_X[ Loop ];
    If Blocked Then Goto APX;
    Enemy_Delta_X[ Loop ] := 0;
    Enemy_Delta_Y[ Loop ] := Delta_Y;
    Goto Mv;
  DltX:
    { TRY X TURN IF Y DELTA IS ZERO }
    Y := Enemy_Y[ Loop ];  X := Enemy_X[ Loop ] + Delta_X;
    If Blocked Then Goto APX;  Enemy_Delta_Y[ Loop ] := 0;
    Enemy_Delta_X[ Loop ] := Delta_X;
    Goto Mv;
    { ** IF GOING ANTI-DELTA, CHECK FOR FREE PERPENDICULARS ** }
  APX:
    { OCCASIONALLY REVERSE INSTEAD OF TURN }
    If ( Enemy_Delta_Y[ Loop ] <> 0 ) and
       ( Enemy_Delta_Y[ Loop ] = 0 - Delta_Y ) and
       ( Delta_X <> 0 ) Then Goto APY;
    If not ( ( Enemy_Delta_X[ Loop ] <> 0 ) and
            ( Enemy_Delta_X[ Loop ] = 0 - Delta_X ) and
            ( Delta_Y <> 0 ) ) Then Goto Blkd;
    { IF GOING ANTI-X, TRY Y TURN }
    Y := Enemy_Y[ Loop ] + Delta_Y;  X := Enemy_X[ Loop ];
    If Blocked Then Goto APX2;
    If Random( Random_Factor ) = 0 Then Goto Rev;
    Enemy_Delta_X[ Loop ] := 0;
    Enemy_Delta_Y[ Loop ] := Delta_Y;
    Goto Mv;
  APX2:
    If Random( Random_Factor ) <> 0 Then Goto Blkd;
    Y := Enemy_Y[ Loop ] + ( 0 - Delta_Y );  X := Enemy_X[ Loop ];
    If Blocked Then Goto Blkd;
    If Random( Random_Factor ) = 0 Then Goto Rev;
    Enemy_Delta_X[ Loop ] := 0;
    Enemy_Delta_Y[ Loop ] := 0 - Delta_Y;
    Goto Mv;
  APY:
    { IF GOING ANTI-Y, TRY X TURN }
    X := Enemy_X[ Loop ] + Delta_X;  Y := Enemy_Y[ Loop ];
    If Blocked Then Goto APY2;
    If Random( Random_Factor ) = 0 Then Goto Rev;
    Enemy_Delta_Y[ Loop ] := 0;
    Enemy_Delta_X[ Loop ] := Delta_X;
    Goto Mv;
  APY2:
    If Random( Random_Factor ) <> 0 Then Goto Blkd;
    X := Enemy_X[ Loop ] + ( 0 - Delta_X );  Y := Enemy_Y[ Loop ];
    If Blocked Then Goto Blkd;
    Enemy_Delta_Y[ Loop ] := 0;
    Enemy_Delta_X[ Loop ] := 0 - Delta_X; Goto Mv;
    { ** CONTINUE CURRENT DELTA IF POSSIBLE ** }
  Blkd:
    X := Enemy_X[ Loop ] + Enemy_Delta_X[ Loop ];
    Y := Enemy_Y[ Loop ] + Enemy_Delta_Y[ Loop ];
    If not Blocked Then Goto Mv;
    { ** CHOOSE NEW DELTA IF CURRENT IS BLOCKED ** }
    { ** PREFERENCES:  1-PERPENDICULAR DIRECTION, 2-OPPOSITE ** }
    If ( Enemy_Delta_X[ Loop ] <> 0 ) Then Goto PrpX;
    If ( Enemy_Delta_Y[ Loop ] = 0 ) Then Goto Rev;
    { IF GOING Y, TRY TO TURN X }
    Y := Enemy_Y[ Loop ];  No_Zero( Delta_X );  X := Enemy_X[ Loop ] + No_Z;
    If Blocked Then Goto PrpY2;
    Enemy_Delta_X[ Loop ] := No_Z;
    Enemy_Delta_Y[ Loop ] := 0;
    Goto Mv;
  PrpY2:
    Y := Enemy_Y[ Loop ];  No_Zero( 0 - Delta_X );
    X := Enemy_X[ Loop ] + No_Z;
    If Blocked Then Goto Rev;
    Enemy_Delta_X[ Loop ] := No_Z;
    Enemy_Delta_Y[ Loop ] := 0;
    Goto Mv;
  PrpX:
    { IF GOING X, TRY TO TURN Y }
    X := Enemy_X[ Loop ];  No_Zero( Delta_Y );
    Y := Enemy_Y[ Loop ] + No_Z;
    If Blocked Then Goto PrpX2;
    Enemy_Delta_Y[ Loop ] := No_Z;
    Enemy_Delta_X[ Loop ] := 0;
    Goto Mv;
  PrpX2:
    X := Enemy_X[ Loop ];  No_Zero( 0 - Delta_Y );
    Y := Enemy_Y[ Loop ] + No_Z;
    If Blocked Then Goto Rev;
    Enemy_Delta_Y[ Loop ] := No_Z;
    Enemy_Delta_X[ Loop ] := 0;
    Goto Mv;
  Rev:
    X := Enemy_X[ Loop ] + ( 0 - Enemy_Delta_X[ Loop ] );
    Y := Enemy_Y[ Loop ] + ( 0 - Enemy_Delta_Y[ Loop ] );
    If Blocked Then Goto Next;  { NO MOVE POSSIBLE }
    Enemy_Delta_X[ Loop ] := ( 0 - Enemy_Delta_X[ Loop ] );
    Enemy_Delta_Y[ Loop ] := ( 0 - Enemy_Delta_Y[ Loop ] );
  Mv:
    ForeColor( Enemy_Color );  At( X, Y, Enemy[ Loop ] );  Normal_Color;
    Ch := Board[ Enemy_Y[ Loop ] - 1 ][ Enemy_X[ Loop ] ];
    At( Enemy_X[ Loop ], Enemy_Y[ Loop ], Ch );
    Enemy_X[ Loop ] := X;  Enemy_Y[ Loop ] := Y;
    If ( X <> My_X ) or ( Y <> My_Y ) Then Goto Next;
    If Offense Then Goto Live;
    Die;
    Exit;
  Live:
    Hit := Loop;  Kill;
  Next:
    Inc( Loop );
    Goto Top;
  End;


Procedure Offense_Countdown;
  Label Bnk, Nof;
  Begin
    If not Offense Then Exit; If Offense_Count <= 0 Then Goto Nof;
    Offense_Count := Offense_Count - 1;
    If Offense_Count > Blink_Threshold Then Exit;
    If Blink_Count <= 0 Then Goto Bnk;
    Blink_Count := Blink_Count - 1;
    Exit;
  Bnk:
    Blink_Count := Blink_Dur;
    If Enemy_Color = Bright Then
      Enemy_Color := Dim
    Else
      Enemy_Color := Bright;
    Exit;
  Nof:
    Tone( 5000 ); Delay( 50 );  NoSound;
    Offense := False;  Offense_Count := Offense_Dur;  Blink_Count := 0;
    Enemy_Color := Bright;  Enemies_Gobbled := 0;
  End;


Procedure First_Blink;
  Label FB1, FB2;
  Begin
    First_Blink_Color := Bright;
    First_Blink_Count := First_Blink_Dur;
  FB1:
    If not Keypressed Then Goto FB2;
    Normal_Color;
    Exit;
  FB2:
    First_Blink_Count := First_Blink_Count - 1;
    If First_Blink_Count >= 0 Then Goto FB1;
    ForeColor( First_Blink_Color );  At( My_X, My_Y, self );
    If First_Blink_Color = Bright Then
      First_Blink_Color := Dim
    Else
      First_Blink_Color := Bright;
    First_Blink_Count := First_Blink_Dur;
    Goto FB1;
  End;


Procedure Main_Loop;
  Label Ovr, Slf, Enm, Off, Out;
  Begin
    EatKeys;  First_Blink;  Handle := True;  Initial_Deltas;
  Ovr:
    If Overall_Count <= 0 Then Goto Slf;
    Delay( Main_Loop_Delay );
    Overall_Count := Overall_Count - 1;
    Goto Ovr;
  Slf:
    Overall_Count := Overall_Dur;
    If Self_Count > 0 Then Goto Enm;
    Update_Self;
    If Game_Stop Then Goto Out;
    Self_Count := Self_Dur + 1;
  Enm:
    Self_Count := Self_Count - 1;
    If Enemy_Count > 0 Then Goto Off;
    Update_Enemies;
    If Game_Stop Then Goto Out;
    Enemy_Count := Enemy_Dur + 1;
  Off:
    Enemy_Count := Enemy_Count - 1;
    Offense_Countdown;
    Goto Ovr;
  Out:
    Handle := False;
  End;


Function Pad( St:String80 ):String80;
  Begin
    Pad := '                ';  Pad := St;  Pad[ 0 ] := Chr( 16 );
  End;


Procedure New_High_Score;
  Label New, Del, Keep;
  Begin
    If ( Score <= High_Score ) or ( Lives_Max > Lives_Max_Default ) or
       ( Overall_Dur > Overall_Dur_Default ) or
       ( First_Level > First_Level_Default ) Then Exit;
    Str( Score:8:0, St );
    At( 23,  7, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
    At( 23,  8, 'X                                          X' );
    At( 23,  9, 'X  !!  YOU HAVE BEATEN THE HIGH SCORE  !!  X' );
    At( 23, 10, 'X   OLD RECORD:  ' + Pad( High_St ) + '          X' );
    At( 23, 11, 'X   YOUR SCORE:  ' + Pad( St )      + '          X' );
    At( 23, 12, 'X   TYPE YOUR INITIALS, THEN PRESS ENTER   X' );
    At( 23, 13, 'X   >                                      X' );
    At( 23, 14, 'X                                          X' );
    At( 23, 15, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
    Loop := 1;  High_Score := Score;  High_Score_Player := '   ';
    At( 29, 13, ' ' );
  New:
    EatKeys;  Ch := ReadKey;  If Ch in QuitKeys Then Quit;
    Ch := Upcase( Ch );
    If Ch = ^M Then Goto Keep;
    If Ch = ^H Then Goto Del;
    If not ( Ch in [ 'A'..'Z' ] ) Then Goto New;
    If Loop > 3 Then Loop := 3;
    At( 29 + Loop, 13, Ch );  High_Score_Player[ Loop ] := Ch;
    Inc( Loop );
    Goto New;
  Del:
    If Loop = 1 Then Goto New;
    Delete( High_Score_Player, Loop, 1 );
    Dec( Loop );
    At( 29 + Loop, 13, ' ' );
    Goto New;
  Keep:
    High_Score_Player[ 0 ] := Chr( Loop );
    Save_High_Score;  Make_High_St;  Clear_Screen;
  End;


Procedure Play;
  Label Yes, Top, Die, Ovr, Ask;
  Begin
  Yes:
    Initialize;  Level_Setup;
  Top:
    Main_Loop;
    If Not Victory Then Goto Die;
    At( 26, 10, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
    At( 26, 11, 'X                          X' );
    At( 26, 12, 'X   ! !  B R A V O  ! !    X' );
    At( 26, 13, 'X                          X' );
    At( 26, 14, 'X  PREPARE FOR NEXT LEVEL  X' );
    At( 26, 15, 'X                          X' );
    At( 26, 16, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
    Delay( 2000 );  Level_Setup;  Goto Top;
  Die:
    If Killed Then Dec( Lives );
    If Lives <= 0 Then Goto Ovr;
    New_Life;
    Goto Top;
  Ovr:
    New_High_Score;
    At( 26, 10, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
    At( 26, 11, 'X                          X' );
    At( 26, 12, 'X    G A M E   O V E R     X' );
    At( 26, 13, 'X                          X' );
    At( 26, 14, 'X   PLAY AGAIN?   (Y/N)    X' );
    At( 26, 15, 'X                          X' );
    At( 26, 16, 'XXXXXXXXXXXXXXXXXXXXXXXXXXXX' );
  Ask:
    EatKeys;  Ch := ReadKey;
    If Upcase( Ch ) = 'Y' Then Goto Yes;
    If Upcase( Ch ) = 'N' Then Quit;
    Goto Ask;
  End;


Procedure Get_Param_Word;
  Begin
    St := '';  St := ParamStr( Loop );
    If Length( St ) <= 0 Then Exit;
    For Loop1 := 1 to Length( St ) do
      St[ Loop1 ] := UpCase( St[ Loop1 ] );
  End;


Procedure Get_Param_Value;
  Begin
    St := '';
    Inc( Loop );
    If Loop > ParamCount Then
      Abort( 'Number missing in command line parameters.' );
    St := ParamStr( Loop );  Strip( St );
    Val( St, R, Y );  If ( Y > 0 ) or ( R > 32000.0 ) Then
      Abort( 'Bad number in command line parameters.' );
    X := Trunc( R );
  End;


Procedure Read_Params;
  Label Top, Lives, Speed, Sound, Level;
  Begin
    Blank_Line := '                    ';
    Blank_Line := Blank_Line + Blank_Line + Blank_Line + Blank_Line;
    Loop := 0;  Overall_Dur_Param := 0;
    Overall_Dur := Overall_Dur_Default;
    Lives_Max := Lives_Max_Default;  Lives_Max_Param := 0;
    Silent_Flag := Silent_Flag_Default;
    First_Level_Param := 0;  First_Level := First_Level_Default;
  Top:
    Inc( Loop );  If Loop > ParamCount Then Exit;
    Get_Param_Word;
    If St = '?' Then
      Begin
        Assign( Con, '' ); ReWrite( Con );
        For CpyRtLp := 1 to 26 do
          If CpyRtLp = 1 Then
            CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
          Else
            CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                     Ord( CpyRt[ CpyRtLp - 1 ] ) );
        Writeln( Con, 'GOBBLE ver ' + Version + ' rev ' + Revision +
                      ' - ' + CpyRt + '.' );
        Writeln( Con, 'Maze, ghosts, munching game like arcade classic.' );
        Writeln( Con, '  Playing instruction screen is built in.' );
        Writeln( COn, 'GOBBLE [LIVES n] [SPEED n] [LEVEL n] [SOUND]' );
        Writeln( Con, 'Options:' );
        Writeln( Con, '  LIVES n   Set starting lives.' );
        Writeln( Con, '  SPEED n   Set game slowdown factor.' );
        Writeln( Con, '  LEVEL c   Set starting level A..Z.' );
        Writeln( Con, '  SOUND n   Deactivate sounds.' );
        Writeln( Con, 'High score is only saved in default game:' );
        Writeln( Con, '  LIVES ', Lives_Max, ' SPEED ', Overall_Dur,
                      ' LEVEL A' );
        Writeln( Con, '  High score is stored in GOBBLE.HIS file.' );
        Writeln( Con, 'Game boards are user modifiable text files:' );
        Writeln( Con, '  ^B is player, A..Z are pursuers.' );
        Writeln( Con, '  GOBBLE-A.BRD..-Z.BRD must be in current path.' );
        Writeln( Con, 'Does not require graphics capability.' );
        Close( Con );  Halt( 1 );
      End;
    If St = 'LIVES' Then Goto Lives;
    If St = 'SPEED' Then Goto Speed;
    If St = 'SOUND' Then Goto Sound;
    If St = 'LEVEL' Then Goto Level;
    Abort( 'Unknown parameter "' + St + '" on command line.' );
  Lives:
    Get_Param_Value;  Lives_Max_Param := X;
    Lives_Max := X;
    Goto Top;
  Speed:
    Get_Param_Value;  Overall_Dur_Param := X;
    Overall_Dur := X;
    Goto Top;
  Sound:
    Silent_Flag := not Silent_Flag;
    Goto Top;
  Level:
    Get_Param_Value;
    If ( X > 0 ) and ( X < 27 ) Then
      First_Level_Param := X;
    First_Level := First_Level_Param;
    Goto Top;
  End;


Procedure cj( St:String80 );
  Begin
    If Length( St ) > 0 Then
      Begin
        Loop := Length( St );  Loop := 80 - Loop;
        If Loop > 0 Then Loop := Loop div 2;
        At( Loop, Y2, St );
      End;
    Inc( Y2 );
  End;        


Procedure Help;
  Begin
    Y2 := 1;
    Clear_Screen;
    cj( 'PRESS  <ENTER>  IF YOU WANT INSTRUCTIONS' );
    cj( 'or any other key to Begin playing.' );
    Ch := ReadKey;  If Ch in QuitKeys Then Quit;
    If Ch <> ^M Then Exit;
    Y2 := 1;
    cj( '> !!!  ********    GOBBLE    ********  !!! <' );
    cj( '' );
    cj( 'This is a standard MAZE game, like the arcade classic.' );
    cj( 'The object is to achieve a record breaking high score.' );
    cj( 'GOBBLE ver ' + Version + ' rev ' + Revision + ' - ' + CpyRt + '.' );
    cj( '' );
    cj( 'You steer using the cursor (arrow) keys.  Num-Lock is ignored.' );
    cj( '<SPACE> pauses the game, and <ESC> ends it.' );
    cj( '' );
    cj( 'When the game Begins, everything is quiet until you press a key.' );
    cj( 'Usually, the ENEMIES chase you, but if you gobble a NUKE DISK (*)' );
    cj( 'you will temporarily gain super powers.  During this time the' );
    cj( 'ENEMIES turn dark and run away.  Gobble them for high scores.' );
    cj( 'They will start to blink when your power becomes low.' );
    cj( 'A chirp sounds when they become agressive again.' );
    cj( 'When you have gobbled all the WHOLE WHEAT SNACK BISCUITS (.)' );
    cj( 'the game advances to the next level.' );
    cj( '' );
    cj(  '' );
    cj( 'There are four parameters you may use when you start the game.' );
    cj( 'SPEED X sets game speed, 0 is fastest.  LEVEL X starts at level X.' );
    St := 'LIVES X gives X lives.  SOUND gives silence.  ';
    St := St + 'Default = LIVES ' + Chr( 48 + Lives_Max ) + 
        ' SPEED ' + Chr( 48 + Overall_Dur );
    cj( St );
    cj( 'High score saved only for games at default settings or below.' );
    cj( '' );
    cj( 'PRESS ANY KEY TO PLAY' );
    Ch := ReadKey;  If Ch in QuitKeys Then Quit;
  End;


Begin

  Read_Params;
  Help;
  Play;

End.



