{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 64000,0,0}

Program IOUtl;

Uses Crt, Dos;

Type
  String20 = String[ 30 ];

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;

Var
  Param, RawParam : String20;
  ParamLoop : Byte;

{-------------------------------------------------------------------}

Procedure DosWrite( Msg : String );
  Var
    Con : Text;
  Begin
    Assign( Con, '' );  ReWrite( Con );
    Write( Con, Msg );  Close( Con );
  End;

{-------------------------------------------------------------------}

Procedure DosWriteLn( Msg : String );
  Begin
    DosWrite( Msg + #13 + #10 );
  End;

{-------------------------------------------------------------------}

Function GetVMode : Byte;
  Var
    Regs : Registers;
  Begin
    FillChar( Regs, SizeOf( Regs ), 0 );
    Regs.AH := 15;
    Intr( $10, Regs );
    GetVMode := Regs.AL;
  End;

{-------------------------------------------------------------------}

Function I_S( Num : Word ) : String20;
  Var
    NumStr : String20;
  Begin
    Str( Num, NumStr );
    I_S := NumStr;
  End;  

{-------------------------------------------------------------------}

Procedure KeyTest;
  Var
    Regs : Registers;
    HiByt, LoByt : Byte;
  Const
    Hex : Array[ 0..15 ] of Char =
      ( '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'A', 'B', 'C', 'D', 'E', 'F' );
  Begin
    DosWrite( 'Press keys to see ' );
    If Param = '/B' THEN DosWrite( 'BIOS' ) ELSE DosWrite( 'MSDOS' );
    DosWriteln( ' scan codes.' );
    If Param = '/B' Then
      Begin
        DosWriteln( 'BIOS returns keypresses as a high byte' );
        DosWriteln( 'containing a keyboard scan code,' );
        DosWriteln( 'and a low byte containing the ASCII code.' );
        DosWriteln( 'Extended keys return a zero in the low byte.' );
      End
    Else
      Begin
        DosWriteln( 'MSDOS returns keypresses as an ASCII byte.' );
        DosWriteln( 'Extended keys return a zero, and a subsequent' );
        DosWriteln( 'call returns the scan code.' );
      End;
    DosWriteln( 'Press  <ESC>  to terminate.' );  DosWriteln( '' );
    Repeat
      If Param = '/B' Then
        Begin
          Regs.AX := $0000;  Intr( $16, Regs );
          HiByt := Regs.AH;  LoByt := Regs.AL;
        End
      Else
        Begin
          If Param = '/8' Then
            Regs.AH := $08
          Else
            Regs.AH := $07;
          MsDos( Regs );
          LoByt := Regs.AL;
          If LoByt = 0 Then
            Begin
              If Param = '/8' Then
                Regs.AH := $08
              Else
                Regs.AH := $07;
              MsDos( Regs );
              HiByt := Regs.AL;
            End
          Else
            HiByt := 0;
        End;
      DosWriteln( I_S( HiByt ) + ' : ' + I_S( LoByt ) +
                  '  (hex ' + Hex[ ( HiByt and $F0 ) shr 4 ] +
                              Hex[ HiByt and $0F ] + ' : ' +
                              Hex[ ( LoByt and $F0 ) shr 4 ] +
                              Hex[ LoByt and $0F ] + ')' );
    Until Regs.AL = 27;
    DosWriteln( '' );
  End;

{-------------------------------------------------------------------}

Procedure SetShiftStates;
  Begin
    { test purge allowed characters }
    While ( Param <> '' ) and ( Pos( ' ', Param ) > 0 ) do
      Delete( Param, Pos( ' ', Param ), 1 );
    { should only be one of each at most }
    If Pos( 'C', Param ) > 0 Then
      Delete( Param, Pos( 'C', Param ), 1 );
    If Pos( 'N', Param ) > 0 Then
      Delete( Param, Pos( 'N', Param ), 1 );
    { should be empty }
    If Param <> '' Then
      Begin
        DosWriteln( 'Invalid parameter.' );
        Halt( 1 );
      End;
    If Pos( 'C', RawParam ) > 0 Then
      Begin
        DosWriteln( 'Setting caps lock.' );
        Mem[ $0000 : $0417 ] := Mem[ $0000 : $0417 ] or $40;
      End;
    If Pos( 'c', RawParam ) > 0 Then
      Begin
        DosWriteln( 'Clearing caps lock.' );
        Mem[ $0000 : $0417 ] := Mem[ $0000 : $0417 ] and $BF;
      End;
    If Pos( 'N', RawParam ) > 0 Then
      Begin
        DosWriteln( 'Setting num lock.' );
        Mem[ $0000 : $0417 ] := Mem[ $0000 : $0417 ] or $20;
      End;
    If Pos( 'n', RawParam ) > 0 Then
      Begin
        DosWriteln( 'Clearing num lock.' );
        Mem[ $0000 : $0417 ] := Mem[ $0000 : $0417 ] and $DF;
      End;
  End;

{-------------------------------------------------------------------}

Procedure ShowAttrGrid;
  Var
    BackLoop, ForeLoop : Byte;
  Const
    Hex : Array[ 0..15 ] of Char =
      ( '0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
        'A', 'B', 'C', 'D', 'E', 'F' );
    BckWrd : String[ 16 ] = '   BACKGROUND   ';
  Begin
    ClrScr;
    If not ( GetVMode in [ 0..3, 7 ] ) Then
      Begin
        DosWriteln( 'System must be in text mode.' );
        Halt( 1 );
      End;
    NormVideo;
    Writeln( '        F O R E G R O U N D' );
    Writeln;
    For BackLoop := 0 to 15 do
      Begin
        For ForeLoop := 0 to 15 do
          Begin
            TextBackGround( BackLoop mod 8 );
            TextColor( ForeLoop + ( BackLoop div 8 * Blink ) );
            Write( Hex[ BackLoop ], ':', Hex[ ForeLoop ], ' ' );
          End;
        NormVideo;
        Writeln( '   ' + BckWrd[ BackLoop + 1 ] );
      End;
  End;

{-------------------------------------------------------------------}

Procedure VWrite( X, Y : Word;  Msg : String20 );
  Type
    ScreenType = Array [ 1..25, 1..80 ] of
      Record  Ch : Char;  Attr : Byte;  End;
  Var
    VAddr, VLoop : Word;
    Screen : ^ScreenType;
  Begin
    If GetVMode = $07 Then
      VAddr := $B000
    Else
      VAddr := $B800;
    Screen := Ptr( Vaddr, 0 );
    For VLoop := 1 to Length( Msg ) do
      Begin
        Screen^[ Y, X + VLoop - 1 ].Ch := Msg[ VLoop ];
        Screen^[ Y, X + VLoop - 1 ].Attr := $07;
      End;
  End;

{-------------------------------------------------------------------}

Procedure ShowAlignGrid;
  Var
    X, Y, BaseX, BaseY : Word;
    Ch : Char;
  Const
    TL=#201;  TR=#187;  BL=#200;  BR=#188;
    T=#205;  B=#205;  L=#186;  R=#186;
    TeeL=#204;  TeeR=#185;  TeeT=#203;  TeeB=#202;
    XJoin=#206;  HLine=#205;  VLine=#186;
  Begin
    { this loop structure creates a diagonal wipe from top left }
    BaseX := 1;  BaseY := 1;
    Repeat
      X := BaseX;  Y := BaseY;
      Repeat
        { determine what character should be at any given spot }
        If ( X = 1 ) and ( Y = 1 ) Then Ch := TL
        Else
        If ( X = 80 ) and ( Y = 1 ) Then Ch := TR
        Else
        If ( X = 1 ) and ( Y = 25 ) Then Ch := BL
        Else
        If ( X = 80 ) and ( Y = 25 ) Then Ch := BR
        Else
        If ( X = 1 ) and ( Y > 1 ) and ( Y < 25 ) and
           ( ( Y - 1 ) mod 4 = 0 ) Then Ch := TeeL
        Else
        If ( X = 80 ) and ( Y > 1 ) and ( Y < 25 ) and
           ( ( Y - 1 ) mod 4 = 0 ) Then Ch := TeeR
        Else
        If ( Y = 1 ) and ( X > 1 ) and ( X < 80 ) and
           ( ( X - 1 ) mod 10 = 0 ) Then Ch := TeeT
        Else
        If ( Y = 25 ) and ( X > 1 ) and ( X < 80 ) and
           ( ( X - 1 ) mod 10 = 0 ) Then Ch := TeeB
        Else
        If ( X = 1 ) and ( Y > 1 ) and ( Y < 25 ) and
           ( ( Y - 1 ) mod 4 <> 0 ) Then Ch := L
        Else
        If ( X = 80 ) and ( Y > 1 ) and ( Y < 25 ) and
           ( ( Y - 1 ) mod 4 <> 0 ) Then Ch := R
        Else
        If ( Y = 1 ) and ( X > 1 ) and ( X < 80 ) and
           ( ( X - 1 ) mod 10 <> 0 ) Then Ch := T
        Else
        If ( Y = 25 ) and ( X > 1 ) and ( X < 80 ) and
           ( ( X - 1 ) mod 10 <> 0 ) Then Ch := B
        Else
        If ( Y > 1 ) and ( Y < 25 ) and
           ( X > 1 ) and ( X < 80 ) and
           ( ( Y - 1 ) mod 4 = 0 ) and
           ( ( X - 1 ) mod 10 = 0 ) Then Ch := XJoin
        Else
        If ( Y > 1 ) and ( Y < 25 ) and
           ( X > 1 ) and ( X < 80 ) and
           ( ( Y - 1 ) mod 4 = 0 ) and
           ( ( X - 1 ) mod 10 <> 0 ) Then Ch := HLine
        Else
        If ( Y > 1 ) and ( Y < 25 ) and
           ( X > 1 ) and ( X < 80 ) and
           ( ( Y - 1 ) mod 4 <> 0 ) and
           ( ( X - 1 ) mod 10 = 0 ) Then Ch := VLine
        Else
        Ch := ' ';
        VWrite( X, Y, Ch );
        Dec( X );  Inc( Y );
      Until ( X = 0 ) or ( Y > 25 );
      If BaseX = 80 Then Inc( BaseY );
      If BaseX < 80 Then Inc( BaseX );
    Until ( BaseX = 80 ) and ( BaseY > 25 );
    While not KeyPressed do;
    While KeyPressed do Ch := ReadKey;
    GotoXY( 80, 25 ); Writeln;
  End;

{-------------------------------------------------------------------}

Function Pad( S : String20;  Wid : Integer ) : String20;
  Begin
    S := Copy( S, 1, Abs( Wid ) );
    While Length( S ) < Abs( Wid ) do
      If Abs( Wid ) > 0 Then
        S:= ' ' + S
      Else
        S := S + ' ';
    Pad := S;
  End;

{-------------------------------------------------------------------}

Procedure ShowAsciiTable;
  Const
    Hex : String[ 16 ] = '0123456789ABCDEF';
  Var
    Loop, X, Y : Word;
    EatCh : Char;
  Begin
    If not ( GetVMode in [ 0..3, 7 ] ) Then
      Begin
        DosWriteln( 'System must be in text mode.' );
        Halt( 1 );
      End;
    ClrScr;
    VWrite(  1,  2, '  0 00 ' + ^@ + ' ^@ NUL' );
    VWrite(  1,  3, '  1 01 ' + ^A + ' ^A SOH' );
    VWrite(  1,  4, '  2 02 ' + ^B + ' ^B STX' );
    VWrite(  1,  5, '  3 03 ' + ^C + ' ^C ETX' );
    VWrite(  1,  6, '  4 04 ' + ^D + ' ^D EOT' );
    VWrite(  1,  7, '  5 05 ' + ^E + ' ^E ENQ' );
    VWrite(  1,  8, '  6 06 ' + ^F + ' ^F ACK' );
    VWrite(  1,  9, '  7 07 ' + ^G + ' ^G BEL' );
    VWrite(  1, 10, '  8 08 ' + ^H + ' ^H BS' );
    VWrite(  1, 11, '  9 09 ' + ^I + ' ^I HT' );
    VWrite(  1, 12, ' 10 0A ' + ^J + ' ^J LF' );
    VWrite(  1, 13, ' 11 0B ' + ^K + ' ^K VT' );
    VWrite(  1, 14, ' 12 0C ' + ^L + ' ^L FF' );
    VWrite(  1, 15, ' 13 0D ' + ^M + ' ^M CR' );
    VWrite(  1, 16, ' 14 0E ' + ^N + ' ^N SO' );
    VWrite(  1, 17, ' 15 0F ' + ^O + ' ^O SI' );
    VWrite(  1, 18, ' 16 10 ' + ^P + ' ^P DLE' );
    VWrite(  1, 19, ' 17 11 ' + ^Q + ' ^Q DC1' );
    VWrite(  1, 20, ' 18 12 ' + ^R + ' ^R DC2' );
    VWrite(  1, 21, ' 19 13 ' + ^S + ' ^S DC3' );
    VWrite(  1, 22, ' 20 14 ' + ^T + ' ^T DC4' );
    VWrite(  1, 23, ' 21 15 ' + ^U + ' ^U NAK' );
    VWrite( 19,  2, ' 22 16 ' + ^V + ' ^V SYN' );
    VWrite( 19,  3, ' 23 17 ' + ^W + ' ^W ETB' );
    VWrite( 19,  4, ' 24 18 ' + ^X + ' ^X CAN' );
    VWrite( 19,  5, ' 25 19 ' + ^Y + ' ^Y EM' );
    VWrite( 19,  6, ' 26 1A ' + ^Z + ' ^Z SUB' );
    VWrite( 19,  7, ' 27 1B ' + ^[ + ' ^[ ESC' );
    VWrite( 19,  8, ' 28 1C ' + ^\ + ' ^\ FS' );
    VWrite( 19,  9, ' 29 1D ' + ^] + ' ^] GS' );
    VWrite( 19, 10, ' 30 1E ' + ^^ + ' ^^ RS' );
    VWrite( 19, 11, ' 31 1F ' + ^_ + ' ^_ US' );
    X := 19;  Y := 12;  Loop := 32;
    Repeat
      VWrite( X, Y,
              Pad( I_S( Loop ), 3 ) + ' ' +
              Hex[ ( Loop and $F0 ) shr 4 + 1 ] +
              Hex[ Loop and $0F + 1 ] + ' ' + Chr( Loop ) );
      Inc( Loop );
      Inc( Y );
      If Y > 23 Then
        Begin
          Y := 2;
          X := X + 18;
        End;
    Until Loop = 84;
    VWrite( 1, 25, '*****  PRESS ANY KEY  *****' );
    While not KeyPressed do;
    While KeyPressed do EatCh := ReadKey;
    GotoXY( 1, 25 );  ClrEol; 
    If EatCh = #27 Then Halt;
    X := 1;  Y := 2;
    ClrScr;
    Repeat
      VWrite( X, Y,
              Pad( I_S( Loop ), 3 ) + ' ' +
              Hex[ ( Loop and $F0 ) shr 4 + 1 ] +
              Hex[ Loop and $0F + 1 ] + ' ' + Chr( Loop ) );
      Inc( Loop );
      Inc( Y );
      If Y > 23 Then
        Begin
          Y := 2;
          X := X + 10;
        End;
    Until Loop = 255;
    VWrite( 1, 25, '*****  PRESS ANY KEY  *****' );
    While not KeyPressed do;
    While KeyPressed do EatCh := ReadKey;
    GotoXY( 1, 25 );  ClrEol; 
  End;

{-------------------------------------------------------------------}

Procedure SetCursor;
  Var
    Style, Result : Integer;
    Regs : Registers;
  Const
    Hex : String[ 16 ] = '0123456789ABCDEF';
  Begin
    Val( Param, Style, Result );
    If Result <> 0 Then
      Begin
        DosWriteln( 'Bad number in cursor style.' );
        Halt( 1 );
      End;
    If ( Style < 0 ) or ( Style > 255 ) Then
      Begin
        DosWriteln( 'Cursor style value out of range.' );
        Halt( 1 );
      End;
    If Style = 255 Then
      Begin
        { get current cursor }
        Regs.AH := $03;
        Regs.BH := $00;
        Intr( $10, Regs );
        Writeln( 'Current cursor style register value is: $',
                 Hex[ ( Regs.CH and $0F ) + 1 ] +
                 Hex[ ( Regs.CL and $0F ) + 1 ] );
      End
    Else
      Begin
        { set new cursor }
        Regs.AH := $01;
        Regs.CH := ( Style and $F0 ) shr 4;
        Regs.CL := Style and $0F;
        Intr( $10, Regs );
      End;
  End;

{-------------------------------------------------------------------}

Begin

  RawParam := '';
  For ParamLoop := 1 to ParamCount do
    If ParamLoop = 1 Then
      RawParam := ParamStr( 1 )
    Else
      RawParam := RawParam + ' ' + ParamStr( 1 );
  Param := RawParam;
  For ParamLoop := 1 to Length( Param ) do
    Param[ ParamLoop ] := UpCase( Param[ ParamLoop ] );

  If ( ParamCount < 1 ) or ( ParamStr( 1 ) = '?' ) Then
    Begin
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      DosWriteln( 'IOUTL ver 3.1 rev 91/06/29 - ' + CpyRt + '.' );
      DosWriteln( 'Keyboard and screen basic programming utilities.' );
      DosWriteln( '  Display keyboard scan codes and ascii tables.' );
      DosWriteln( '  Display alignment and color combination grids.' );
      DosWriteln( '  Change CAP LOCK and NUM LOCK status and cursor.' );
      DosWriteln( 'IOUTL /B' );
      DosWriteln( '  Display BIOS intr 16h key codes.' );
      DosWriteln( 'IOUTL /7 {or} /8' );
      DosWriteln( '  Display MsDos function 7 or 8 key codes.' );
      DosWriteln( 'IOUTL [C][c][N][n]' );
      DosWriteln( '  Any combination of C or N sets cap or num lock.' );
      DosWriteln( '  Lower case clears.' );
      DosWriteln( 'IOUTL /A' );
      DosWriteln( '  ASCII table.' );
      DosWriteln( 'IOUTL /C' );
      DosWriteln( '  Text color combination grid.' );
      DosWriteln( 'IOUTL /G' );
      DosWriteln( '  Screen alignment pattern grid.' );
      DosWriteln( 'IOUTL $se' );
      DosWriteln( '  Set or view cursor style register:' );
      DosWriteln( '    s=start row (0..7), e=end row, >$77=off, $FF=view.' );
      Halt( 1 );
    End;

  If ( Param = '/B' ) or ( Param = '/7' ) or ( Param = '/8' ) Then
    KeyTest
  Else
    If Param = '/C' Then
      ShowAttrGrid
    Else
      If Param = '/G' Then
        ShowAlignGrid
      Else
        If Param = '/A' Then
          ShowAsciiTable
        Else
          If not ( Param[ 1 ] in [ 'c', 'C', 'n', 'N' ] ) Then
            SetCursor
          Else
            SetShiftStates;

End.



