{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 64000,0,0}

Program NewChk;

Uses DOS;

TYPE
  String80 = String[ 80 ];
  String2 = String[ 2 ];

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;

{-------------------------------------------------------------------------}

FUNCTION AbsTime( H, M, S : Integer ) : LongInt;  { seconds since 00:00:00 }
  BEGIN  AbsTime := LongInt( H ) * 3600 + M * 60 + S;  END;

{-------------------------------------------------------------------------}

FUNCTION AbsDate( Y, M, D : Integer ) : LongInt;
  VAR  MLoop : Integer;  Total : LongInt;  
  CONST  DaysPerMonth : Array[ 1..12 ] of Byte =
           ( 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 );
  BEGIN
    Y := Y - 1980;
  { start with leap year days }
    Total := Y div 4;
  { compensate for fact that the base year, 1980, is a leap year }
    Inc( Total );
  { compensate if current year is a leap year, but leap day is not past }
    If ( Y mod 4 = 0 ) and
       ( ( M < 2 ) or ( ( M = 2 ) and ( D < 29 ) ) ) Then Dec( Total );
  { add days for past years }
    Total := Total + ( ( Y - 1 ) * 365 );
    MLoop := 1;
  { add days for elapsed months in year }
    While MLoop < M do
      BEGIN
        Total := Total + DaysPerMonth[ MLoop ];
        Inc( MLoop );
      END;
  { add elapsed days in month to finish }
    AbsDate := Total + D - 1;
  END;

{-------------------------------------------------------------------------}

FUNCTION NewerTime( InTime1, InTime2 : LongInt ) : Boolean;
  VAR  DT : DateTime;  Time1, Time2, Age1, Age2 : LongInt;
  BEGIN
    UnPackTime( InTime1, DT );
    Age1 := AbsDate( DT.Year, DT.Month, DT.Day );
    Time1 := AbsTime( DT.Hour, DT.Min, DT.Sec );
    UnPackTime( InTime2, DT );
    Age2 := AbsDate( DT.Year, DT.Month, DT.Day );
    Time2 := AbsTime( DT.Hour, DT.Min, DT.Sec );
    NewerTime := ( Age1 > Age2 ) or
              ( ( Age1 = Age2 ) and ( Time1 > Time2 ) );
  END;


{-------------------------------------------------------------------------}

Function FindNewest( Mask : String80;  VAR Dir : SearchRec ) : Boolean;
  Var
    TempDir : SearchRec;
    UpLoop : Byte;
  Begin
    FindNewest := False;
    For UpLoop := 1 to Length( Mask ) do
      Mask[ UpLoop ] := UpCase( Mask[ UpLoop ] );
    FillChar( Dir, SizeOf( Dir ), 0 );
    FindFirst( Mask, Archive, TempDir );
    If DosError <> 0 Then
      Writeln( 'No file matching ', Mask );
    While DosError = 0 do
      Begin
        If NewerTime( TempDir.Time, Dir.Time ) Then Dir := TempDir;
        FindNext( TempDir );
        FindNewest := True;
      End;
  End;

{-------------------------------------------------------------------------}

Function BiggerSize( InSize1, InSize2 : LongInt ) : Boolean;
  Begin
    BiggerSize := InSize1 > InSize2;
  End;

{-------------------------------------------------------------------------}

Function FindBigest( Mask : String80;  VAR Dir : SearchRec ) : Boolean;
  Var
    TempDir : SearchRec;
    UpLoop : Byte;
  Begin
    FindBigest := False;
    For UpLoop := 1 to Length( Mask ) do
      Mask[ UpLoop ] := UpCase( Mask[ UpLoop ] );
    FillChar( Dir, SizeOf( Dir ), 0 );
    FindFirst( Mask, Archive, TempDir );
    If DosError <> 0 Then
      Writeln( 'No file matching ', Mask );
    While DosError = 0 do
      Begin
        If BiggerSize( TempDir.Size, Dir.Size ) Then Dir := TempDir;
        FindNext( TempDir );
        FindBigest := True;
      End;
  End;

{-------------------------------------------------------------------------}

Function NewerFile( Mask1, Mask2 : String80 ) : Boolean;
  Var
    Dir1, Dir2 : SearchRec;
    Path1, Path2 : String[80];
    JunkName, JunkExt : String[20];
    NewResult : Boolean;
  Begin
    NewerFile := False;
    If not FindNewest( Mask1, Dir1 ) Then
      NewResult := False
    Else
      If not FindNewest( Mask2, Dir2 ) Then
        NewResult := True
      Else
        NewResult := NewerTime( Dir1.Time, Dir2.Time );
    If Dir1.Name = '' Then
      Writeln( 'No file matching name 1: ', Mask1 );
    If Dir2.Name = '' Then
      Writeln( 'No file matching name 2: ', Mask2 );
    If ( Dir1.Name <> '' ) and ( Dir2.Name <> '' ) Then
      Begin
        FSplit( Mask1, Path1, JunkName, JunkExt );
        FSplit( Mask2, Path2, JunkName, JunkExt );
        Write( Path1 + Dir1.Name, ' is ' );
        If not NewResult Then Write( 'not ' );
        Writeln( 'newer than ', Path2 + Dir2.Name );
      End;
    NewerFile := NewResult;
  End;

{-------------------------------------------------------------------------}

Function BiggerFile( Mask1, Mask2 : String80 ) : Boolean;
  Var
    Dir1, Dir2 : SearchRec;
    Path1, Path2 : String[80];
    JunkName, JunkExt : String[20];
    BigResult : Boolean;
  Begin
    BiggerFile := False;
    If not FindBigest( Mask1, Dir1 ) Then
      BigResult := False
    Else
      If not FindBigest( Mask2, Dir2 ) Then
        BigResult := True
      Else
        BigResult := BiggerSize( Dir1.Size, Dir2.Size );
    If Dir1.Name = '' Then
      Writeln( 'No file matching name 1: ', Mask1 );
    If Dir2.Name = '' Then
      Writeln( 'No file matching name 2: ', Mask2 );
    If ( Dir1.Name <> '' ) and ( Dir2.Name <> '' ) Then
      Begin
        FSplit( Mask1, Path1, JunkName, JunkExt );
        FSplit( Mask2, Path2, JunkName, JunkExt );
        Write( Path1 + Dir1.Name, ' is ' );
        If not BigResult Then Write( 'not ' );
        Writeln( 'bigger than ', Path2 + Dir2.Name );
      End;
    BiggerFile := BigResult;
  End;

{-------------------------------------------------------------------------}

BEGIN

  If ( ParamCount < 2 ) or ( ParamStr( 1 ) = '?' )
    THEN BEGIN
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( 'NEWCHK ver 3.1 rev 91/06/29 - ', CpyRt, '.' );
      Writeln( 'Compare files to determine which is newer.' );
      Writeln( '  Accepts explicit or wildcard names.' );
      Writeln( 'NEWCHK file1 file2' );
      Writeln( '  Return an errorlevel if file1 is older than file2' );
      Writeln( '    or if file1 does not exist.' );
      Writeln( '  Wildcard name uses newest file matching mask.' );
      Writeln( 'NEWCHK file1 file2 /S' );
      Writeln( '  Return an errorlevel if file1 is smaller than file2' );
      Writeln( '    or if file1 does not exist.' );
      Writeln( '  Wildcard name uses largest file matching mask.' );
      Halt( 1 );
    END;

  If ( ParamCount > 2 ) and
     ( ( ParamStr( 3 ) = '/S' ) or ( ParamStr( 3 ) = '/s' ) ) Then
    Begin
      If BiggerFile( ParamStr( 1 ), ParamStr( 2 ) ) Then
        Halt
      Else
        Halt( 1 );
    End
  Else
    Begin
      If NewerFile( ParamStr( 1 ), ParamStr( 2 ) ) Then
        Halt
      Else
        Halt( 1 );
    End;

END.



