{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 2048,0,0}

Program Pop;

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  StackFileSpec = 'C:\DIRSTACK.$$$';
  MaxNDirs = 20;
  PopAll : Boolean = False;

Var
  DirStack, PurgeTemp : Text;
  CurDir, Param : String[ 80 ];
  DirStackArray : Array [ 1..MaxNDirs ] of String[ 80 ];
  UCLoop, DirLoop, DirCount, CloseResult, EraseResult, Result : Integer;


Function EraseFile( FileName : String ) : Integer;
  Var EFile : Text;  EResult : Integer;
  Begin
    Assign( EFile, FileName );
    Erase( EFile );  EResult := IOResult;
    EraseFile := EResult;
  End;


Begin

  If ParamCount > 0 Then
    Begin
      Param := ParamStr( 1 );
      For UCLoop := 1 to Length( Param ) do
        Param[ UCLoop ] := UpCase( Param[ UCLoop ] );
      PopAll := Param = '/A';
    End;

  If ( ParamCount > 0 ) and ( not PopAll ) Then
    Begin
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( 'POP ver 3.1 rev 91/06/29 - ', CpyRt, '.' );
      Writeln( 'Change to a drive and directory popped from a stack.' );
      Writeln( '  Use to return from temporary directory change' );
      Writeln( '    or to allow batch files to change directories' );
      Writeln( '    then later restore the original path.' );
      Writeln( 'POP' );
      Writeln( '  Change to drive and path most recently pushed.' );
      Writeln( '  Remove most recent entry from stack.' );
      Writeln( 'POP /A' );
      Writeln( '  Pop last drive and path then erase stack file.' );
      Writeln( 'Intended for use with the PUSH program.' );
      Writeln( 'The stack is stored in C:\DIRSTACK.$$$ file.' );
      Halt( 1 );
    End;

{ get the paths from the stack }
  DirCount := 0;
  Assign( DirStack, StackFileSpec );
  Reset( DirStack );  Result := IOResult;
  While ( Result = 0 ) and ( not EOF( DirStack ) ) do
    Begin  { read loop }
      Readln( DirStack, CurDir );  Result := IOResult;
      If Result = 0 Then
        Begin  { load stack }
          Inc( DirCount );
          DirStackArray[ DirCount ] := CurDir;
        End;  { load stack }
    End;  { read loop }

  If ( Result = 0 ) and ( DirCount < 1 ) Then Result := 2;

{ change back to most recently pushed path }
  If Result = 0 Then
    Begin  { change dir }
      ChDir( DirStackArray[ DirCount ] );  Result := IOResult;
    End;  { change dir }

{ close, regardless of errors }
  Close( DirStack );  CloseResult := IOResult;
  If Result = 0 Then
      Result := CloseResult;

{ erase current stack file }
  EraseResult := EraseFile( StackFileSpec );
  If Result = 0 Then
      Result := EraseResult;

{ erase stack if empty }
  If ( Result = 0 ) and ( DirCount < 2 ) Then
    Result := EraseFile( StackFileSpec );

{ purge the top stack item and rewrite }
  If not PopAll Then
    Begin  { not PopAll }
      DirLoop := 1;
      If ( Result = 0 ) and ( DirCount > 1 ) Then
        Begin  { purge }
          Assign( DirStack, StackFileSpec );
          ReWrite( DirStack );  Result := IOResult;
          While ( Result = 0 ) and ( DirLoop <= DirCount - 1 ) do
            Begin  { write loop }
              Writeln( DirStack, DirStackArray[ DirLoop ] );
              Result := IOResult;
              Inc( DirLoop );
            End;  { write loop }
          Close( DirStack );  CloseResult := IOResult;
          If Result = 0 Then
              Result := CloseResult;
        End;  { purge }
    End;  { not PopAll }

{ erase stack if any errors }
  If Result <> 0 Then
    EraseResult := EraseFile( StackFileSpec );

{ halt with success indication }
  If Result = 0 Then
      Halt
    Else
      Halt( 1 );

End.



