{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 2048,0,0}

Program Push;

Var
  DirStack : Text;
  CurDir, Param : String[ 80 ];
  CloseResult, Result, UCLoop : Integer;

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  StackFileSpec = 'C:\DIRSTACK.$$$';
  PushAll : Boolean = False;

Procedure EraseFile( FileName : String );
  Var EFile : Text;  EResult : Integer;
  Begin
    Assign( EFile, FileName );
    Erase( EFile );  EResult := IOResult;
  End;


Begin

  If ParamCount > 0 Then
    Begin
      Param := ParamStr( 1 );
      For UCLoop := 1 to Length( Param ) do
        Param[ UCLoop ] := UpCase( Param[ UCLoop ] );
      PushAll := Param = '/A';
    End;

  If ( ParamCount > 0 ) and ( not PushAll ) Then
    Begin
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Writeln( 'PUSH ver 3.1 rev 91/06/29 - ', CpyRt, '.' );
      Writeln( 'Record the current drive and directory on a stack.' );
      Writeln( '  Use to prepare for temporary directory change' );
      Writeln( '    or to allow batch files to change directories' );
      Writeln( '    then later restore the original path.' );
      Writeln( 'PUSH' );
      Writeln( '  Record current drive and path on stack.' );
      Writeln( 'PUSH /A' );
      Writeln( '  Erase stack file then push current drive and path.' );
      Writeln( 'Intended for use with the POP program.' );
      Writeln( 'The stack is stored in C:\DIRSTACK.$$$ file.' );
      Halt( 1 );
    End;

  If PushAll Then
    EraseFile( StackFileSpec );

{ prepare stack file }
  Assign( DirStack, StackFileSpec );
  Append( DirStack );  Result := IOResult;
  If Result <> 0 Then
    Begin  { new file }
      ReWrite( DirStack );  Result := IOResult;
    End;  { new file }

{ append current path }
  If Result = 0 Then
    Begin  { open OK }
      GetDir( 0, CurDir );  Result := IOResult;
      If Result = 0 Then
        Begin  { get dir OK }
          Writeln( DirStack, CurDir );  Result := IOResult;
        End;  { get dir OK }
    End;  { open OK }

{ close, regardless of errors }
  Close( DirStack );  CloseResult := IOResult;
  If Result = 0 Then
      Result := CloseResult;

{ erase if any errors }
  If Result <> 0 Then
      EraseFile( StackFileSpec );

{ halt with success indication }
  If Result = 0 Then
      Halt
    Else
      Halt( 1 );

End.



