{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 8192,0,0}

Program Sounds;

Uses
  Dos, Crt;

Var
  Con : Text;
  Found, EatKys, ReDraw : Boolean;
  MenuCh, EatKey : Char;
  ParamArr : String;
  ParamLoop, FirstParam : Integer;
  ParamName : String[ 10 ];
  DelayMult : Integer;

Const
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;
  LastY : Byte = 0;

(*****  LOW LEVEL SOUNDS  *****)

Procedure Beep( Freq, Duration : Word );
  Begin
    Sound( Freq );  Delay( Duration );  NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Alert( Freq, Rep : Word );
  Var
    Loop : Word; 
  Begin
    For Loop := 1 to Rep do
      Begin
        Beep( Freq, 100 );  Beep( Freq * 2, 100 );
      End;
  End;

{----------------------------------------------------------------------}

Procedure Noise( Freq : Word );
  Var
    Loop, MultLp : Word;
  Begin
    For MultLp := 1 to DelayMult do
      For Loop := 1 to 150 do
        If Random( Freq ) = 1 Then
          Port[ 97 ] := Port[ 97 ] and $FC  { bits 0,1 off = speaker on }
        Else
          Port[ 97 ] := Port[ 97 ] or $02;  { bits 0,1 on = speaker off }
    NoSound;
  End;

(*****  HIGH LEVEL SOUNDS  *****)

Procedure Claxon;  { trouble }
  Var
    Loop : Word;
  Begin
    For Loop := 1 to 70 do
      If Odd( Loop ) Then
        Beep( 1000, 10 )
      Else
        Beep( 250, 10 );
  End;

{----------------------------------------------------------------------}

Procedure Bleep;  { command }
  Begin
    Alert( 2000, 1 );
  End;

{----------------------------------------------------------------------}

Procedure Continue;  { continue }
  Begin
    Beep( 1700, 50 );  Beep( 1200, 50 );
  End;

{----------------------------------------------------------------------}

Procedure Dit;  { keypress }
  Begin
    Beep( 2000, 40 );
  End;

{----------------------------------------------------------------------}

Procedure Di;  { keypress }
  Begin
    Beep( 2000, 4 );
  End;

{----------------------------------------------------------------------}

Procedure DeeDee;  { selection }
  Begin
    Beep( 1500, 30 );  Delay( 30 );  Beep( 1500, 30 );
  End;

{----------------------------------------------------------------------}

Procedure Doo;  { backspace }
  Begin
    Beep( 880, 50 );  Beep( 831, 50 );  Beep( 784, 50 );
  End;

{----------------------------------------------------------------------}

Procedure NoKay;  { denied }
  Var
    Loop : Word;
  Begin
    For Loop:=1 to 6 do
      If Odd( Loop ) Then
        Beep( 350, 25 )
      Else
        Beep( 300, 25 );
  End;

{----------------------------------------------------------------------}

Procedure Enter;  { enter }
  Begin
    Beep( 422, 50 );  Beep( 502, 50 );  Beep( 670, 50 );
  End;

{----------------------------------------------------------------------}

Procedure Okay;  { confirmed }
  Begin
    Beep( 100, 25 );  Beep( 200, 25 );  Beep( 400, 25 );  Beep( 800, 20 );
    Beep( 1600, 20 );  Beep( 3200, 15 );  Beep( 6400, 15 );
  End;

{----------------------------------------------------------------------}

Procedure Zoop;  { escape }
  Var
    Loop : Word;
  Begin
    For Loop := 12 downto 6 do
      Begin
        Sound( Loop * 100 );  Delay( 20 );
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Oop;  { invalid }
  Begin
    Beep( 400, 250 );
  End;

{----------------------------------------------------------------------}

Procedure Siren;  { serious }
  Var
    Loop : Word;
  Begin
    Loop := 150;
    While Loop <= 1800 do
      Begin
        Sound( Loop );  Delay( 1 );  Loop := Loop + 3;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure DoubleSiren;  { emergency }
  Var
    Loop, Repeats : Word;
  Begin
    For Repeats := 1 to 2 do
      Begin
        Loop := 500;
        While Loop <= 3000 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop + 7;
          End;
        NoSound;
      End;
  End;

{----------------------------------------------------------------------}

Procedure ExcuseMe;  { attention }
  Begin
    Beep( 5000, 60 );
  End;

{----------------------------------------------------------------------}

Procedure Chromatic;  { special }
  Begin
    Beep( 784, 40 );  Beep( 831, 40 );  Beep( 880, 40 );
    Beep( 932, 40 );  Beep( 986, 40 );
  End;

{----------------------------------------------------------------------}

Procedure Whoop( T : Word; Up : Boolean);
  Var
    Loop, MultLp : Word;
  Begin
    Case Up of
      True  : For Loop := T downto T div 2 do
                For MultLp := 1 to DelayMult do Sound( Loop );
      False : For Loop := T div 2 to T do
                For MultLp := 1 to DelayMult do Sound( Loop);
    End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Boop( T : Word );
  Begin
    Beep( T, 200 );
  End;

{----------------------------------------------------------------------}

Procedure Chirp( T : Word );
  Begin
    Beep( T, 14 );
    Beep( T div 2, 14 );
    Beep( T, 14 );
  END;

{----------------------------------------------------------------------}

Procedure Razz( T : Word );
  Var
    Loop : Byte;
  Begin
    For Loop := 1 to 10 do
      Begin
        Beep( T, 8 );
        Beep( T div 2, 8 );
      End;
  End;

{----------------------------------------------------------------------}

Procedure Arpeggio( T : Word );
  Begin
    Beep( T, 20 );
    Beep( T * 5 div 4, 20 );
    Beep( T * 4 div 3, 20 );
    Beep( T * 3 div 2, 20 );
  End;

{----------------------------------------------------------------------}

Procedure Boom;
  Var
    Freq : Word;
  Begin
    For Freq := 1 to 20 do
      Begin
        Noise( Freq );  Noise( Freq );
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Fall;
  Var
    Freq : Real;
  Begin
    Freq := 7000.0;
    While Freq > 2000.0 do
      Begin
        Sound( Round( Freq ) );  Delay( 1 );
        Freq := Freq * 0.997;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure LaserGun;
  Var
    Freq : Real;
  Begin
    Freq := 18000.0;
    While Freq > 350.0 do
      Begin
        Sound( Round( Freq ) );  Delay( 1 );
        Freq := Freq * 0.85;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Bomb;
  Begin
    Fall;  Boom;
  End;

{----------------------------------------------------------------------}

Procedure ChooChoo;
  Var
    Itr : Word;
  Begin
    For Itr := 1 to 2 do
      Begin
        Noise( 2 );  Noise( 2 );  Delay( 90 );
        Noise( 6 );  Noise( 6 );  Delay( 90 );
        Noise( 6 );  Noise( 6 );  Delay( 90 );
        Noise( 6 );  Noise( 6 );  Delay( 80 );
      End;
  End;  

{----------------------------------------------------------------------}

Procedure PeepPeep;
  Var
    Freq : Real;
    MultLp : Integer;
  Begin
    Freq := 2000;
    While Freq < 2700 do
      Begin
        For MultLp := 1 to DelayMult do
          Sound( Round( Freq ) );
        Freq := Freq * 1.007;
      End;
    Beep( Round( Freq ), 500 );
    Delay( 50 );
    Freq := 2000;
    While Freq < 2700 do
      Begin
        For MultLp := 1 to DelayMult do
          Sound( Round( Freq ) );
        Freq := Freq * 1.007;
      End;
    Beep( Round( Freq ), 800 );
  End;

{----------------------------------------------------------------------}

Procedure Shot;
  Var
    Itr : Word;
  Begin
    Noise( 2 );  Noise( 4 );
  End;

{----------------------------------------------------------------------}

Procedure TommyGun;
  Var
    Itr : Word;
  Begin
    For Itr := 1 to 10 do
      Begin
        Noise( 2 );
        Delay( 15 );
      End;
  End;  

{----------------------------------------------------------------------}

Procedure Drill;
  Var
    Loop, Itr : Word;
  Begin
    Loop := 150;
    For Itr := 1 to 10 do
      Begin
        While Loop <= 1800 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop + 300;
          End;
        While Loop > 150 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop - 300;
          End;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure SonicGun;
  Var
    Loop, Itr : Word;
  Begin
    Loop := 150;
    For Itr := 1 to 6 do
      Begin
        While Loop <= 1800 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop + 100;
          End;
        While Loop > 150 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop - 100;
          End;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure PhaserGun;
  Var
    Loop, Itr : Word;
  Begin
    Loop := 2300;
    For Itr := 1 to 10 do
      Begin
        While Loop <= 2500 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop + 30;
          End;
        While Loop > 2000 do
          Begin
            Sound( Loop );  Delay( 1 );  Loop := Loop - 30;
          End;
      End;
    NoSound;
  End;

{----------------------------------------------------------------------}

Procedure Charge;
  Const
    TempoFactor : Real = 100;
  Begin
    Beep( 392, Round( 1 * TempoFactor ) );
    Beep( 523, Round( 1 * TempoFactor ) );
    Beep( 659, Round( 1 * TempoFactor ) );
    Beep( 784, Round( 2 * TempoFactor ) );
    Beep( 659, Round( 1 * TempoFactor ) );
    Beep( 784, Round( 3 * TempoFactor ) );
  End;

{----------------------------------------------------------------------}

Procedure Birthday;
  Const
    TempoFactor : Real = 40;
  Begin
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 294, Round( 3 * TempoFactor ) );
    Beep( 262, Round( 3 * TempoFactor ) );
    Beep( 349, Round( 3 * TempoFactor ) );
    Beep( 330, Round( 5 * TempoFactor ) );
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 294, Round( 3 * TempoFactor ) );
    Beep( 262, Round( 3 * TempoFactor ) );
    Beep( 392, Round( 3 * TempoFactor ) );
    Beep( 349, Round( 5 * TempoFactor ) );
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 262, Round( 2 * TempoFactor ) );
    Beep( 523, Round( 3 * TempoFactor ) );
    Beep( 440, Round( 3 * TempoFactor ) );
    Beep( 349, Round( 3 * TempoFactor ) );
    Beep( 330, Round( 3 * TempoFactor ) );
    Beep( 294, Round( 5 * TempoFactor ) );
    Beep( 466, Round( 2 * TempoFactor ) );
    Beep( 466, Round( 2 * TempoFactor ) );
    Beep( 440, Round( 3 * TempoFactor ) );
    Beep( 349, Round( 3 * TempoFactor ) );
    Beep( 392, Round( 3 * TempoFactor ) );
    Beep( 349, Round( 5 * TempoFactor ) );
  End;

{----------------------------------------------------------------------}

Procedure ShowChoice( MnuCh : Char;  Brgt : Boolean );
  Const
    MaxSlct = 42;
    SlctSet : String[ MaxSlct ] =
      'ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890-=/[]\';
    SlctLn : Array[ 1..MaxSlct ] of String[ 20 ] =
      ( '  A. Doe',         '  B. Ray',        '  C. Me',
        '  D. Fah',         '  E. So',         '  F. Lah',
        '  G. Tee',         '  H. Enter',      '  I. Okay',
        '  J. Zoop',        '  K. Oop',        '  L. Siren',
        '  M. DoubleSiren', '  N. Di',         '  O. ExcuseMe',
        '  P. Chromatic',   '  Q. Whoop',      '  R. Poohw',
        '  S. Boop',        '  T. Chirp',      '  U. Razz',
        '  V. Arpeggio',    '  W. Birthday',   '  X. Charge',
        '  Y. Drill',       '  Z. NoKay',      '  1. Boom',
        '  2. Fall',        '  3. Bomb',       '  4. ChooChoo',
        '  5. PeepPeep',    '  6. Shot',       '  7. TommyGun',
        '  8. LaserGun',    '  9. PhaserGun',  '  0. SonicGun',
        '  -. Claxon',      '  =. Bleep',      '  /. Continue',
        '  [. Dit',         '  ]. DeeDee',     '  \. Doo' );
  Var
    SlctNum, X, Y : Byte;
  Procedure ShowLn;
    Begin
      Y := ( SlctNum - 1 ) div 3 + 4;
      X := ( ( SlctNum - 1 ) mod 3 ) * 21 + 4;
      GotoXY( X, Y );
      If Brgt Then
        Begin
          TextColor( Black );  TextBackGround( White );
        End
      Else
        Begin
          TextColor( White );  TextBackGround( Black );
        End;
      While Length( SlctLn[ SlctNum ] ) < 20 do
        SlctLn[ SlctNum ] := SlctLn[ SlctNum ] + ' ';
      Write( SlctLn[ SlctNum ] );
      If LastY < Y Then LastY := Y;
    End;
  Begin
    SlctNum := Pos( MnuCh, SlctSet );
    If SlctNum > 0 Then
      ShowLn
    Else
      For SlctNum := 1 to MaxSlct do
        Begin
          Brgt := True;  ShowLn;
          Delay( 5 );
          Brgt := False;  ShowLn;
        End;
  End;          

{----------------------------------------------------------------------}

Procedure PlayRepeat;
  Var
    Ch, Tone : Char;
    Seq : Array[ 1..1024 ] of Char;
    SeqLen, PlayPos, ClxLoop, SeqLp, X, Y, Retry, MsgNum : Integer;
    HiFile : Text;
    HiName : String[20];
    HiScrStr : String[20];
    HiScr, PrevHiScr, HiResult, HiLp : Integer;
  Const
    CharMap : Array [ 1..4 ] of String[ 15 ] =
      ( '.X..X..X..X..X.', 'XXX..XXXXX..XXX',
        'XXX..XXXX..XXXX', 'X.XX.XXXX..X..X' );
  Type
    String80 = String[80];
  Function Rep( Ch : Char; Cnt : Byte ) : String80;
    Var
      RepOut : String80;
    Begin
      FillChar( RepOut, SizeOf( RepOut ), Ch );
      RepOut[ 0 ] := Chr( Cnt );
      Rep := RepOut;
    End;
  Procedure ShowTone( TnCh : Char );
    Const
      BsFrq = 1500;
      W = 3;
    Var
      Row, Col, StrOfs : Byte;
    Begin
      Case TnCh of
        '1' : Begin  Sound( BsFrq );  X := 2;  Y := 2;  End;
        '2' : Begin  Sound( BsFrq * 5 div 4 );  X := 42;  Y := 2;  End;
        '3' : Begin  Sound( BsFrq * 4 div 3 );  X := 2;  Y := 14;  End;
        '4' : Begin  Sound( BsFrq * 3 div 2 );  X := 42;  Y := 14;  End;
      End;
      Window( X, Y, X + 37, Y + 9 );
      TextColor( Black );  TextBackGround( White );  ClrScr;
      Delay( 200 );
      TextColor( White );  TextBackGround( Black );  ClrScr;
      Window( 1, 1, 80, 25 );
      X := X + 2;  Y := Y + 2;
      GotoXY( X, Y );
      For Row := 1 to 5 do
        Begin
          For Col := 1 to 3 do
            Begin
              StrOfs := ( Row - 1 ) * 3;
              GotoXY( X + ( Col - 1 ) * W, Y - 1 + Row );
              If CharMap[ Ord( TnCh ) - 48 ][ StrOfs + Col ] = 'X' Then
                Write( Rep( #219, W ) )
              Else
                Write( Rep( ' ', W ) );
            End;
          Writeln;
        End;
      NoSound;  Delay( 75 );
    End;  { ShowTone procedure }
  Begin
    Randomize;
    SeqLen := 0;
    For HiLp := 1 to Length( ParamName ) do
      ParamName[ HiLp ] := UpCase( ParamName[ HiLp ] );
    While ( ParamName <> '' ) and
          ( Copy( ParamName, 1, 1 ) = ' ' ) do
      Delete( ParamName, 1, 1 );
    While ( ParamName <> '' ) and
          ( Copy( ParamName, Length( ParamName ), 1 ) = ' ' ) do
      Delete( ParamName, Length( ParamName ), 1 );
    If ParamName = '' Then ParamName := '???';
    Assign( HiFile, 'SOUNDS.HIS' );          
    Reset( HiFile );  HiResult := IOResult;
    HiScr := 0;  HiName := '';
    If HiResult = 0 Then
      Begin
        ReadLn( HiFile, HiName );  HiResult := IOResult;
        ReadLn( HiFile, HiScrStr );  HiResult := HiResult + IOResult;
        If HiResult = 0 Then
          Val( HiScrStr, HiScr, HiResult );
      End;
    If HiResult <> 0 Then
      Begin  HiScr := 0;  HiName := '';  End;
    PrevHiScr := HiScr;
    Close( HiFile );  HiResult := IOResult;
    MsgNum := -1;
    Repeat
      If MsgNum = -1 Then
        Begin
          SeqLen := 0;  Retry := 1;
          Window( 1, 1, 80, 25 );
          TextColor( White );  TextBackGround( Black );
          For Y := 1 to 24 do Write( Rep( '+', 80 ) );
          GotoXY( 1, 25 );  ClrEol;
          GotoXY( 30, 25 );  Write( 'HI: ', HiScr, ' ', HiName );
          ShowTone( '1' );  ShowTone( '2' );
          ShowTone( '3' );  ShowTone( '4' );  Delay( 500 );
          MsgNum := 1;
        End;
      If MsgNum = 1 Then
        Begin
          Window( 1, 1, 80, 25 );  GotoXY( 60, 25 );  ClrEol;
          Write( '1/2/3/4=tones X=quit' );
          MsgNum := 0;
        End;
      If MsgNum = 2 Then
        Begin
          Window( 1, 1, 80, 25 );  GotoXY( 60, 25 );  ClrEol;
          Write( 'QUIT? Y/N' );
          Beep( 4000, 40 );  Delay( 40 );  Beep( 4000, 40 );
          While KeyPressed do Ch := ReadKey;
          Ch := ReadKey;
          If UpCase( Ch ) = 'Y' Then
            Begin
              Okay;
              Retry := 99;
            End
          Else
            NoKay;
          While KeyPressed do Ch := ReadKey;
          Delay( 500 );
          MsgNum := 1;
        End;
      If MsgNum = 3 Then
        Begin
          Window( 1, 1, 80, 25 );  GotoXY( 60, 25 );  ClrEol;
          Write( '!! BAD KEY !!' );
          For ClxLoop := 1 to 70 do
            If Odd( ClxLoop ) Then
              Beep( 800, 10 )
            Else
              Beep( 190, 10 );
          While KeyPressed do Ch := ReadKey;
          Delay( 500 );
          MsgNum := 1;
        End;
      If MsgNum = 4 Then
        Begin
          Window( 1, 1, 80, 25 );  GotoXY( 60, 25 );  ClrEol;
          Write( '--->> WRONG <<---' );
          For ClxLoop := 1 to 70 do
            If Odd( ClxLoop ) Then
              Beep( 800, 10 )
            Else
              Beep( 190, 10 );
          While KeyPressed do Ch := ReadKey;
          Delay( 500 );
          MsgNum := 1;
        End;
      If MsgNum = 5 Then
        Begin
          Window( 1, 1, 80, 25 );  GotoXY( 60, 25 );  ClrEol;
          Write( '. . . SORRY . . .' );
          Beep( 986 div 3, 200 );  Beep( 932 div 3, 200 );
          Beep( 880 div 3, 200 );  Beep( 831 div 3, 200 );
          Beep( 784 div 3, 200 );
          Retry := 1;
          MsgNum := -1;
        End;
      If MsgNum = 0 Then
        Begin
          If ( HiScr <= SeqLen ) and ( SeqLen > 0 ) Then
            Begin
              HiScr := SeqLen;
              HiName := Copy( ParamName, 1, 10 );
            End;
          If Retry = 1 Then
            Begin  { add a tone if not on retries }
              Tone := Chr( 49 + Random( 4 ) );
              Inc( SeqLen );  Seq[ SeqLen ] := Tone;
            End;
          Window( 1, 1, 80, 25 );  GotoXY( 1, 25 );
          Write( ' LENGTH: ', SeqLen:4, '    TRY: ', Retry );
          { play sequence }
          For SeqLp := 1 to SeqLen do ShowTone( Seq[ SeqLp ] );
          { get player response }
          PlayPos := 0;
          While KeyPressed do Ch := ReadKey;
          Repeat
            Inc( PlayPos );
            Ch := UpCase( ReadKey );
            If Ch = 'X' Then
              MsgNum := 2
            Else
              If not ( Ch in [ '1'..'4' ] ) Then
                Begin
                  MsgNum := 3;
                  Inc( Retry );
                End
              Else
                If Ch = Seq[ PlayPos ] Then
                  ShowTone( Ch )
                Else
                  Begin
                    MsgNum := 4;
                    Inc( Retry );
                  End;
          Until ( PlayPos = SeqLen ) or ( MsgNum <> 0 );
          If MsgNum = 0 Then
            Begin
              Delay( 500 );
              Retry := 1;
            End;
        End;
      If Retry > 3 Then MsgNum := 5;
    Until Retry > 10;
    If HiScr <= PrevHiScr Then
      Begin
        HiScr := SeqLen;
        HiName := Copy( ParamName, 1, 10 );
        Assign( HiFile, 'SOUNDS.HIS' );
        ReWrite( HiFile );  HiResult := IOResult;
        If HiResult = 0 Then
          Begin
            Str( HiScr, HiScrStr );
            Writeln( HiFile, HiName );  HiResult := IOResult;
            Writeln( HiFile, HiScrStr );  HiResult := HiResult + IOResult;
          End;
        Close( HiFile );  HiResult := IOResult;
      End;
  End;

{----------------------------------------------------------------------}

Procedure SetDelay;
  Var
    Regs : Registers;
    Sec10, EndSec10, Sec10Cnt : Byte;
    SpeedCnt : LongInt;
  Begin
    { perform a timed loop }
    Sec10Cnt := 0;  SpeedCnt := 0;
    Regs.AH := $2C;  MSDos( Regs );  { get time }
    Sec10 := Regs.DL div 10;
    { wait for next 1/10 second }
    EndSec10 := Sec10;
    Repeat
      Regs.AH := $2C;  MSDos( Regs );
      Sec10 := Regs.DL div 10;
    Until Sec10 <> EndSec10;
    EndSec10 := Sec10;
    { ooop for 4/10 seconds }
    Repeat
      Inc( SpeedCnt );
      Regs.AH := $2C;  MSDos( Regs );
      Sec10 := Regs.DL div 10;
      If Sec10 <> EndSec10 Then
        Begin
          EndSec10 := Sec10;
          Inc( Sec10Cnt );
        End;
    Until Sec10Cnt = 4;
    If SpeedCnt <= 300 Then
      DelayMult := 1   { probable 8086/8088 }
    Else
      If SpeedCnt < 480 Then
        DelayMult := 2  { fast 8088 or slow 286 }
      Else
        DelayMult := 3;  { other }
  End;

{----------------------------------------------------------------------}

Begin

  If ( ParamCount > 0 ) and ( ParamStr( 1 ) = '?' ) Then
    Begin
      For CpyRtLp := 1 to 26 do
        If CpyRtLp = 1 Then
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
        Else
          CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                   Ord( CpyRt[ CpyRtLp - 1 ] ) );
      Assign( Con, '' );  ReWrite( Con );
      Writeln( Con, 'SOUNDS ver 3.1 rev 91/06/29 - ' + CpyRt + '.' );
      Writeln( Con, 'Produce a variety of exciting sounds.' );
      Writeln( Con, '  Audio prompts, video game effects, white noise.' );
      Writeln( Con, '  Also includes four tone repeat game.' );
      Writeln( Con, 'SOUNDS' );
      Writeln( Con, '  Select from a displayed menu of sounds.' );
      Writeln( Con, 'SOUNDS /E' );
      Writeln( Con, '  Eat keypresses between selections.' );
      Writeln( Con, 'SOUNDS sequence' );
      Writeln( Con, '  Play sequence of menu selection.' );
      Writeln( Con, 'SOUNDS /R [name]' );
      Writeln( Con, '  Play standard repeat type game.' );
      Writeln( Con, '  Player repeats growing sequence of tones.' );
      Writeln( Con, '  Use name to store high score in SOUNDS.HIS file.' );
      Close( Con );  Halt( 1 );
    End;

  SetDelay;
  ParamArr := '';  ParamName := '';
  If ( ParamCount > 0 ) and
     ( ( ParamStr( 1 ) = '/E' ) or ( ParamStr( 1 ) = '/e' ) ) Then
    Begin
      FirstParam := 2;
      EatKys := True;
    End
  Else
    If ( ParamCount > 0 ) and
       ( ( ParamStr( 1 ) = '/R' ) or ( ParamStr( 1 ) = '/r' ) ) Then
      Begin
        If ParamCount > 1 Then
          ParamName := Copy( ParamStr( 2 ), 1, 10 );
        PlayRepeat;
        GotoXY( 1, 25 );  Writeln;  ClrEol;  Halt;
      End
    Else
      Begin
        FirstParam := 1;
        EatKys := False;
      End;

  If ParamCount > 0 Then
    Begin
      For ParamLoop := FirstParam to ParamCount do
        ParamArr := ParamArr + ParamStr( ParamLoop );
      ParamArr := ParamArr + ^X;
      For ParamLoop := 1 to Length( ParamArr ) do
        ParamArr[ ParamLoop ] := UpCase( ParamArr[ ParamLoop ] );
    End;

  ReDraw := ParamCount = 0;
  Repeat
    If ReDraw Then
      Begin
        Window( 1, 1, 80, 25 );
        NormVideo;  ClrScr;  ReDraw := False;
        Writeln;  Writeln( 'Press a letter to play a sound:' );
        ShowChoice( #0, True );
        NormVideo;  GotoXY( 1, LastY + 2 );
        Write( '>>> Press Ctrl-X to exit   --',
               '  Ctrl-R for repeat game <<<' );
      End;
    If ParamArr = '' Then
      MenuCh := UpCase( ReadKey )
    Else
      Begin
        MenuCh := ParamArr[ 1 ];
        Delete( ParamArr, 1, 1 );
      End;
    If ParamCount = 0 Then
      If ( MenuCh <> ^X ) and ( MenuCh <> ^R ) Then
        ShowChoice( MenuCh, True );
    Found := True;
    Case MenuCh of
      'A': Beep( 262, 300 );
      'B': Beep( 294, 300 );
      'C': Beep( 330, 300 );
      'D': Beep( 349, 300 );
      'E': Beep( 392, 300 );
      'F': Beep( 440, 300 );
      'G': Beep( 494, 300 );
      'H': Enter;
      'I': Okay;
      'J': Zoop;
      'K': Oop;
      'L': Siren;
      'M': DoubleSiren;
      'N': Di;
      'O': ExcuseMe;
      'P': Chromatic;
      'Q': Whoop( 2000, True );
      'R': Whoop( 2000, False );
      'S': Boop( 2000 );
      'T': Chirp( 2000 );
      'U': Razz( 2000 );
      'V': Arpeggio( 2000 );
      'W': Birthday;
      'X': Charge;
      'Y': Drill;
      'Z': NoKay;
      '1': Boom;
      '2': Fall;
      '3': Bomb;
      '4': ChooChoo;
      '5': PeepPeep;
      '6': Shot;
      '7': TommyGun;
      '8': LaserGun;
      '9': PhaserGun;
      '0': SonicGun;
      '-': Claxon;
      '=': Bleep;
      '/': Continue;
      '[': Dit;
      ']': DeeDee;
      '\': Doo;
      ^X : Begin
             Found := False;
             If ParamCount = 0 Then
               Begin
                 GotoXY( 1, LastY + 2 );  ClrEol;
               End;
           End;
      ^R : Begin
             Found := True;  ReDraw := True;
             If ParamName = '' Then
               Begin
                 ClrScr;  Writeln;
                 Write( 'Please enter your initials > ' );
                 ReadLn( ParamName );
               End;
             PlayRepeat;
           End;
     Else Found := False;
    End;
    If ( ParamCount <> 0 ) and ( not Found ) Then
      Delay( 300 );
    While EatKys and KeyPressed do EatKey := ReadKey;
    If ( ParamCount = 0 ) and Found and
       ( MenuCh <> ^R ) and ( MenuCh <> ^X ) Then
      ShowChoice( MenuCh, False );
  Until MenuCh = ^X;

  NoSound;

End.




