{$A+,B-,D-,E-,F-,I-,L-,N-,O-,R-,S-,V-}
{$M 1024,0,0}

Uses Dos;

Const
  NewVec : Byte = $80;
  OldVec = $16;  { bios kbd }
  HotKey : Word = $1400;
  HotKeyChar : Char = 'T';
  AltKeys : String[72] =
   'A'#30'B'#48'C'#46'D'#32'E'#18'F'#33'G'#34'H'#35'I'#23'J'#36 +
   'K'#37'L'#38'M'#50'N'#49'O'#24'P'#25'Q'#16'R'#19'S'#31'T'#20 +
   'U'#22'V'#47'W'#17'X'#45'Y'#21'Z'#44'1'#120'2'#121'3'#122 +
   '4'#123'5'#124'6'#125'7'#126'8'#127'9'#128'0'#129;
  CpyRt : String[ 26 ] =   { encoded '(C) Andrew Bedno - Chicago' }
      #168#155#102#119#161#173#118#142#115#146#41#162#163#127#138#129 +
      #49#141#115#163#165#129#122#126#134#136;
  CpyRtLp : Byte = 1;

Var
  ScrnFile : File;
  Regs : Registers;
  Result, Loop, Row, CloseResult : Integer;
  VLoop : Byte;
  Ch, MenuCh : Char;
  VAddr, VOfs : Word;
  VecAddr : Pointer;
  SaveLn : Array [ 0..159 ] of Byte;
  WorkLn : String[82];
  FileName : String[60];

Procedure VWrite;
  Begin
    For VLoop := 1 to 80 do
      Begin
        If VLoop > Length( WorkLn ) Then
          Mem[ VAddr : ( VLoop - 1 ) * 2 ] := 32
        Else
          Mem[ VAddr : ( VLoop - 1 ) * 2 ] := Ord( WorkLn[ VLoop ] );
        Mem[ VAddr : ( VLoop - 1 ) * 2 + 1 ] := $70;
      End;
  End;

Procedure TsrEntry( Flags, CS, IP,
                    AX, BX, CX, DX, SI, DI, DS, ES, BP : Word );
  Interrupt;
  Begin
    If ( AX = $FFFF ) and 
       ( CX = Ord( 'T' ) ) and ( DX = Ord( 'G' ) ) Then
      Begin
        CX := $ABCD;  { residency check }
        SI := Ord( HotKeyChar );
      End
    Else
      Begin
        { get a keypress }
        Regs.AX := AX;  Regs.BX := BX;  Regs.CX := CX;  Regs.DX := DX;
        Regs.BP := BP;  Regs.SI := SI;  Regs.DI := DI;
        Regs.DS := DS;  Regs.ES := ES;  Regs.Flags := Flags;
        Intr( NewVec, Regs );
        If ( AX and $FF00 = 0 ) and ( Regs.AX = HotKey ) Then
          Begin  { hot key }
            If Mem[ $40 : $49 ] = $07 Then  { get video mode }
              VAddr := $B000       { mono }
            Else
              If Mem[ $40 : $49 ] < 4 Then
                VAddr := $B800     { color }
              Else
                VAddr := 0;        { graphics }
            If VAddr > 0 Then
              Repeat  { hotkey restart }
                Result := 0;
                { save current top line }
                Move( Mem[ VAddr : $0000 ], SaveLn, 160 );
                { display choices }
                WorkLn := 'Select:  <W>=Write screen with attributes' +
                          '  <S>=Save screen as text  <ESC>=Quit';
                VWrite;
                Repeat
                  Regs.AX := 0;  Intr( NewVec, Regs );
                  MenuCh := UpCase( Chr( Regs.AL ) );
                  If ( MenuCh <> 'W' ) and ( MenuCh <> 'S' ) and
                     ( MenuCh <> #27 ) Then
                    Write( ^G );
                Until ( MenuCh = 'W' ) or ( MenuCh = 'S' ) or ( MenuCh = #27 );
                If MenuCh <> #27 Then
                  Begin  { not quit }
                    If MenuCh = 'W' Then
                      WorkLn := '<Write>'
                    Else
                      WorkLn := '<Save> ';
                    WorkLn := WorkLn + '  Enter file name: ';
                    VWrite;
                    Repeat
                      Regs.AX := 0;
                      Intr( NewVec, Regs );
                      Ch := UpCase( Chr( Regs.AL ) );
                      If ( Ch >= ' ' ) and ( Ch <= '~' ) Then
                        WorkLn := WorkLn + Ch;
                      If ( Ch = ^H ) and ( Length( WorkLn ) > 26 ) Then
                        WorkLn[ 0 ] := Chr( Ord( WorkLn[ 0 ] ) - 1 );
                      VWrite;
                    Until ( Ch = #13 ) or ( Ch = #27 ) or
                          ( Length( WorkLn ) > 75 );
                    If Ch = #27 Then
                      FileName := ''
                    Else
                      FileName := Copy( WorkLn, 27, 255 );
                    If FileName <> '' Then
                      Begin  { name entered }
                        Assign( ScrnFile, FileName );
                        Reset( ScrnFile, 1 );  Result := IOResult;
                        Close( ScrnFile );  CloseResult := IOResult;
                        If Result = 0 Then
                          Begin  { overwrite }
                            WorkLn := 'File exists.  Overwrite? <Y>/<N>';
                            VWrite;
                            Repeat
                              Regs.AX := 0;  Intr( NewVec, Regs );
                              Ch := UpCase( Chr( Regs.AL ) );
                              If ( Ch <> 'Y' ) and ( Ch <> 'N' ) Then
                                Write( ^G );
                            Until ( Ch = 'Y' ) or ( Ch = 'N' );
                          End  { overwrite }
                        Else
                          Ch := 'Y';
                        If Ch = 'Y' Then
                          Begin  { procede }
                            ReWrite( ScrnFile, 1 );  Result := IOResult;
                            If MenuCh = 'W' Then
                              Begin  { write }
                                WorkLn := 'Writing . . .';  VWrite;
                                Row := 1;
                                While ( Row <= 25 ) and ( Result = 0 ) do
                                  Begin  { row }
                                    VOfs := ( Row - 1 ) * 160;
                                    If Row = 1 Then
                                      BlockWrite( ScrnFile, SaveLn, 160 )
                                    Else
                                      BlockWrite( ScrnFile,
                                                  Mem[ VAddr : VOfs ], 160 );
                                    Result := IOResult;
                                    Inc( Row );
                                  End;
                              End  { write }
                            Else
                              Begin  { save }
                                WorkLn := 'Saving . . .';  VWrite;
                                Row := 1;
                                While ( Row <= 25 ) and ( Result = 0 ) do
                                  Begin  { row }
                                    Loop := 1;
                                    If Row = 1 Then
                                      For Loop := 1 to 80 do
                                        WorkLn[ Loop ] :=
                                          Chr( SaveLn[ ( Loop - 1 ) * 2 ] )
                                    Else
                                      For Loop := 1 to 80 do
                                        Begin
                                          VOfs := ( Loop - 1 ) * 2 +
                                                  ( Row - 1 ) * 160;
                                          WorkLn[ Loop ] :=
                                            Chr( Mem[ VAddr : VOfs ] );
                                        End;
                                    Loop := 80;
                                    While ( Loop > 0 ) and
                                          ( ( WorkLn[ Loop ] = ' ' ) or
                                            ( WorkLn[ Loop ] = #255 ) ) do
                                      Dec( Loop );
                                    WorkLn[ 0 ] := Chr( Loop + 2 );
                                    WorkLn[ Loop + 1 ] := #13;
                                    WorkLn[ Loop + 2 ] := #10;
                                    Loop := 1;
                                    While ( Loop <= Length( WorkLn ) ) and
                                          ( Result = 0 ) do
                                      Begin  { loop }
                                        Ch := WorkLn[ Loop ];
                                        BlockWrite( ScrnFile, Ch, 1 );
                                        Result := IOResult;
                                        Inc( Loop );
                                      End;  { loop }
                                    Inc( Row );
                                  End;  { row }
                              End;  { save }
                            Close( ScrnFile );  CloseResult := IOResult;
                            If Result = 0 Then Result := CloseResult;
                            If Result <> 0 Then
                              Begin
                                Str( Result, WorkLn );
                                WorkLn := 'Disk error ' + WorkLn +
                                          '.   *** PRESS ANY KEY ***';
                                VWrite;
                                Regs.AH := 0;  Intr( NewVec, Regs );
                              End;
                          End;  { procede }
                      End;  { name entered }
                  End;  { not quit }
                { restore current top line }
                If VAddr > 0 Then  { text mode }
                  Move( SaveLn, Mem[ VAddr : $0000 ], 160 );
              { call displaced keyboard routine }
                Regs.AX := AX;  Regs.BX := BX;  Regs.CX := CX;
                Regs.DX := DX;
                Regs.BP := BP;  Regs.SI := SI;  Regs.DI := DI;
                Regs.DS := DS;  Regs.ES := ES;  Regs.Flags := Flags;
                Intr( NewVec, Regs );
              Until Regs.AX <> HotKey;  { hotkey restart }
          End;  { hot key }
        AX := Regs.AX;  BX := Regs.BX;  CX := Regs.CX;  DX := Regs.DX;
        BP := Regs.BP;  SI := Regs.SI;  DI := Regs.DI;
        DS := Regs.DS;  ES := Regs.ES;  Flags := Regs.Flags;
      End;  { not a residency check }
  End;

{------------------------------------------------------------------------}

Begin

  { check if help requested }
  If ParamCount > 0 Then
    If ( ParamStr( 1 ) = '?' ) or ( ParamCount > 1 ) Then
      Begin  { help }
        For CpyRtLp := 1 to 26 do
          If CpyRtLp = 1 Then
            CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 )
          Else
            CpyRt[ CpyRtLp ] := Chr( Ord( CpyRt[ CpyRtLp ] ) - 128 +
                                     Ord( CpyRt[ CpyRtLp - 1 ] ) );
        Writeln( 'TGRAB ver 3.1 rev 91/06/29 - ', CpyRt, '.' );
        Writeln( 'Resident text screen capture.' );
        Writeln( '  Capture or load screen as array or text.' );
        Writeln( 'TGRAB [c]' );
        Writeln( '  c    Specify Alt-hot key 0..9, A..Z (default T).' );
        Writeln( 'TGRAB [fn]' );
        Writeln( '  fn   Load screen file fn.  Don''t make resident.' );
        Writeln( 'Once activated:' );
        Writeln( '  W    Write entire screen including attributes.' );
        Writeln( '  S    Save screen as text file.' );
        Halt( 1 );
      End  { help }
    Else
      Begin  { other parameters }
        If Length( ParamStr( 1 ) ) > 1 Then
          Begin  { load }
            Assign( ScrnFile, ParamStr( 1 ) );
            Reset( ScrnFile, 1 );  Result := IOResult;
            If Result = 0 Then
              Begin
                If FileSize( ScrnFile ) = 4000 Then
                  Begin  { w/ attr }
                    If Mem[ $40 : $49 ] = $07 Then  { get video mode }
                      VAddr := $B000       { mono }
                    Else
                      If Mem[ $40 : $49 ] < 4 Then
                        VAddr := $B800     { color }
                      Else
                        VAddr := 0;        { graphics }
                    If VAddr <> 0 Then
                      Begin  { text mode }
                        Row := 1;
                        While ( Row <= 25 ) and ( Result = 0 ) do
                          Begin  { row }
                            VOfs := ( Row - 1 ) * 160;
                            BlockRead( ScrnFile,
                                       Mem[ VAddr : VOfs ], 160 );
                            Result := IOResult;
                            Inc( Row );
                          End;
                      End;  { text mode }
                  End  { w/ attr }
                Else
                  Begin  { text }
                    Ch := #0;
                    Repeat
                      If Ch = #10 Then Writeln;
                      BlockRead( ScrnFile, Ch, 1 );
                      Result := IOResult;
                      If ( Ch <> #13 ) and ( Ch <> #10 ) Then
                        Write( Ch );
                    Until ( Result <> 0 ) or EOF( ScrnFile );
                  End;  { text }
              End;
            If Result <> 0 Then
              Begin
                If Result = 2 Then
                  Writeln( 'File not found.' )
                Else
                  Writeln( 'Disk error ', Result, '.   Cannot load.' );
                Halt( 1 );
              End;
            Halt;
          End  { load }
        Else
          Begin  { hot key }
            WorkLn := ParamStr( 1 );
            Ch := WorkLn[ 1 ];
            HotKeyChar := UpCase( Ch );
            For Loop := 1 to 36 do
              If AltKeys[ Loop * 2 - 1 ] = HotKeyChar Then
                HotKey := Ord( AltKeys[ Loop * 2 ] ) shl 8;
            If HotKey = $1400 Then HotKeyChar := 'T';
          End;  { hot key }
      End;  { other parameters }

  { check if already resident }
  Regs.AX := $FFFF;
  Regs.CX := Ord( 'T' );  Regs.DX := Ord( 'G' );
  Intr( OldVec, Regs );
  If Regs.CX = $ABCD Then
    Begin
      { show already loaded message }
      Writeln( 'TGRAB already loaded.  Use Alt-', Chr( Regs.SI ), '.' );
      Halt( 1 );
    End;

  { find a free vector }
  NewVec := $7F;
  Repeat
    Inc( NewVec );
    GetIntVec( NewVec, VecAddr );  { get vector }
  Until ( VecAddr = Nil ) or ( NewVec = $F0 );
  If NewVec = $F0 Then
    Begin
      Writeln( 'No free vector.' );
      Halt( 1 );
    End;

  { get current address of vector to be displaced }
  GetIntVec( OldVec, VecAddr );

  { copy it to new vector }
  SetIntVec( NewVec, VecAddr );

  { replace original with new address }
  {$F+}  VecAddr := @TsrEntry;  {$F-}
  SetIntVec( OldVec, VecAddr );

  { show now loaded message }
  Writeln( 'TGRAB loaded.  Alt-', HotKeyChar, ' activates.' );

  { exit but keep resident }
  Keep( 0 );

End.


